
unit HIAVerifyPatient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, Buttons, Fmcntrls,Grids,
  CCOWRPCBrokerCAPRI, ComCtrls, StrUtils, printers, Types,Math, QuickRpt,
  MFunStr, VA508AccessibilityManager;

type
  Tfrmhiaverifypatientlist = class(TForm)
    menuhiaVeryPatientList: TMainMenu;
    fil1: TMenuItem;
    Print1: TMenuItem;
    Exit1: TMenuItem;
    Process1: TMenuItem;
    pnlhia1: TPanel;
    opndlgSelecthiaPatientListFile: TOpenDialog;
    Import1: TMenuItem;
    Export1: TMenuItem;
    rchedtMVIResilts: TRichEdit;
    displayResultsStrGrid: TStringGrid;
    PrinterSetupDialog1: TPrinterSetupDialog;
    pnlhiaSelectFile: TPanel;
    lblhiaPatientLstSelect: TLabel;
    lblSelecthiapatientList: TLabel;
    BitBtnhiaSelectFile: TBitBtn;
    BitBtnCanCel: TBitBtn;
    BitBtnhiaVerify: TBitBtn;
    gbLegend: TGroupBox;
    SveDlgStrGrd: TSaveDialog;
    edProgress: TEdit;
    edSelectedFile: TEdit;
    edLegend: TEdit;
    lbDisplay508Results: TListBox;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure BitBtnhiaVerifyClick(Sender: TObject);
    procedure FopatientrmShow(Sender: TObject);
    procedure BitBtnhiaSelectFileClick(Sender: TObject);
    procedure CreateCSVWorkArea(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Print1Click(Sender: TObject);
    procedure Import1Click(Sender: TObject);
    procedure Export1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure fil1Click(Sender: TObject);
    procedure Process1Click(Sender: TObject);
  private
   var
    multiArrayBaseR, multiArrayBaseC: integer;
    SelectFilePthNm: String;
    { Private declarations }
    RestrictedListLstBox: TListBox;
    RestrictedListStrGrd: TStringGrid;
    Lastpath: String;
    function  LoadCVStoMemory(PathandFile: String): Boolean;
    procedure ParseRecord(sRecord: string; Row: integer);
    procedure ParseRecordMVIResults(sRecord: string; Row: integer;MVILocateVal: string);
    function  ReFormatDT(OrigDate: String): String;
    procedure WriteToMultiArry(MVIRptData: String; ExpandArray: Boolean; Row: integer; Col: integer);
    procedure ReadAllOfMultiArry;
    procedure UpdateMultiArryRecdCnts(TotalNumRec: integer; Valid: integer; Invalid: integer; Multi: integer; MultiPls: integer);
    procedure InitMultiArray;
    procedure UpdateHIACVSandSave(PathandFile: String);
    Procedure ParseContactLnFnMn(origNm: String; Var Fn, Ln, Mn: String);
    Procedure ResetGridandArray;
    procedure Load508DisplayResults;
  public
    { Public declarations }
    procedure DeterminePageBreaks(const ItemSizes: TIntegerDynArray;
                const ContainerSize: Integer;
                out FirstItemsInPages: TIntegerDynArray;
                out LastItemsInPages: TIntegerDynArray);
   procedure PrintStringGrid(const StringGrid: TStringGrid;
                          const Orientation: TPrinterOrientation;
                          const Title: String);
  end;


var
  frmhiaverifypatientlist: Tfrmhiaverifypatientlist;
  FormCaption: String;
  ArryMVIDsplyRslt: array of array of String; //Multi Demi array will contain data to generate formatted results.


implementation

Uses
Main,
CAPRISupport,
dialogscapri,
VAUtils;


{$R *.dfm}

procedure Tfrmhiaverifypatientlist.BitBtnhiaSelectFileClick(Sender: TObject);
begin
  //******User selects Restricted List to be verified****
  With opndlgSelecthiaPatientListFile do
  begin
    Filter := 'Comma-Separated (*.csv)|*.csv';
    DefaultExt := 'csv';
    InitialDir := LastPath;
    Filename := '';
    if execute then
    begin
      Lastpath := getCurrentdir();
      InitialDir := LastPath;
      SelectFilePthNm := Lastpath + '\' + ExtractFileName(opndlgSelecthiaPatientListFile.Files[0]);
      edSelectedFile.Text := SelectFilePthNm;
      //** call this function to remove Double quotes and replace with single
      //** Then load to Dynamic StringGrid RestrictedListStrGrd

      ResetGridAndArray;
      LoadCVStoMemory(SelectFilePthNm);

      RestrictedListStrGrd.Visible:=False;
      if True then
        BitBtnhiaVerify.Enabled := True
      else
        BitBtnhiaVerify.Enabled := False;
      frmhiaverifypatientlist.Refresh;
    end;
  end;
end;

procedure Tfrmhiaverifypatientlist.BitBtnhiaVerifyClick(Sender: TObject);
var
  tempServer: String;
  tempPort: integer;
  i: integer;
  x: integer;
  MVIinput: String;
  MVIDsplayRpt1: String;
  ColIndexFulNm: integer;
  ColIndexSSN: integer;
  ColIndexDOB: integer;
  RowIndex: integer;
  Fname,Lname,Mname: String;
  MVIRTNInfoRec: String;
  MVIRTNRecCnt: integer;
  MVIRTNMssg: String;
  MVIValidate: String;
  SSNInteger: integer;
  SSNFrmt: String;
  CntOfAllRec: integer;
  CntOfValidRec: integer;
  CntofInValidRec: integer;
  CntofMulitRec: integer;
  CntofMulitPlsRec: integer;
  PathPrt1, PathPrt2: String;
  processCount: Integer;
  PreviousTimeoutTimerState : Boolean;
begin
  tempPort:=0;
  processCount := 0;
  PreviousTimeoutTimerState := frmMain.TimeoutTimer.Enabled;

  if VAUtils.ScreenReaderActive then   //508 compliance
    edProgress.SetFocus;

  try {outer try...finally}
    tempServer := frmMain.RPCBroker1.Server;
    tempPort := frmMain.RPCBroker1.ListenerPort;
    frmMain.RPCBroker1.Connected := False;
    frmMain.RPCBroker1.Server := HomeServer;
    frmMain.RPCBroker1.ListenerPort := StrToInt(HomePort);
    frmMain.ConnectToServer('DVBA CAPRI GUI');

    //Shutdown timeout timer during file processing
    PreviousTimeoutTimerState := frmMain.TimeoutTimer.Enabled;
    frmMain.TimeoutTimer.Enabled := False;

    //Sent request to MVI - mnj - 08/2012
    //MVIimput:= 'FORTH^TESTMID^EZTESTALIAS^111905454^2800101^';//+
    //MVIimput:= 'CAPRI^TEST^PATIENT^999999999^2540101';

    //****** Read CSV File And Extract Name, SSN and DOB if available ******
    BitBtnhiaVerify.Enabled:=False;
    ColIndexFulNm:=0;
    ColIndexSSN:= 1;
    ColIndexDOB:= 2;
    CntOfAllRec:=RestrictedListLstBox.Items.Count - 1;
    CntOfValidRec:=0;
    CntofInValidRec:=0;
    CntofMulitRec:= 0;
    CntofMulitPlsRec:= 0;

    frmhiaverifypatientlist.Refresh;

    //Clear Grid and Array
    ResetGridandArray;
    InitMultiArray; //Establish base colunms and rows and Fill

    rchedtMVIResilts.Lines.Add(inttoStr(RestrictedListStrGrd.ColCount));
    for I := 0 to  RestrictedListStrGrd.RowCount - 2 do  // minus 2 from rowcount to account for skipping Fields Record
    begin
      processCount := processCount + 1;
      edProgress.Text := 'Validating record ' + IntToStr(processCount) + ' of ' + IntToStr(CntOfAllRec);
      Application.ProcessMessages;
      RowIndex:= I+1;
      MVIinput:='';
      MVIDsplayRpt1:='';
      Fname:='';
      Lname:='';
      Mname:='';

      ParseContactLnFnMn(RestrictedListStrGrd.Cells[ColIndexFulNm,RowIndex],
                             Fname, Lname, Mname);

      MVIDsplayRpt1:= Fname+ ' '+ //Fname
                      Mname+' '+ //MidName
                      Lname+' '+   //Lname
                      RestrictedListStrGrd.Cells[ColIndexSSN,RowIndex]+' '+    //SSN
                      RestrictedListStrGrd.Cells[ColIndexDOB,RowIndex];       //DOB

      //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
      //Concatenated Lname. Fname. Mname, Set True to add new row, Locates last row index,
      // Column to insert value assoc with Row.
      WriteToMultiArry(Lname+','+Fname+' '+Mname,True,(high(ArryMVIDsplyRslt)+1),1);

      //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
      //Write SSN, Set False to not create a new row, Locates last row index,
      // Column to insert value assoc with Row.
      SSNInteger:=Strtoint(RestrictedListStrGrd.Cells[ColIndexSSN,RowIndex]);
      SSNFrmt:=Format('%.9d',[SSNInteger]);
      WriteToMultiArry(SSNFrmt,False,high(ArryMVIDsplyRslt),2);

      //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
      //Write DOB, Set False to not create a new row, Locates last row index,
      // Column to insert value assoc with Row.
      WriteToMultiArry(RestrictedListStrGrd.Cells[ColIndexDOB,RowIndex],
                        False,high(ArryMVIDsplyRslt),3);

      MVIinput:= Fname+ '^'+ //Fname
                 Mname+'^'+ //MidName
                 Lname+'^'+   //Lname           ^
                 SSNFrmt+'^';

      //Reformat DOB date  if exists
      if Trim(RestrictedListStrGrd.Cells[ColIndexDOB,RowIndex]) <> '' then
      begin
        MVIinput:=MVIinput +
            FMToDateConvert(ReFormatDT(RestrictedListStrGrd.Cells[ColIndexDOB,RowIndex]));
      end
      else
      begin
        MVIinput:=MVIinput+'^';
      end;


      try  //start of try...except
        if CallRPC(frmMain.RPCBroker1, 'DVBA MVI SEARCH PERSON', [MVIinput,'1','1'], nil) and (frmMain.RPCBroker1.Results.Count > 0)  then
        begin
          if frmMain.RPCBroker1.Results[0] <> '' then
          begin
            MVIRTNInfoRec:=frmMain.RPCBroker1.Results[0];
            MVIRTNRecCnt:= StrtoInt(Piece(MVIRTNInfoRec, '^', 1));
            MVIRTNMssg:= Piece(MVIRTNInfoRec, '^', 2);
            if (MVIRTNMssg <> 'Acknowledgement Error: [RTE]Can&apos;t Filter Query:') then
              if (MVIRTNMssg <> 'Communication error occurred') then
              begin
                if (MVIRTNRecCnt = 0) and (POS('More',MVIRTNMssg) <> 1) then //Patient Not In MVI
                Begin
                  //***insert value 'N' in Column Validated.****************************
                  RestrictedListStrGrd.Cells[RestrictedListStrGrd.ColCount, RowIndex]:= 'N';
                  CntOfInValidRec:=CntOfInValidRec+1;
                  //***********************************************************************
                End
                Else if MVIRTNRecCnt = 1 then  //Patient Found In MVI
                Begin
                  //***insert value 'Y' in Column Validated.****************************
                  RestrictedListStrGrd.Cells[RestrictedListStrGrd.ColCount, RowIndex]:= 'Y';
                  CntOfValidRec:=CntOfValidRec+1;
                  //***********************************************************************
                end
                Else if (MVIRTNRecCnt > 1) and (MVIRTNRecCnt <=10)  then
                Begin
                  //***insert value 'M' in Column Validated, Result found 2 to 10 Records
                  RestrictedListStrGrd.Cells[RestrictedListStrGrd.ColCount, RowIndex]:= 'M';
                  CntofMulitRec:=CntofMulitRec+1;
                  //***********************************************************************
                end
                Else
                Begin
                  //***insert value 'Y' in Column Validated, Result found More than 10 Records
                  RestrictedListStrGrd.Cells[RestrictedListStrGrd.ColCount, RowIndex]:= 'M+';
                  CntofMulitPlsRec:=CntofMulitPlsRec+1;
                  //***********************************************************************
                end;

                MVIValidate:= RestrictedListStrGrd.Cells[RestrictedListStrGrd.ColCount, RowIndex];
                MVIDsplayRpt1:=MVIDsplayRpt1+','+ MVIValidate;

                if(MVIRTNRecCnt >=1) then  //****Write detail result from MVI****
                begin
                  for x := 1 to MVIRTNRecCnt do
                  begin
                    //Parse results from MVI and Write to Multi Dim Array
                    ParseRecordMVIResults(frmMain.RPCBroker1.Results[x],MVIRTNRecCnt,MVIValidate);
                  end;
                end; //end if MVIRTNRecCnt >=1 then Write detail result from MVI

                if(MVIRTNRecCnt = 0) then  //****No Record Found Write status Ind "N"****
                begin
                  //Parse results from MVI and Write to Multi Dim Array
                  ParseRecordMVIResults(frmMain.RPCBroker1.Results[0],0,MVIValidate);
                end;

              end //if MVIRTNMssg <> 'Acknowledgement Error: [RTE]Can&apos;t Filter Query:' then
              else
              begin
                displayResultsStrGrid.Visible:=False;
                edSelectedFile.Text := '';
                BitBtnhiaVerify.Enabled:=False;
                ShowMessageCAPRI('Web service call failed.' + #10#13
                               + 'Cause: ' + MVIRTNMssg + #10#13
                               + 'Input Record: ' + MVIInput);
                Application.ProcessMessages;
                Exit;
              end;
          end; //end of - if frmMain.RPCBroker1.Results[0] <> '' then
        end;  //End of if CallRPC()

      except on e:exception do
        begin
          displayResultsStrGrid.Visible:=False;
          edSelectedFile.Text := '';
          //mnoSelecthiaPatientList.Lines.Clear;
          BitBtnhiaVerify.Enabled:=False;
          ShowMessageCAPRI('Error executing HIA Search.  Please try again.');
          Application.ProcessMessages;
          Exit;
        end;
      end; //inner try...except
    End; // End outer for I loop

    //Update Default Recount types AllRec, VaildRec, InvalidRec, MultiRec, More Then 10
    UpdateMultiArryRecdCnts(CntOfAllRec,CntOfValidRec,CntofInValidRec,CntofMulitRec,
                                  CntofMulitPlsRec);

    //Write values in Multi Dim Array to  rchedtMVIResilts
    edProgress.Text := 'Validation Complete';
    ReadAllOfMultiArry;
    displayResultsStrGrid.Rows[0].Add('Date: '+ DateToStr(Date));
    displayResultsStrGrid.Visible:=True;
    BitBtnhiaVerify.Enabled:=True;
    frmhiaverifypatientlist.Refresh;

    PathPrt1:= Copy(SelectFilePthNm,1,(Pos('.',SelectFilePthNm)-1));
    PathPrt2:= '.'+FormatDateTime('mmddyyyhhnnss',Now())+'.csv';

    UpdateHIACVSandSave(PathPrt1+PathPrt2);

    if VAUtils.ScreenReaderActive then   //508 compliance
      Load508DisplayResults;  //use listbox for display instead of string grid

  finally {outer try...finally}
    frmMain.TimeoutTimer.Enabled := PreviousTimeoutTimerState;  //restore previous timer state
    frmMain.RPCBroker1.Connected := False;
    frmMain.RPCBroker1.Server := TempServer;
    frmMain.RPCBroker1.ListenerPort := TempPort;
    frmMain.ConnectToServer('DVBA CAPRI GUI');
  end; {outer try...finally}
end;

procedure Tfrmhiaverifypatientlist.CreateCSVWorkArea(Sender: TObject);
begin
  //**** Create Dymanic TstringListBox to load CVS File
  RestrictedListLstBox:= TListBox.Create(Self);
  RestrictedListLstBox.Parent := self;
  RestrictedListLstBox.Visible:= False;
  //**Create Dymanic StringGrid
  RestrictedListStrGrd:=TStringGrid.Create(Self);
  RestrictedListStrGrd.Parent := Self;
  RestrictedListStrGrd.Visible:=False;
  RestrictedListStrGrd.ColCount:=1;
  InitMultiArray; //Establish base colunms and rows and Fill
end;

procedure Tfrmhiaverifypatientlist.DeterminePageBreaks(
  const ItemSizes: TIntegerDynArray; const ContainerSize: Integer;
  out FirstItemsInPages, LastItemsInPages: TIntegerDynArray);
var
  SpaceRemaining: Integer;
  I: Integer;
  PageCount: Integer;

begin
  SpaceRemaining := 0;
  PageCount := 0;

  for I := 1 to High(ItemSizes) do
  begin
    if (SpaceRemaining >= ItemSizes[I]) then
      Dec(SpaceRemaining, ItemSizes[I])
    else
      begin
      Inc(PageCount);
      SpaceRemaining := ContainerSize - ItemSizes[I];
      SetLength(FirstItemsInPages, PageCount);
      SetLength(LastItemsInPages, PageCount);
      FirstItemsInPages[PageCount - 1] := I;
      end;

    LastItemsInPages[PageCount - 1] := I;
  end;
end;
procedure Tfrmhiaverifypatientlist.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure Tfrmhiaverifypatientlist.Export1Click(Sender: TObject);
Var
  CSV: TStrings;
  i: Integer;
  ExprtPthFn:string;
begin
  //displayResultsStrGrid
  With SveDlgStrGrd do
  Begin
    Filter := 'Comma-Separated (*.csv)|*.csv';
    DefaultExt := 'csv';
    InitialDir := LastPath;

    Filename := 'HIAResult'+FormatDateTime('mmddyyyhhnnss',Now())+'.csv';
    if Execute then
    begin
      Lastpath := getCurrentdir();
      InitialDir := LastPath;
      ExprtPthFn := InitialDir + '\' +ExtractFileName(FileName);
      CSV := TStringList.Create;

      Try
        CSV.Add(',,"HIA Search Result"');
        CSV.Add(' ');
        For i := 0 To displayResultsStrGrid.RowCount - 1 Do
          CSV.Add(displayResultsStrGrid.Rows[i].CommaText);

        CSV.SaveToFile(ExprtPthFn);
      Finally
        CSV.Free;
      End;
    end;//End of if SveDlgStrGrd.Execute
  End;
end;

procedure Tfrmhiaverifypatientlist.fil1Click(Sender: TObject);
begin
  if displayResultsStrGrid.RowCount <=4 then
    Print1.Enabled:=False
  else
    Print1.Enabled:=True;
  frmhiaverifypatientlist.Refresh;
end;

procedure Tfrmhiaverifypatientlist.FopatientrmShow(Sender: TObject);
begin
  Caption:= 'HIA Search - Patient Restricted List';
  Lastpath:=getCurrentdir();
end;

procedure Tfrmhiaverifypatientlist.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RestrictedListLstBox.Free;
  RestrictedListStrGrd.Free;
  Finalize(ArryMVIDsplyRslt);
end;

procedure Tfrmhiaverifypatientlist.FormCreate(Sender: TObject);
begin
  CreateCSVWorkArea(Sender);
  
  if VAUtils.ScreenReaderActive then   //508 compliance
  begin
    gbLegend.TabStop := True;
    edProgress.TabStop := True;
    edLegend.TabStop := True;
    lbDisplay508Results.TabStop := True;
    DisplayResultsStrGrid.TabStop := False;
  end
  else
  begin
    gbLegend.TabStop := False;
    edProgress.TabStop := False;
    edLegend.TabStop := False;
    lbDisplay508Results.TabStop := False;
    DisplayResultsStrGrid.TabStop := True;
  end;
end;

procedure Tfrmhiaverifypatientlist.Import1Click(Sender: TObject);
begin
  BitBtnhiaSelectFileClick(self);
end;

procedure Tfrmhiaverifypatientlist.InitMultiArray;
begin
  multiArrayBaseR:=4;
  multiArrayBaseC:=8;
  SetLength(ArryMVIDsplyRslt,multiArrayBaseR,multiArrayBaseC); //Allocate Memory multi dem Array
  WriteToMultiArry('Total Count: ',False,0,0);
  WriteToMultiArry('0',False,0,1); //initial val for Total Count
  WriteToMultiArry('Valid Records: ',False,1,0);
  WriteToMultiArry('0',False,1,1); //initial val for Valid Records
  WriteToMultiArry('Invalid Records: ',False,2,0);
  WriteToMultiArry('0',False,2,1); //initial val for Invalid Records
  WriteToMultiArry('Name',False,3,1);
  WriteToMultiArry('SSN',False,3,2);
  WriteToMultiArry('DOB',False,3,3);
  WriteToMultiArry('ICN',False,3,4);
  WriteToMultiArry('Validated',False,3,0);
  WriteToMultiArry('MVI Name',False,3,5);
  WriteToMultiArry('MVI SSN',False,3,6);
  WriteToMultiArry('MVI DOB',False,3,7);

end;

{========================================================================
 Load508DisplayResults
 The TStringGrid used for display of the processed MVI results does not
 function properly with JAWS screen reader software.  This procedure
 formats the results from the TStringGrid and populates a TListBox with
 the formatted results, which can be read using a screen reader. This
 procedure is only called when a screen reader is active.
 =========================================================================}
procedure Tfrmhiaverifypatientlist.Load508DisplayResults;
var
  I: Integer;
  aFormattedLine: String;
const
  //formatted column sizes allowing 2 spaces between columns
  ValColSize = 11;
  NameColSize = 30;
  SSNColSize = 11;
  DOBColSize = 12;
  ICNColSize = 20;
  MVINameColSize = 30;
  MVISSNColSize = 11;
begin
  lbDisplay508Results.Clear;
  lbDisplay508Results.Top := DisplayResultsStrGrid.Top;
  lbDisplay508Results.Left := DisplayResultsStrGrid.Left;
  lbDisplay508Results.Height := DisplayResultsStrGrid.Height;
  lbDisplay508Results.Width := DisplayResultsStrGrid.Width;

  for I := 0 to DisplayResultsStrGrid.RowCount - 1 do
  begin
    aFormattedLine := DisplayResultsStrGrid.Cells[0, I];
    aFormattedLine := aFormattedLine + StringOfChar(' ', ValColSize - Length(DisplayResultsStrGrid.Cells[0, I])) + (DisplayResultsStrGrid.Cells[1, I]);
    aFormattedLine := aFormattedLine + StringOfChar(' ', NameColSize - Length(DisplayResultsStrGrid.Cells[1, I])) + (DisplayResultsStrGrid.Cells[2, I]);
    aFormattedLine := aFormattedLine + StringOfChar(' ', SSNColSize - Length(DisplayResultsStrGrid.Cells[2, I])) + (DisplayResultsStrGrid.Cells[3, I]);
    aFormattedLine := aFormattedLine + StringOfChar(' ', DOBColSize - Length(DisplayResultsStrGrid.Cells[3, I])) + (DisplayResultsStrGrid.Cells[4, I]);
    aFormattedLine := aFormattedLine + StringOfChar(' ', ICNColSize - Length(DisplayResultsStrGrid.Cells[4, I])) + (DisplayResultsStrGrid.Cells[5, I]);
    aFormattedLine := aFormattedLine + StringOfChar(' ', MVINameColSize - Length(DisplayResultsStrGrid.Cells[5, I])) + (DisplayResultsStrGrid.Cells[6, I]);
    aFormattedLine := aFormattedLine + StringOfChar(' ', MVISSNColSize - Length(DisplayResultsStrGrid.Cells[6, I])) + (DisplayResultsStrGrid.Cells[7, I]);
    lbDisplay508Results.Items.Add(aFOrmattedLine);
  end;
  //turn off string grid and turn on list box
  DisplayResultsStrGrid.Visible := False;
  lbDisplay508Results.Visible := True;
end;

function Tfrmhiaverifypatientlist.LoadCVStoMemory(PathandFile: String): Boolean;
var
  FileName1, sRecord: string;
  Row: integer;
begin
  //***Load ListBox object RestrictedListLstBox ****
  LoadCVStoMemory:=True;
  FileName1 := PathandFile;

  RestrictedListLstBox.Items.LoadFromFile(FileName1);  // 2.
  RestrictedListStrGrd.RowCount := RestrictedListLstBox.Items.Count;    // 3.

  // for every record... ( count starts at 0 ! )
  for Row := 0 to RestrictedListLstBox.Items.Count - 1 do begin
    sRecord := RestrictedListLstBox.Items[Row];
    ParseRecord(sRecord, Row);             // 4.
  end;

  //Insert new column "Validated" to insert values of
  // Y - when the returned MVI search results match a veteran;
  // N - when the returned MVI search results do not match a veteran.
  // M - when the returned MVI search results match a veteran with multiple entries.
  RestrictedListStrGrd.ColCount:=RestrictedListStrGrd.ColCount +1;
  RestrictedListStrGrd.Cells[RestrictedListStrGrd.ColCount, 0] := 'Validated';
end;

procedure Tfrmhiaverifypatientlist.ParseContactLnFnMn(origNm: String; var Fn, Ln, Mn: String);
var
  SpaceLocation: integer;
begin
  SpaceLocation := Pos(' ',origNm);
  Ln := Trim(Copy(origNm,1,SpaceLocation-1));
  Delete(origNm,1,SpaceLocation);
  SpaceLocation := Pos(' ',origNm);
  if SpaceLocation = 0 then  // no middle name
  begin
    Fn := Copy(origNm,1,Length(origNm));
    Mn := '';
  end
  else
  begin
    Fn := Copy(origNm,1,SpaceLocation-1);
    Delete(origNm,1,SpaceLocation-1);
    Mn := Copy(origNm,1,Length(origNm));
  end;
end;

procedure Tfrmhiaverifypatientlist.ParseRecord(sRecord: string; Row: integer);
var
  Col, PosComma: integer;
  sField: string;
begin
  Col := 0;    // first column of stringgrid
  sRecord := StringReplace(sRecord, '"', '',
                          [rfReplaceAll]    );
  if Row > 0 then
      sRecord := StringReplace(sRecord, ',', ' ',[]);

  repeat
    PosComma := Pos(',', sRecord);

    if PosComma > 0 then
      sField := Copy(sRecord, 1, PosComma - 1)
    else
      sField := sRecord;

    RestrictedListStrGrd.Cells[Col, Row] := sField;

    if PosComma > 0 then
    begin
      Delete(sRecord, 1, PosComma);
      Col := Col + 1;                           // next column
    end;
  until PosComma = 0;

  if RestrictedListStrGrd.ColCount <= Col then
     RestrictedListStrGrd.ColCount:=Col;          //Set / allocate number of columns
end;

procedure Tfrmhiaverifypatientlist.ParseRecordMVIResults(sRecord: string; Row: integer; MVILocateVal: string);
var
  FullName:String;
  SSN:String;
  DOB: String;
  ICN: String;
  MVIYorNVal:String;
  DTInteger: integer;
  DTFrmt: String;
begin
  MVIYorNVal:='';
  MVIYorNVal := MVILocateVal;

  if Row > 0 then
  begin
    FullName := Piece(sRecord,'^',1); // Full name
    SSN := Piece(sRecord, '^', 2); // SSN
    DOB := Piece(sRecord, '^', 3); // DOB
    ICN := Piece(sRecord, '^', 4);  //ICN

    //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
    // Column to insert value assoc with Row.
    WriteToMultiArry(MVIYorNVal,False,high(ArryMVIDsplyRslt),0);

    //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
    //Concatenated Lname. Fname. Mname, Set True to add new row, Locates last row index,
    // Column to insert value assoc with Row.
    WriteToMultiArry(FullName,False,high(ArryMVIDsplyRslt),5);

    //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
    //Write SSN, Set False to not create a new row, Locates last row index,
    // Column to insert value assoc with Row.
    DTInteger:=Strtoint(SSN);
    DTFrmt:=Format('%.9d',[DTInteger]);
    WriteToMultiArry(DTFrmt,False,high(ArryMVIDsplyRslt),6);

    //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
    //Write DOB, Set False to not create a new row, Locates last row index,
    // Column to insert value assoc with Row.
    WriteToMultiArry(DOB,False,high(ArryMVIDsplyRslt),7);

    //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
    //Write ICN, Set False to not create a new row, Locates last row index,
    // Column to insert value assoc with Row.
    WriteToMultiArry(ICN,False,high(ArryMVIDsplyRslt),4);

  end// if Row > 0
  else
  begin
    //***** Write value to Multi Demi Array ArryMVIDsplyRslt *******
    // Column to insert value assoc with Row.
    WriteToMultiArry(MVIYorNVal,False,high(ArryMVIDsplyRslt),0);
  end;
end;

procedure Tfrmhiaverifypatientlist.Print1Click(Sender: TObject);
begin
  with  PrinterSetupDialog1 do
  begin
    if Execute Then
      PrintStringGrid(displayResultsStrGrid,poPortrait,'HIA Search Results');
  end;
end;

procedure Tfrmhiaverifypatientlist.PrintStringGrid(
  const StringGrid: TStringGrid; const Orientation: TPrinterOrientation;
  const Title: String);
var
  I, J, X, Y: Integer;
  PageWidth, PageHeight: Integer;
  XPos, YPos: Integer;
  ColumnWidths, RowHeights: TIntegerDynArray;
  FirstColumnsInPages: TIntegerDynArray;
  LastColumnsInPages: TIntegerDynArray;
  FirstRowsInPages: TIntegerDynArray;
  LastRowsInPages: TIntegerDynArray;
  Offset: Integer;
  ColumnAlignments: TIntegerDynArray;
  PageNumber: Integer;
begin
  SetLength(ColumnAlignments, StringGrid.ColCount);

  for I := 0 to (StringGrid.ColCount - 1) do
    ColumnAlignments[I] := 2;

  Printer.Orientation := Orientation;
  Printer.Title := Title;

  printer.Canvas.Font.Name:='Times New Roman';
  printer.Canvas.Font.Size:=10;

  Printer.BeginDoc;
  try
    SetLength(ColumnWidths, StringGrid.ColCount);
    SetLength(RowHeights, StringGrid.RowCount);

    for J := 0 to (StringGrid.RowCount - 1) do
      begin
      for I := 0 to (StringGrid.ColCount - 1) do
        ColumnWidths[I] := Max(ColumnWidths[I], Printer.Canvas.TextWidth(StringGrid.Cells[I, J]));

      RowHeights[J] := Printer.Canvas.TextHeight('X');
      end;

    PageWidth := GetDeviceCaps(Printer.Canvas.Handle, HORZRES);
    PageHeight := GetDeviceCaps(Printer.Canvas.Handle, VERTRES);

    DeterminePageBreaks(ColumnWidths, PageWidth - ColumnWidths[0], FirstColumnsInPages, LastColumnsInPages);
    DeterminePageBreaks(RowHeights, PageHeight - 3 * RowHeights[0], FirstRowsInPages, LastRowsInPages);

    PageNumber := 1;

    for X := 0 to High(FirstColumnsInPages) do
      for Y := 0 to High(FirstRowsInPages) do
      begin
        if (X > 0) or (Y > 0) then
          Printer.NewPage;

        Printer.Canvas.Brush.Style := bsClear;

        Printer.Canvas.TextOut(0, 0, Title + '   Page ' + IntToStr(PageNumber) + ' of ' +
                               IntToStr(Length(FirstColumnsInPages) * Length(FirstRowsInPages)));

        // column headers
        XPos := ColumnWidths[0];
        YPos := 2 * RowHeights[0];

        J := 0;

        for I := FirstColumnsInPages[X] to LastColumnsInPages[X] do
        begin
          Printer.Canvas.Rectangle(XPos, YPos, XPos + ColumnWidths[I], YPos + RowHeights[J]);

          Offset := ColumnAlignments[I] * (ColumnWidths[I] - Printer.Canvas.TextWidth(StringGrid.Cells[I, J])) div 2;
          Printer.Canvas.TextOut(XPos + Offset, YPos, StringGrid.Cells[I, J]);
          Inc(XPos, ColumnWidths[I]);
        end;

        // row headers
        XPos := 0;
        YPos := 3 * RowHeights[0];

        I := 0;

        for J := FirstRowsInPages[Y] to LastRowsInPages[Y] do
        begin
          Printer.Canvas.Rectangle(XPos, YPos, XPos + ColumnWidths[I], YPos + RowHeights[J]);
          Offset := ColumnAlignments[I] * (ColumnWidths[I] - Printer.Canvas.TextWidth(StringGrid.Cells[I, J])) div 2;
          Printer.Canvas.TextOut(XPos + Offset, YPos, StringGrid.Cells[I, J]);
          Inc(YPos, RowHeights[J]);
        end;

        // cells
        XPos := ColumnWidths[0];

        for I := FirstColumnsInPages[X] to LastColumnsInPages[X] do
        begin
          YPos := 3 * RowHeights[0];

          for J := FirstRowsInPages[Y] to LastRowsInPages[Y] do
          begin
            Printer.Canvas.Rectangle(XPos, YPos, XPos + ColumnWidths[I], YPos + RowHeights[J]);
            Offset := ColumnAlignments[I] * (ColumnWidths[I] - Printer.Canvas.TextWidth(StringGrid.Cells[I, J])) div 2;
            Printer.Canvas.TextOut(XPos + Offset, YPos, StringGrid.Cells[I, J]);
            Inc(YPos, RowHeights[J]);
          end;

          Inc(XPos, ColumnWidths[I]);
        end;

        Inc(PageNumber);
      end;
  finally
    Printer.EndDoc;
  end;
end;


procedure Tfrmhiaverifypatientlist.Process1Click(Sender: TObject);
begin
  if displayResultsStrGrid.RowCount <=4 then
    Export1.Enabled:=False
  else
    Export1.Enabled:=True;
end;

procedure Tfrmhiaverifypatientlist.ReadAllOfMultiArry;
var
  i, x: integer;
  GetPatientRslt: String;
begin
  displayResultsStrGrid.ColCount:=multiArrayBaseC;
  displayResultsStrGrid.RowCount:=(High(ArryMVIDsplyRslt)+1);
  displayResultsStrGrid.ColWidths[0] := 100;
  displayResultsStrGrid.ColWidths[1] := 200;
  displayResultsStrGrid.ColWidths[2] := 100;
  displayResultsStrGrid.ColWidths[3] := 100;
  displayResultsStrGrid.ColWidths[4] := 150;
  displayResultsStrGrid.ColWidths[5] := 200;
  displayResultsStrGrid.ColWidths[6] := 100;
  displayResultsStrGrid.ColWidths[7] := 100;

  for i:=0 to High(ArryMVIDsplyRslt) do
  begin
    GetPatientRslt:='';
    for x:=0 to multiArrayBaseC -1 do
    Begin
      displayResultsStrGrid.Cells[x,i]:=ArryMVIDsplyRslt[i,x];
    End;
  End;
end;

function Tfrmhiaverifypatientlist.ReFormatDT(OrigDate: String): String;
var
  edtDateStr: String;
  mmStr: String;
  ddStr: String;
  yyStr: String;
  I: integer;
  fndDash: integer;
  mmNum:integer;
  mmNumStr: String;
  ShortMonthNames: ARRAY[1..12] of string;
begin
  mmStr := '';
  ddStr := '';
  yyStr := '';
  mmNum := 0;
  mmNumStr := '00';
  edtDateStr:=Trim(OrigDate);
  ShortMonthNames[1] := 'JAN';
  ShortMonthNames[2] := 'FEB';
  ShortMonthNames[3] := 'MAR';
  ShortMonthNames[4] := 'APR';
  ShortMonthNames[5] := 'MAY';
  ShortMonthNames[6] := 'JUN';
  ShortMonthNames[7] := 'JUL';
  ShortMonthNames[8] := 'AUG';
  ShortMonthNames[9] := 'SEP';
  ShortMonthNames[10] := 'OCT';
  ShortMonthNames[11] := 'NOV';
  ShortMonthNames[12] := 'DEC';

  fndDash := Pos('-',edtDateStr);
  ddStr := Copy(edtDateStr,1,(fndDash -1));
  delete(edtDateStr,1,fndDash);
  fndDash := Pos('-',edtDateStr);
  mmStr := Copy(edtDateStr,1,(fndDash -1));
  delete(edtDateStr,1,fndDash);
  yyStr := Copy(edtDateStr,1,length(edtDateStr));
  delete(edtDateStr,1,length(edtDateStr));

  if Strtoint(yyStr) <= 99 then
    yyStr := '19' + yyStr;

  //locate ansi equivlate of 3 char month and assign integer value
  for i := 1 to 12 do
    if AnsiCompareText(ShortMonthNames[i], mmStr) = 0 then
    begin
      mmNum := i;
      Break;
    end;

  ddStr := Format('%.2d',[StrToInt(ddStr)]);
  mmNumStr := Format('%.2d',[mmNum]);
  Result:= mmNumStr + '/' + ddStr + '/' + yyStr;
end;

procedure Tfrmhiaverifypatientlist.ResetGridandArray;
var
  DisRsltGrdCnt: integer;
begin
  LoadCVStoMemory(SelectFilePthNm);

  displayResultsStrGrid.Visible := False;
  Application.ProcessMessages;
  displayResultsStrGrid.Enabled := False;
  Application.ProcessMessages;

  for DisRsltGrdCnt := 0 to displayResultsStrGrid.RowCount - 1 do
  Begin
    displayResultsStrGrid.Rows[DisRsltGrdCnt].Text := '  ';
    displayResultsStrGrid.Update;
    Application.ProcessMessages;
  End;

  displayResultsStrGrid.ColCount := 8;
  displayResultsStrGrid.RowCount := 5;
  displayResultsStrGrid.FixedRows := 4;
  displayResultsStrGrid.Enabled := True;
  displayResultsStrGrid.Update;
  displayResultsStrGrid.Visible := true;
  edProgress.Text := '';
  Application.ProcessMessages;

  Finalize(ArryMVIDsplyRslt);
end;

//This procedure crates a new file containing all records from the input Patient restricted List
// and adds the flags of Y= exact match found, N = No records match, M = Mulitiple records found,
//and M+ = More that 10 records found, based on the values save in grid "displayResultsStrGrid.
// This procedure is call at the end of event procedure BitBtnhiaVerifyClick.
procedure Tfrmhiaverifypatientlist.UpdateHIACVSandSave(PathandFile: String);
var
  i, x: integer;
  ValidateVal: String;
  ICNVal: String;
  MVIName, MVISSN, MVIDOB: String;
begin

  RestrictedListLstBox.ItemIndex := 0;
  RestrictedListLstBox.Items[0] := 'Validated,ICN,'
                                    + RestrictedListLstBox.Items[0] + ','
                                    + 'MVI Name,MVI SSN,MVI DOB';

  ValidateVal := '';
  i := 1;
  //*loop here to set vaidated value for each row.
  displayResultsStrGrid.Row:=4;
  for x := 4 to displayResultsStrGrid.RowCount - 1 do
  begin
    MVIName := '';
    MVISSN := '';
    MVIDOB := '';
    ValidateVal:=displayResultsStrGrid.Cells[0,x];

    if Trim(ValidateVal) <> '' then
    begin
      if Trim(displayResultsStrGrid.Cells[4,x]) <> '' then
        ICNVal := displayResultsStrGrid.Cells[4,x]
      else
        ICNVal := '';

      if Trim(ValidateVal) = 'Y' then
      begin
        MVIName := Trim(displayResultsStrGrid.Cells[5,x]);
        MVISSN := Trim(displayResultsStrGrid.Cells[6,x]);
        MVIDOB := Trim(displayResultsStrGrid.Cells[7,x]);
      end;
      RestrictedListLstBox.Items[i]:= ValidateVal + ','
                                     + ICNVal + ','
                                     + RestrictedListLstBox.Items[i] + ','
                                     + '"'+ MVIName + '"' + ',' + MVISSN + ',' + MVIDOB;
      i:=i+1;
    end;  //end of Trim(ValidateVal) <> ''
  end; // end of outer loop - x:=4

  SetCurrentDir(ExtractFilePath(PathandFile));
  RestrictedListLstBox.Items.SaveToFile((PathandFile));
end;

procedure Tfrmhiaverifypatientlist.UpdateMultiArryRecdCnts(TotalNumRec: Integer; Valid, Invalid,
  Multi, MultiPls: integer);
begin
  //'Total Count'
  WriteToMultiArry(inttostr(TotalNumRec),False,0,1); //initial val for Total Count
  //'Valid Records'
  WriteToMultiArry(inttostr(Valid + Multi + MultiPls),False,1,1); //initial val for Valid Records
  //'Invalid Records'
  WriteToMultiArry(inttostr(INValid),False,2,1); //initial val for Invalid Records
end;

procedure Tfrmhiaverifypatientlist.WriteToMultiArry(MVIRptData: String; ExpandArray: Boolean; Row: integer; Col: integer);
var
  nexthigh: integer;
begin
  nexthigh:= high(ArryMVIDsplyRslt) + 2;
  if ExpandArray then
  Begin
    setlength(ArryMVIDsplyRslt,nexthigh,multiArrayBaseC);   //add a row to array
  End;

  ArryMVIDsplyRslt[Row,Col]:=MVIRptData; //
end;

end.
