unit QR2PDFConverter;

{
    This unit utilizes the Synopse framework to provide PDF conversion
    functionality as credited in the LICENSE BLOCK that follows.
    The PDF Engine source may be retrieved from the Synopse Open Source
    downloads web page at http://synopse.info/fossil/wiki?name=Downloads.
    The design of the ExportAsPDF procedure was copied from a forum message
    at http://synopse.info/forum/viewtopic.php?id=138.

    Synopse framework. Copyright (C) 2011 Arnaud Bouchez
      Synopse Informatique - http://synopse.info

  *** BEGIN LICENSE BLOCK *****
  Version: MPL 1.1/GPL 2.0/LGPL 2.1

  The contents of this file are subject to the Mozilla Public License Version
  1.1 (the "License"); you may not use this file except in compliance with
  the License. You may obtain a copy of the License at
  http://www.mozilla.org/MPL

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
  for the specific language governing rights and limitations under the License.

  The Original Code is Synopse framework.

  The Initial Developer of the Original Code is Arnaud Bouchez.

  Portions created by the Initial Developer are Copyright (C) 2011
  the Initial Developer. All Rights Reserved.

  Contributor(s):
  Alternatively, the contents of this file may be used under the terms of
  either the GNU General Public License Version 2 or later (the "GPL"), or
  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
  in which case the provisions of the GPL or the LGPL are applicable instead
  of those above. If you wish to allow use of your version of this file only
  under the terms of either the GPL or the LGPL, and not to allow others to
  use your version of this file under the terms of the MPL, indicate your
  decision by deleting the provisions above and replace them with the notice
  and other provisions required by the GPL or the LGPL. If you do not delete
  the provisions above, a recipient may use your version of this file under
  the terms of any one of the MPL, the GPL or the LGPL.

  ***** END LICENSE BLOCK *****
}

interface

uses
  Classes, Graphics, QuickRpt, QrPrntr, QrCtrls, SynGdiPlus,
  SynCommons, SynPdf, SysUtils, Windows;

procedure ExportAsPDF(QuickRep: TQuickRep; const aFileName: TFileName; const aFilePath: String);

implementation

procedure ExportAsPDF(QuickRep: TQuickRep; const aFileName: TFileName; const aFilePath: String);
var
  Pdf: TPdfDocument;
  aMeta: TMetaFile;
  i: integer;
begin
  Pdf := TPdfDocument.Create;
  try
    Pdf.DefaultPaperSize := psLetter;
    QuickRep.Prepare;
    for i := 1 to QuickRep.QRPrinter.PageCount do begin
      Pdf.AddPage;
      aMeta := QuickRep.QRPrinter.GetPage(i);
      try
        // draw the page content
        Pdf.Canvas.RenderMetaFile(aMeta,1,0,0);
      finally
        aMeta.Free;
      end;
    end;
    Pdf.SaveToFile(aFilePath + aFileName);
  finally
    Pdf.free;
  end;
end;


end.
