unit VocRehabPOC;
//------------------------------------------------------------------------------
// CodeCR347 - JRL June, 2012 - Added unit/form        
// Vocational Rehab Form 28-8861
//               
// This form displays the Vocational Rehab Point of Contact and is displayed
// from VocRehabMedicalRequest.pas (frmVRMedicalRequest)
//------------------------------------------------------------------------------
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Grids, Diaccess,   Fmcntrls, 
  Fmcmpnts, CAPRISupport;

type
  TfrmVRPointOfContact = class(TForm)
    Panel1: TPanel;
    btnClose: TBitBtn;
    leName: TLabeledEdit;
    leLocation: TLabeledEdit;
    lePhone: TLabeledEdit;
    leEmail: TLabeledEdit;
    edtPOC: TEdit;
    leLocationIEN: TLabeledEdit;
    FMListerVR_POC: TFMLister;
    procedure FormActivate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
    procedure PopulatePOCDisplayGrid;
  public
    { Public declarations }
  end;

  var
  frmVRPointOfContact: TfrmVRPointOfContact;

implementation
uses Main, DiTypLib, VAUtils;

{$R *.dfm}

//------------------------------------------------------------------------------
// Form Activate
//------------------------------------------------------------------------------
procedure TfrmVRPointOfContact.FormActivate(Sender: TObject);
begin
  if VAUtils.ScreenReaderActive then
     edtPOC.TabStop := TRUE   // Set focus on title if screen reader is active
  else
  begin
     edtPOC.TabStop := FALSE;
     leName.SetFocus;
  end;
  PopulatePOCDisplayGrid;  
end;

//------------------------------------------------------------------------------
// Retrieve POC Info and display on screen
//------------------------------------------------------------------------------
procedure TfrmVRPointOfContact.PopulatePOCDisplayGrid;
var
  PopulateFields : Boolean;
begin
  PopulateFields := frmMain.VocRehab.PopulatePOCInfo(frmMain.VocRehab.GetPointOfContactIEN(frmMain.VocRehab.AddExam));
  if PopulateFields then
  begin
    leName.Text := frmMain.VocRehab.POC_Name;
    leLocation.Text := frmMain.VocRehab.POC_Location;
    leLocationIEN.Text := frmMain.VocRehab.POC_LocationIEN;
    lePhone.Text := frmMain.VocRehab.POC_Phone;
    leEmail.Text := frmMain.VocRehab.POC_Email;
  end
  else
  begin
    leName.Text := '--';
    leLocation.Text := '--';
    lePhone.Text := '--';
    leEmail.Text := '--';
  end;
end;


//------------------------------------------------------------------------------
// Close button clicked
//------------------------------------------------------------------------------
procedure TfrmVRPointOfContact.btnCloseClick(Sender: TObject);
begin
  Close;
end;


end.
