Unit audit;

Interface

Uses
  Windows,
  Messages,
  Buttons,
  CAPRISupport,
  CheckLst,
  Classes,
  ComCtrls,
  ComObj,
  Controls,
  Db,
  DBCtrls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Gauges,
  Graphics,
  Grids,
  kbmMemTable,
  OleServer,
  ORCtrls,
  ORDtTm,
  ORFn,
  StdCtrls,
  SysUtils,
  Trpcb,
  CCOWRPCBrokerCAPRI;

Type
  TfrmAuditTrail = Class(TForm)
    buttonStop        : TButton;
    Gauge1            : TGauge;
    Label1            : TLabel;
    Label2            : TLabel;
    Label3            : TLabel;
    Label4            : TLabel;
    Label5            : TLabel;
    Label6            : TLabel;
    labelTimeRemaining: TLabel;
    RichEditReport    : TRichEdit;
    SaveDialog1       : TSaveDialog;
    TimerStartDownload: TTimer;
    Procedure buttonStopClick(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormShow(Sender: TObject);
    Procedure TimerStartDownloadTimer(Sender: TObject);
  Private
    { Private declarations }
  Public
    { Public declarations }
  End;

Var
  frmAuditTrail: TfrmAuditTrail;
  StopAudit: Boolean;

Implementation

Uses main;

{$R *.DFM}

{$ASSERTIONS ON} // ON/OFF	Set to OFF after debug

Procedure TfrmAuditTrail.FormCloseQuery(Sender: TObject;
  Var CanClose: Boolean);
Begin
  modalresult := mrOk;
End;

Procedure TfrmAuditTrail.FormClose(Sender: TObject;
  Var Action: TCloseAction);
Begin
  Action := caFree;
End;

Procedure TfrmAuditTrail.FormShow(Sender: TObject);
Begin
  TimerStartDownload.Enabled := True;
End;

Procedure TfrmAuditTrail.TimerStartDownloadTimer(Sender: TObject);
Var
  ClaimNbr       : String;
  count          : longint;
  Date_Time      : String;
  DeleteFailed   : Boolean;
  downloadcount  : longint;
  Hour           : Word;
  InFile         : TextFile;
  LastIENPosition: LongInt;
  lasttime       : ttime;
  Location       : String;
  Min            : Word;
  MSec           : Word;
  OutFile        : TextFile;
  PatientICN     : String;
  PatientName    : String;
  PatientSSN     : String;
  position       : longint;
  SaveFile       : String;
  Sec            : Word;
  Sensitive      : String;
  tempString     : String;
  timeavg        : double;
  timecount      : integer;
  timetotal      : double;
  total          : longint;
  UserIEN        : String;
  UserName       : String;
  UserSSN        : String;
  UserTitle      : String;
  x              : integer;
  xtime          : String;

  Procedure AddToCustomReport(reportstring: String);
  Begin
    UserIEN      := Piece(reportstring, '^', 1);
    UserName     := Piece(reportstring, '^', 2);
    UserSSN      := Copy(Piece(reportstring, '^', 3), 6, 4);
    UserDivision := Piece(reportstring, '^', 4);
    UserTitle    := Piece(reportstring, '^', 5);
    PatientName  := Piece(reportstring, '^', 6);
    PatientICN   := Piece(reportstring, '^', 7);
    PatientSSN   := Piece(reportstring, '^', 8);
    Location     := Piece(reportstring, '^', 9);
    Date_Time    := FMDateTimeConvert(Piece(reportstring, '^', 10));
    Sensitive    := Piece(reportstring, '^', 11);
    ClaimNbr     := Piece(reportstring, '^', 12);
    WriteLn(OutFile,
      '"'          + UserIEN + '","' +
      UserName     + '","' +
      UserSSN      + '","' +
      UserDivision + '","' +
      UserTitle    + '","' +
      PatientName  + '","' +
      PatientICN   + '","' +
      PatientSSN   + '","' +
      Location     + '","' +
      Date_Time    + '","' +
      Sensitive    + '","' +
      ClaimNbr     + '"'
      );
  End;

Begin
  frmMain.StatusBarLoadPt.Caption := 'Ready.';

  TimerStartDownload.Enabled := False;
  SaveFile := '';
  If SaveDialog1.Execute Then
  Begin
    SaveFile := saveDialog1.Filename;
  End
  Else
  Begin
    modalResult := mrCancel;
    exit;
  End;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB ATE QUANTITY';
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'DVBAB ATE QUANTITY could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB ATE QUANTITY could not be accessed!');
    End;
  End;
  Total := 0;
  If frmMain.RPCBroker1.Results.Count > 0 Then
    total := StrToInt(frmMain.RPCBroker1.Results[0]);
  Label5.Caption := IntToStr(total);
  RichEditReport.Lines.Clear;
  Position := 0;
  Count := trunc(total / 100); // Ever how many there are, break it into 1000 segments.
  // This will keep the gauge from jumping from 0 to 100
  // instantly when the file is small.

  Try
  DeleteFile(SaveFile + '.bak')Except
    Begin
      ShowmessageCAPRI('Can''t remove previous backup file.');
      exit;
    End;
  End;

  AssignFile(OutFile, SaveFile + '.bak');
  Try
    Rewrite(OutFile);
  Except
    Begin
      ShowmessageCAPRI('There was a file write i/o problem.');
      exit;
    End;
  End;

  If FileExists(savefile) Then
  Begin
    LabelTimeRemaining.Caption := 'Checking previous...';
    LabelTimeRemaining.Repaint;
    frmAuditTrail.repaint;

    AssignFile(InFile, SaveFile);
    Try
      Reset(InFile);
    Except
      Begin
        ShowmessageCAPRI('There was a file read i/o problem.');
        exit;
      End;
    End;

    frmAuditTrail.DoubleBuffered := True;

    //Copy File and get rid of last line, which records the last record downloaded
    x := 0;
    Repeat
      ReadLn(InFile, TempString);
      If Not EOF(InFile) Then
        WriteLn(Outfile, TempString);
      inc(x);
      If x / 5000 = trunc(x / 5000) Then
      Begin
        Label4.Caption := inttostr(x);
        frmAuditTrail.Repaint;
      End;
      // Release ticks for rest of Windows to ease sluggishness
      application.processmessages;
    Until EOF(InFile);

    closeFile(inFile);

    If Pos('NEXT IEN #', tempstring) = 1 Then
    Begin
      Position := strtoint(frmMain.Piece(tempstring, '#', 2));

      Label4.Caption := IntToStr(Position);
      Count := total - x - 1; // Don't count the lines already downloaded

      If Count < 1 Then
      Begin
        ShowMessageCAPRI('No new records are available.  Download has been cancelled.');
        modalresult := mrCancel;
        exit;
      End
      Else
      Begin
        Count := trunc(count / 100);
      End;
    End
    Else
    Begin
      ShowMessageCAPRI('Unable to continue due to missing information in the file.  The file will be deleted and re-downloaded.');
    End;
  End;
  If Count < 1 Then
    count := 1;
  If Count > 5000 Then
    count := 5000;
  downloadcount := 0;
  Gauge1.MaxValue := Total;
  screen.cursor := crHourglass;
  labelTimeRemaining.caption := '';
  timecount := 0;
  timetotal := 0;

  If Total > 0 Then
  Begin
    buttonStop.Enabled := True;
    Repeat
      Begin
        lasttime := time;
        LastIENPosition := Position + Count;
        frmMain.RPCBroker1.RemoteProcedure := 'DVBAB ATE LIST';
        frmMain.RPCBroker1.Param[0].Value := inttostr(Position);
        frmMain.RPCBroker1.Param[0].PType := literal;
        frmMain.RPCBroker1.Param[1].Value := inttostr(count);
        frmMain.RPCBroker1.Param[1].PType := literal;
        frmMain.RPCBrokerCall;
        frmMain.RPCBroker1.Call;
        application.processmessages;
        screen.cursor := crHourglass;
        If frmMain.RPCBroker1.Results.Count > 0 Then
        Begin
          position := strToInt(frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1));
          //ShowMessageCAPRI(frmMain.Piece(frmMain.RPCBroker1.Results[0],'^',1));
          // Don't use QuickCopy function because we need to append
          For x := 1 To StrToInt(frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 2)) Do
            AddtoCustomReport(frmMain.RPCBroker1.Results[x]);
          downloadcount := downloadcount + strToInt(frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 2));
        End
        Else
          Position := 0; // Force it to end if it comes back blank
        label4.caption := IntToStr(Position); // Was downloadcount instead
        Gauge1.Progress := DownloadCount;
        timetotal := timetotal + (time - lasttime);
        timeCount := timeCount + 1;
        timeavg := timetotal / timecount;
        Try
        DecodeTime(((timeavg) * ((gauge1.maxvalue - gauge1.progress) / count)), Hour, Min, Sec, MSec)Except
          Begin
            Hour := 0;
            Min := 0;
            Sec := 1;
            MSec := 0;
          End;
        End;
        xtime := '';
        If Hour > 0 Then
          xtime := xtime + Copy('00' + inttostr(hour), length('00' + inttostr(hour)) - 1, 2) + ':';
        If min > 0 Then
          xtime := xtime + Copy('00' + inttostr(min), length('00' + inttostr(min)) - 1, 2) + ':';
        xtime := xtime + Copy('00' + inttostr(sec), length('00' + inttostr(sec)) - 1, 2);
        If ((length(xtime) = 2) And (Copy(xtime, 1, 1) = '0')) Then
          xtime := Copy(xtime, 2, 1);
        If pos(':', xtime) = 0 Then
          xtime := xtime + ' seconds';
        If xtime = '1 seconds' Then
          xtime := '1 second';
        If (xtime = '') Then
          xtime := 'Done!';
        If (xtime = '0 seconds') Then
          xtime := '<1 second';
        labelTimeRemaining.caption := xtime;
        labelTimeRemaining.Repaint;
        Gauge1.Repaint;
    End Until (Position = 0) Or (StopAudit = True);
  End
  Else
  Begin
    screen.cursor := crDefault;
    modalResult := mrCancel;
    exit;
  End;
  labelTimeRemaining.caption := 'Done!';
  labelTimeRemaining.Repaint;
  Gauge1.Progress := Gauge1.Maxvalue;
  Gauge1.Repaint;
  screen.cursor := crDefault;
  //ShowMessageCAPRI(saveDialog1.Filename);
  WriteLn(OutFile, 'NEXT IEN #' + FloatToStr(LastIENPosition));
  CloseFile(OutFile);
  DeleteFailed := False;
  If FileExists(saveFile) Then
  Begin
    Try
    deletefile(saveFile)Except
      Begin
        DeleteFailed := True;
      End
    End;
  End;

  If DeleteFailed = True Then
  Begin
    RenameFile(SaveFile + '.bak', SaveFile + '.bak' + floattostr(now));
  End
  Else
  Begin
    RenameFile(SaveFile + '.bak', SaveFile);
  End;

  frmMain.StatusBarLoadPt.Caption := 'CAPRI Audit file has been saved to the specified location.';
  StopAudit := False;
  modalResult := mrOk;
End;

Procedure TfrmAuditTrail.buttonStopClick(Sender: TObject);
Begin
  StopAudit := True;
End;

End.
