unit clsUserInfo;

interface

uses Classes, SysUtils, FMCmpnts, CCOWRPCBroker;

Type
  TUserInfo = class(TObject)
    private
    { Private Declarations }
    class function IsKeyInList(KeyName: String; KeyList: TFMLister): Boolean;
    public
    { Public Declaraions }
    class function GetUserTimeOut(Brkr: TCCOWRPCBroker): Cardinal;
    class function UserHasKey(Brkr: TCCOWRPCBroker; KeyName: String): Boolean;
  end;

implementation

{ PUBLIC }

class function TUserInfo.GetUserTimeOut(Brkr: TCCOWRPCBroker): Cardinal;
var
  val: String;
  FMGetUsrInfo: TFMGets;
begin
  Result := 900000;  { If no timed read value in 200 then default to 15 minutes }
  FMGetUsrInfo := TFMGets.Create(nil);
  try
    { Retrieve Timed Read value to use as Application TimeOut value }
    FMGetUsrInfo.RPCBroker := Brkr;
    FMGetUsrInfo.FieldNumbers.Add('200.1');
    FMGetUsrInfo.FileNumber := '200';
    FMGetUsrInfo.IENS := Brkr.User.DUZ;
    FMGetUsrInfo.GetData;
    val := FMGetUsrInfo.GetField('200.1').FMDBExternal;
    if Not SameText(val, '') then
      try
        Result := (StrToInt(val) * 1000);  { Timer is in Milliseconds }
        if (Result <= 300000) then
          Result := 900000; { Default to 15 min if value is 5 minutes or less }
      except
        Result := 900000;
      end;  { End Inner Try/Except Block }
  finally
    FMGetUsrInfo.Free;
  end;  { End Outer Try/Finally Block }
end;

class function TUserInfo.UserHasKey(Brkr: TCCOWRPCBroker; KeyName: String): Boolean;
var
  FMLstrUsrInfo: TFMLister;
begin
  FMLstrUsrInfo := TFMLister.Create(nil);
  try
    { Retrieve User's Assigned Key(s) }
    FMLstrUsrInfo.RPCBroker := Brkr;
    FMLstrUsrInfo.FileNumber := '200.051';
    FMLstrUsrInfo.FieldNumbers.Add('.01');  { Key Name - DBIA #10060 }
    FMLstrUsrInfo.IENS := ',' + Brkr.User.DUZ;
    FMLstrUsrInfo.GetList(nil);
    { Determine if user has Admin Key }
    Result := IsKeyInList(KeyName, FMLstrUsrInfo);
  finally
    FMLstrUsrInfo.Free;
  end;  { End Try/Finally Block }
end;

{ PRIVATE }

class function TUserInfo.IsKeyInList(KeyName: string; KeyList: TFMLister): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to KeyList.Results.Count - 1 do
  begin
    if SameText(UpperCase(KeyList.GetRecord(KeyList.Results[i]).GetField('.01').
         FMDBExternal), KeyName) then
    begin
      Result := True;
      break;
    end;  { End If Search Key Value found in list }
  end;  { End Keylist Loop }
end;

end.
