unit examdet;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  CheckLst,
  ORDtTm,
  Trpcb,
  ExtCtrls,
  Diaccess,
  Fmcmpnts,
  Menus,
  clipbrd,
  ComCtrls, ToolWin, ActnMan, ActnCtrls, ActnMenus, ActnList, XPStyleActnCtrls,
  CCOWRPCBrokerCAPRI;  // CodeCR699 JRL 3/10/15

type
  TfrmExamDetails = class(TForm)
    Panel1: TPanel;
    btnClose: TButton;
    btnCancelExam: TButton;
    ScrollBox1: TScrollBox;
    Label6: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    FMExamType: TFMEdit;
    edExamReferenceNumber: TEdit;
    FMExamStatus: TFMEdit;
    FMWorkSheet: TFMEdit;
    FMExamPlace: TFMEdit;
    FMFeeExam: TFMEdit;
    FMPhysician: TFMEdit;
    FMDateOfExam: TFMEdit;
    FMCancelBy: TFMEdit;
    FMCancelDate: TFMEdit;
    FMProvider: TFMEdit;
    FMInsufficientReason: TFMEdit;
    Label3: TLabel;
    Label5: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    FMOutTo: TFMEdit;
    FMOutBy: TFMEdit;
    FMDateOut: TFMEdit;
    FMCancelReason: TFMEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    FMDateReturned: TFMEdit;
    FMDateIn: TFMEdit;
    Label21: TLabel;
    Label22: TLabel;
    Shape1: TShape;
    FMGetsExamDetails: TFMGets;
    panelCancel: TPanel;
    FMListerCancelReason: TFMLister;
    FMListCancelReason: TFMListBox;
    btnOKCancel: TButton;
    btnAbortCancel: TButton;
    btnCancelByMAS: TRadioButton;   // CodeCR699 JRL 3/11/15 -refactored name to be descriptive
    btnCancelByRO: TRadioButton;    // CodeCR699 JRL 3/11/15 -refactored name to be descriptive
    FMFiler1: TFMFiler;
    TimerClose: TTimer;
    CCOWTimer: TTimer;
    GroupBox1: TGroupBox;
    FMExamDetailsCommentsMemo: TFMMemo;
    RichEditExamReport: TRichEdit;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    FMInsufficientMemo: TFMMemo;
    ActionManExamDetails: TActionManager;
    actFilePrint: TAction;
    actFilePrintPreview: TAction;
    actEditUndo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actMenuBarExamDetails: TActionMainMenuBar;
    actFileTransmitVirtualVA: TAction;
    lbxListCancelReason: TListBox;                                              // CodeCR665 rpk 11/18/2014
    gbxCancelComments: TGroupBox;
    FMMemoCancelComments: TFMMemo;
    MemoCancelComments_x: TMemo;
    txtCancelComments: TStaticText;
    lblSelCancelReason: TStaticText;                                            // rpk 2/17/2015
    procedure edExamReferenceNumberChange(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCancelExamClick(Sender: TObject);
    procedure btnAbortCancelClick(Sender: TObject);
    procedure btnOKCancelClick(Sender: TObject);
    procedure FMExamStatusChange(Sender: TObject);
    procedure FMListCancelReasonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TimerCloseTimer(Sender: TObject);
    procedure FMExamDetailsCommentsMemoEnter(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure actEditUndoUpdate(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
    procedure actFilePrintExecute(Sender: TObject);
    procedure actFilePrintPreviewExecute(Sender: TObject);
    procedure RichEditExamReportEnter(Sender: TObject);                         //CodeCR216 - rpm 3/7/12
    procedure actFileTransmitVirtualVAExecute(Sender: TObject);
    procedure actFileTransmitVirtualVAUpdate(Sender: TObject);
    procedure lbxListCancelReasonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FMMemoCancelCommentsEnter(Sender: TObject);                       // rpk 2/17/2015
    procedure FMInsufficientMemoEnter(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);                         // rpk 2/17/2015
  private
    { Private declarations }
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
    procedure GetComments;
  public
    { Public declarations }
  end;

var
  frmExamDetails: TfrmExamDetails;

implementation

uses main, viewexam, comments1, CapriSupport, untMiscMthds;

{$R *.DFM}

var
  CancelReasonsIEN: TStringList;                                                // CodeCR665 rpk 11/18/2014

procedure TfrmExamDetails.edExamReferenceNumberChange(Sender: TObject);
begin
  Scrollbox1.VertScrollbar.Position := 0;
  fmExamDetailsCommentsMemo.ReadOnly := True;
  fmInsufficientMemo.ReadOnly := True;
  FMMemoCancelComments.ReadOnly := True;                                        // CodeCR670 rpk 11/17/2014
end;

procedure TfrmExamDetails.btnCloseClick(Sender: TObject);
begin
  if panelCancel.Visible = True then begin
    ShowMessageCAPRI('You are in the process of cancelling an exam.  Please finish that action before closing the window.');
    exit;
  end;
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  ModalResult := mrOK;
end;

procedure TfrmExamDetails.btnCancelExamClick(Sender: TObject);
var
  i: Integer;
  resultstr: String;
begin
  If IsPatchInstalled('DVBA*2.7*189') then // CodeCR666 JRL 2/2/15 - Added test for backward compatibility
  begin
    ContextorChangeMessage := 'You are cancelling an exam.  If you continue, this will be aborted.';
    CCOWBreakLink := False;
    btnCancelExam.Enabled := False;
    lbxListCancelReason.Clear;                                                  // CodeCR665 rpk 11/18/2014
    CancelReasonsIEN.Clear;                                                     // CodeCR665 rpk 11/18/2014
    if CallRPC(frmMain.RPCBroker1, 'DVBA CAPRI GETCANCELREASON', [], nil) then  // CodeCR665 rpk 11/13/2014
    begin
      for I := 0 to frmMain.RPCBroker1.Results.Count - 1 do                     // CodeCR665 rpk 11/18/2014
      begin
      resultstr := frmMain.RPCBroker1.Results[I];
      CancelReasonsIEN.Add(piece(resultstr, '^', 1));                           // CodeCR665 rpk 11/18/2014
      lbxListCancelReason.Items.Add(piece(resultstr, '^', 2));                  // CodeCR665 rpk 11/18/2014
      end;                                                                      // CodeCR665 rpk 11/18/2014
    end;
    btnOKCancel.Enabled := False;
    PanelCancel.Top := ScrollBox1.Top + ((Scrollbox1.Height - PanelCancel.Height) div 2);
    PanelCancel.Left := ScrollBox1.Left + ((Scrollbox1.Width - PanelCancel.Width) div 2);
    lbxListCancelReason.Height := 230;
    lbxListCancelReason.Visible := TRUE;
    FMListCancelReason.Visible := FALSE;
    FMListCancelReason.Enabled := FALSE;                                        // rpk 2/17/2015
    if ESSOVersion = True then                                                  // CodeCR699 JRL 3/10/15
    begin // Remote login - enable "Cancel by Regional Office"                  // CodeCR699 JRL 3/10/15
      btnCancelByMAS.Checked := FALSE;                                          // CodeCR699 JRL 3/10/15
      btnCancelByRO.Checked := TRUE;                                            // CodeCR699 JRL 3/10/15
      btnCancelByMAS.Enabled := FALSE;                                          // CodeCR699 JRL 3/10/15
      btnCancelByRO.Enabled := TRUE;                                            // CodeCR699 JRL 3/10/15
    end                                                                         // CodeCR699 JRL 3/10/15
    else                                                                        // CodeCR699 JRL 3/10/15
    begin // local login - enable "Cancel by MAS"                               // CodeCR699 JRL 3/10/15
      btnCancelByMAS.Checked := TRUE;                                           // CodeCR699 JRL 3/10/15
      btnCancelByRO.Checked := FALSE;                                           // CodeCR699 JRL 3/10/15
      btnCancelByMAS.Enabled := TRUE;                                           // CodeCR699 JRL 3/10/15
      btnCancelByRO.Enabled := FALSE;                                           // CodeCR699 JRL 3/10/15
    end;                                                                        // CodeCR699 JRL 3/10/15
    panelCancel.Visible := True;                                                
    panelCancel.Enabled := True;                                                
    panelCancel.BringToFront;                                                   
    try                                                                         // rpk 2/17/2015
      if lbxListCancelReason.CanFocus then                                      // rpk 2/17/2015
        lbxListCancelReason.SetFocus;                                           // rpk 2/17/2015
    except;                                                                     // rpk 2/17/2015
    end;                                                                        // rpk 2/17/2015
    FMExamStatusChange(application);                                            // Forces code to determine if cancel button should be enabled
    if CancellationReason <> '' then
      if CancellationReason <> '-1' then
      begin
        lbxListCancelReason.ItemIndex := StrToInt(CancellationReason);          // CodeCR665 rpk 10/28/2014
        btnOKCancelClick(Application);
      end;
  end
  else  // DVBA*2.7*187
  begin
    ContextorChangeMessage := 'You are cancelling an exam.  If you continue, this will be aborted.';
    CCOWBreakLink := False;
    btnCancelExam.Enabled := False;
    FMListerCancelReason.GetList(nil);
    FMListCancelReason.GetList;
    btnOKCancel.Enabled := False;
    PanelCancel.Top := ScrollBox1.Top + ((Scrollbox1.Height - PanelCancel.Height) div 2);
    PanelCancel.Left := ScrollBox1.Left + ((Scrollbox1.Width - PanelCancel.Width) div 2);
    lbxListCancelReason.Visible := FALSE;
    FMListCancelReason.Height := 201;
    FMListCancelReason.Visible := TRUE;
    FMListCancelReason.Enabled := TRUE;                                         // rpk 2/17/2015
    panelCancel.Visible := True;
    panelCancel.Enabled := True;
    panelCancel.BringToFront;
    try                                                                         // rpk 2/17/2015
      if FMListCancelReason.CanFocus then                                       // rpk 2/17/2015
        FMListCancelReason.SetFocus;                                            // rpk 2/17/2015
    except;                                                                     // rpk 2/17/2015
    end;                                                                        // rpk 2/17/2015
    FMExamStatusChange(application); // Forces code to determine if cancel button should be enabled
    if CancellationReason <> '' then
      if CancellationReason <> '-1' then
      begin
        FMListCancelReason.ItemIndex := StrToInt(CancellationReason);
        btnOKCancelClick(Application);
      end;
  end;
end;                                                                            // btnCancelExamClick

procedure TfrmExamDetails.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmExamDetails.actEditCutExecute(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmExamDetails.actEditPasteExecute(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
end;

procedure TfrmExamDetails.actEditUndoExecute(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmExamDetails.actEditUndoUpdate(Sender: TObject);
var
  tempTMemoBox: TMemo;
  tempTEdit: TEdit;
  tempTRichEdit: TRichEdit;
begin
  FEditCtrl := nil;
  if Screen.ActiveControl is TCustomEdit then
    FEditCtrl := TCustomEdit(Screen.ActiveControl);
  if FEditCtrl <> nil then begin
    actEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    actEditCut.Enabled := FEditCtrl.SelLength > 0;
    actEditCopy.Enabled := actEditCut.Enabled;
    actEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
  end
  else begin
    actEditUndo.Enabled := False;
    actEditCut.Enabled := False;
    actEditCopy.Enabled := False;
    actEditPaste.Enabled := False;
  end;
  // Don't let read only memos accept paste function
  if FEditCtrl = nil then
    exit;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMMEMO') then begin
    tempTMemoBox := FEditCtrl as TMemo;
    if (tempTMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMEDIT') then begin
    tempTEdit := FEditCtrl as TFMEdit;
    if (tempTEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;

  if (Uppercase(FEditCtrl.ClassName) = 'TRICHEDIT') then begin
    tempTRichEdit := FEditCtrl as TRichEdit;
    if (tempTRichEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
end;

procedure TfrmExamDetails.actFilePrintExecute(Sender: TObject);
begin
  frmMain.actFilePrintExecute(frmExamDetails);
end;

procedure TfrmExamDetails.actFilePrintPreviewExecute(Sender: TObject);
begin
  frmMain.actFilePrintPreview.Execute;
end;

procedure TfrmExamDetails.actFileTransmitVirtualVAExecute(Sender: TObject);
begin
  frmMain.actFileTransmitVirtualVAExecute(frmExamDetails);
end;

procedure TfrmExamDetails.actFileTransmitVirtualVAUpdate(Sender: TObject);
begin
  if (frmMain.VirtualVAURL = '') or
    (frmMain.VirtualVAToken = '') then
    actFileTransmitVirtualVA.Enabled := False
  else
    actFileTransmitVirtualVA.Enabled := True;
end;

procedure TfrmExamDetails.GetComments;
begin
  frmComments := TfrmComments.Create(frmMain);
  try
    frmComments.Top := frmMain.Top + ((frmMain.Height - frmComments.Height) div 2);
    frmComments.Left := frmMain.Left + ((frmMain.Width - frmComments.Width) div 2);
    frmComments.MemoCancelComments.Lines.Clear;
    try
      if frmComments.MemoCancelComments.CanFocus then
        frmComments.MemoCancelComments.SetFocus;
    except
    end;
    //  Set up screen
    frmComments.Font := frmMain.panel1.Font;
//    frmComments.txtlabel1.font := frmMain.panel1.Font;
    frmComments.memoCancelComments.Font := frmMain.panel1.font;
    frmComments.btnDone.Font := frmMain.panel1.font;
    frmComments.btnDone.height := frmMain.panel1.height;
    frmComments.btnDone.top := frmComments.height - frmComments.btnDone.height * 3 - 8;
//    frmComments.memoCancelComments.Top := frmComments.txtLabel1.Top + frmComments.txtLabel1.Height + 8;
    frmComments.memoCancelComments.height := frmComments.btnDone.Top - frmComments.memoCancelComments.Top - 8;
    //
    frmComments.ShowModal;
    if frmComments.memoCancelComments.Lines.Count > 0 then begin
      ViewExamCancelComments.Assign(frmComments.memoCancelComments.Lines);      // CodeCR670 rpk 11/17/2014
//      FMMemoCancelComments.Lines.Assign(frmComments.MemoCancelComments.Lines);  // CodeCR670 rpk 11/14/2014
    end;
  finally
    FreeAndNil(frmComments);
  end;
end;                                                                            // GetComments

procedure TfrmExamDetails.btnAbortCancelClick(Sender: TObject);
begin
  ContextorChangeMessage := '';
  CCOWBreakLink := False;
  panelCancel.Visible := False;
  panelCancel.Enabled := False;
  if CancellationReason <> '' then
//  btnCancelClick(Application);
    btnCloseClick(Application);                                                 // rpk 11/17/2014
end;

procedure TfrmExamDetails.btnOKCancelClick(Sender: TObject);
begin
  if (btnCancelByMAS.Checked = False) and (btnCancelByRO.Checked = False) then begin // CodeCR699 JRL 3/11/15 -refactored names to be descriptive
    ShowMessageCAPRI('Select a cancellation category: MAS or RO.');
    exit;
  end;

  If IsPatchInstalled('DVBA*2.7*189') then // CodeCR666 JRL 2/2/15 - Added test for backward compatibility
  begin
    // if cancelling one exam or all exams, get cancellation comments to be used in examdet
    if (CancellationReason = '') or (CancellationReason = '-1') then            // CodeCR670 rpk 1/14/2015
    begin
      if Application.MessageBox('Are you sure you are ready to cancel this exam?', 'Cancel Exam', 4) = mrYes then // rpk 1/15/2015
      begin
        GetComments;                                                              // CodeCR670 rpk 1/14/2015
      end
      else
        exit
    end;
    CancelIt[EditWhich] := True;                                                  // Mark this exam # cancelled
    CancelReason[EditWhich] := lbxListCancelReason.Items[lbxListCancelReason.ItemIndex]; // CodeCR665 rpk 10/28/2014
    fmCancelDate.Text := 'NOW';
    fmCancelBy.Text := '`' + AuthorIEN;
    fmCancelReason.Text := '`' + CancelReasonsIEN[lbxListCancelReason.ItemIndex]; // CodeCR665 rpk 11/18/2014
    if ViewExamCancelComments.Count > 0 then                                    // CodeCR670 rpk 11/17/2014
      FMMemoCancelComments.Lines.Assign(ViewExamCancelComments);                // CodeCR670 rpk 11/14/2014
    if btnCancelByMAS.Checked then                                              // CodeCR699 JRL 3/11/15 -refactored name to be descriptive
      fmExamStatus.Text := 'X';                                                 //Cancelled by MAS
    if btnCancelByRO.Checked then                                               // CodeCR699 JRL 3/11/15 -refactored name to be descriptive
      fmExamStatus.Text := 'RX';                                                //Cancelled by RO
  end
  else // DVBA*2.7*187
  begin
    if (btnCancelByMAS.Checked = False) and (btnCancelByRO.Checked = False) then begin // CodeCR699 JRL 3/11/15 -refactored names to be descriptive
      ShowMessageCAPRI('Select a cancellation category: MAS or RO.');
      exit;
    end;
    if (CancellationReason = '') or (CancellationReason = '-1') then
      if Application.MessageBox('Are you sure you are ready to cancel this exam?', 'Cancel Exam', 4) <> 6 then 
      begin
        exit;
      end;
    CancelIt[EditWhich] := True; // Mark this exam # cancelled
    CancelReason[EditWhich] := fmListCancelReason.Items[FMListCancelReason.ItemIndex];
    fmCancelDate.Text := 'NOW';
    fmCancelBy.Text := '`' + AuthorIEN;
    fmCancelReason.Text := '`' + FMListCancelReason.GetSelectedRecord.IEN;
    if btnCancelByMAS.Checked then                                              // CodeCR699 JRL 3/11/15 -refactored name to be descriptive
      fmExamStatus.Text := 'X'; //Cancelled by MAS
    if btnCancelByRO.Checked then                                               // CodeCR699 JRL 3/11/15 -refactored name to be descriptive
      fmExamStatus.Text := 'RX'; //Cancelled by RO
  end;

  if FMExamStatus.FMModified then
    if FMExamStatus.Validate then begin
      FMFiler1.AddChgdControl(FMExamStatus);
      FMExamStatus.Text := FMExamStatus.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamStatus.Text := FMExamStatus.FMTag;
    end;

  if FMCancelDate.FMModified then
    if FMCancelDate.Validate then begin
      FMFiler1.AddChgdControl(FMCancelDate);
      FMCancelDate.Text := FMCancelDate.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMCancelDate.Text := FMCancelDate.FMTag;
    end;

  if FMCancelBy.FMModified then
    if FMCancelBy.Validate then begin
      FMFiler1.AddChgdControl(FMCancelBy);
      FMCancelBy.Text := FMCancelBy.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMCancelBy.Text := FMCancelBy.FMTag;
    end;

  if FMCancelReason.FMModified then
    if FMCancelReason.Validate then begin
      FMFiler1.AddChgdControl(FMCancelReason);
      FMCancelReason.Text := FMCancelReason.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMCancelReason.Text := FMCancelReason.FMTag;
    end;

  if FMMemoCancelComments.FMModified then
    FMFiler1.AddChgdControl(FMMemoCancelComments);

  if FMFiler1.AnythingToFile then
    if FMFiler1.DataProblemCheck then begin
      FMFiler1.ProcessDataProblemList
    end
    else if FMFiler1.Update then
    begin
    end
    else
      FMFiler1.DisplayErrors;

  panelCancel.Visible := False;
  panelCancel.Enabled := False;

  If IsPatchInstalled('DVBA*2.7*189') then // CodeCR666 JRL 2/2/15 - Added test for backward compatibility
  begin
    if CancellationReason = '-1' then                                           // cancelling all exams
    begin
      CancellationReason := inttoStr(lbxListCancelReason.ItemIndex);            // CodeCR665 rpk 10/28/2014
    end;

    ContextorChangeMessage := '';
    CCOWBreakLink := False;
    if CancellationReason <> '' then 
    begin
      TimerClose.Enabled := True;
      exit;
    end;
    // if this exam is cancelled, cancel all exams should no longer be used.
    if (fmExamStatus.Text <> 'OPEN') then                                       // rpk 11/19/2014
      if frmViewExam.btnCancelAllExams.Enabled then                             // rpk 11/19/2014
        frmViewExam.btnCancelAllExams.Enabled := False;                         // rpk 11/19/2014
    if FMCancelBy.Text <> '' then
      btnCloseClick(Application);                                               // rpk 11/17/2014
  end
  else // DVBA*2.7*187
  begin
    if CancellationReason = '-1' then
      CancellationReason := inttoStr(FMListCancelReason.ItemIndex);
    ContextorChangeMessage := '';
    CCOWBreakLink := False;
    if CancellationReason <> '' then begin
      TimerClose.Enabled := True;
      exit;
    end;
    if FMCancelBy.Text <> '' then
//    btnCancelClick(Application);  
      btnCloseClick(Application);                                               // rpk 11/17/2014 - renamed
  end;
end;                                                                            // btnOKCancelClick

procedure TfrmExamDetails.FMExamStatusChange(Sender: TObject);
begin
  if (fmExamStatus.Text = 'OPEN') then
    btnCancelExam.Enabled := True
  else
    btnCancelExam.Enabled := False;
  if ReadOnlyMode = True then
    btnCancelExam.Enabled := False;
end;

procedure TfrmExamDetails.FMInsufficientMemoEnter(Sender: TObject);             // rpk 2/17/2015
begin
  FMInsufficientMemo.SelStart := 0;
end;

procedure TfrmExamDetails.FMListCancelReasonClick(Sender: TObject);
begin
  btnOKCancel.Enabled := True;
end;

procedure TfrmExamDetails.FMMemoCancelCommentsEnter(Sender: TObject);           // rpk 2/17/2015
begin
  FMMemoCancelComments.SelStart := 0;
end;

procedure TfrmExamDetails.FormActivate(Sender: TObject);
begin
  if CancellationReason <> '' then
    btnCancelExamClick(Application);
end;

procedure TfrmExamDetails.TimerCloseTimer(Sender: TObject);
begin
  timerClose.Enabled := False;
//btnCancelClick(Application);
  btnCloseClick(Application);                                                   // rpk 11/17/2014 - renamed
end;

procedure TfrmExamDetails.FMExamDetailsCommentsMemoEnter(Sender: TObject);
begin
  FEditCtrl := FMExamDetailsCommentsMemo;
end;

procedure TfrmExamDetails.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    panelCancel.Visible := False;
//  btnCancelClick(Application);
    btnCloseClick(Application);                                                 // rpk 11/17/2014 - renamed
    frmExamDetails.Visible := False;
  end;
end;

procedure TfrmExamDetails.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  RichEditExamReport.Visible := False;
end;

procedure TfrmExamDetails.FormCreate(Sender: TObject);
begin
  panel2.sendtoback;
  If not IsPatchInstalled('DVBA*2.7*189') then // CodeCR666 JRL 2/2/15 - Added test for backward compatibility
     FMMemoCancelComments.Clear;
  CancelReasonsIEN := TStringList.Create;                                       // CodeCR665 rpk 11/18/2014
  PanelCancel.SendtoBack;                                                       // rpk 1/15/2015
end;

procedure TfrmExamDetails.FormDestroy(Sender: TObject);
begin
  FreeAndNil(CancelReasonsIEN);                                                 // CodeCR665 rpk 11/18/2014
end;

procedure TfrmExamDetails.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  tbool: Boolean;
  wc: TWinControl;
begin
  wc := ScrollBox1;
  if wc <> nil then begin
    tbool := ScrollBox(wc, MousePos, WheelDelta);
    Handled := tbool;
  end;
end;

procedure TfrmExamDetails.lbxListCancelReasonClick(Sender: TObject);            // CodeCR665 rpk 10/28/2014
begin
  btnOKCancel.Enabled := True;
end;


//CodeCR216 - rpm 3/7/12

procedure TfrmExamDetails.RichEditExamReportEnter(Sender: TObject);
begin
  actEditUndoUpdate(Sender);
end;

//CCAPRI_CodeCR96 - jcs - 03/16/10

procedure TfrmExamDetails.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;

end.

