unit frmContractedExamCheckIn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frmContractedBase, ComCtrls, ExtCtrls, StdCtrls, CheckLst, StrUtils,
  Fmcntrls, clsPatientInfo,
  CCOWRPCBrokerCAPRI,     // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
  MFunStr, untMiscMthds, untAddtnlMMthds,
  Diaccess, Fmcmpnts, clsExamInfo, DateUtils, dlgVndrExmChkInRslts, dialogsCAPRI,
  clsSFTPConn, dlgVndrExmRtrvl, untBrkrMthds,
  clsUserInfo,
  { Secure BlackBox Components }
  SBSftpCommon, Trpcb, Buttons;

type
  { Vendor ASCII File Length Exception - Line exceeds 999 Characters }
  EVndrExmLngthError = class(Exception);
  TExntdCntrctdBaseFormCheckIn = class(TCntrctdBaseForm)
    Panel1: TPanel;
    Label2: TLabel;
    lblFilePath: TLabel;
    btnGetCntrctdExamFile: TButton;
    lblCntrctrs: TLabel;
    cmbBxContractors: TComboBox;
    fmMemoExmRslts: TFMMemo;
    Panel2: TPanel;
    Label1: TLabel;
    Panel3: TPanel;
    edDtPkrCheckIn: TEdit;
    btnDateReceivedFromContractor: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure chkdLstBxExamsClickCheck(Sender: TObject);
    procedure chkBxCntrctAllExamsClick(Sender: TObject);
    procedure btnGetCntrctdExamFileClick(Sender: TObject);
    procedure cmbBxContractorsChange(Sender: TObject);
//    procedure dtPckrCheckInChange(Sender: TObject);
    procedure tmepckrCheckInChange(Sender: TObject);
//    procedure dtPckrCheckInExit(Sender: TObject);
    procedure cmbx2507RqstsChange(Sender: TObject);
    procedure btnRfrshRqstsClick(Sender: TObject);
//    procedure dtPckrCheckInLookupSelect(Sender: TObject; var Value: string);
    procedure btnDateReceivedFromContractorClick(Sender: TObject);
    procedure edDtPkrCheckInExit(Sender: TObject);
  protected
    { Protected declarations }
    procedure ExecuteBtnAction; override;
    procedure PopExamList(rqstIEN: String); overload; override;
  private
    { Private declarations }
    _RqstIEN: String;
    _UpdtExmLst: Boolean;
    _CntrctdExmFilePths, _CntrctdExmRslts: TStringList;
    _SFTPConn: TSFTPConn;
    function CheckInExams(exmObjLst: TStringList; allExmsCmpltdCncld: Boolean;
         OverWriteRslts: Boolean; VRslts: TStrings): Boolean;
    function CreateExamObjRefList(exmObjLst: TStringList; Var rsltsExst: Boolean): Boolean;
    function GetContractorInfo(): String;
    //function GetTempExmDir(): String;
    function IsCheckInDateValid(): Boolean;
    procedure AllowAction;
    procedure AddVendorRsltsToExmRslts(Rslts: TStrings);
    procedure GetCntrctdExamFiles;
    procedure PopExamList(rqstIEN, cntrctrSrchIEN: String); reintroduce; overload;
    procedure PopContractorList;
    procedure InitCntrctdFileRtrvl;
    function GetDateOfText(aDateStr : string; defaultDate : string) : TDateTime;
    // function IsDateValid(aDateStr : string) : Boolean;  // DONE: LMS refactored out
    procedure DateComplete(var StrLikeDate : string; MinDate : TDate; const NowIfError : Boolean = TRUE);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; PtntInfo: TPatientInfo;
         CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal); reintroduce;
    destructor Destroy; override;
  end;

var
  ExntdCntrctdBaseFormCheckIn: TExntdCntrctdBaseFormCheckIn;

implementation
uses
  VocRehabSelectDate  // DONE: CodeCR457 - LMS For replacing date selection components
  ;

{$R *.dfm}

constructor TExntdCntrctdBaseFormCheckIn.Create(AOwner: TComponent; PtntInfo: TPatientInfo;
     CCOWBrkr: TCCOWRPCBrokerCAPRI; TmrVal: Cardinal);
begin
  inherited Create(AOwner, PtntInfo, CCOWBrkr, TmrVal);
  _CntrctdExmFilePths := TStringList.Create;
  _CntrctdExmRslts := TStringList.Create;
  _SFTPConn := nil;
end;

destructor TExntdCntrctdBaseFormCheckIn.Destroy;
begin
  _CntrctdExmFilePths.Free;
  _CntrctdExmRslts.Free;
  if Assigned(_SFTPConn) then
    _SFTPConn.Free;
  inherited;
end;

procedure TExntdCntrctdBaseFormCheckIn.FormShow(Sender: TObject);
begin
  inherited;
  Caption := 'Check-In Contracted 2507 Exam(s) for ' + _PtntInfo.PatientName +
       ' (' + Copy(_PtntInfo.PatientSSN, Length(_PtntInfo.PatientSSN)-3, 4) + ')';
  { Set Initial Default Check-In Value to current System Date }
//  dtPckrCheckIn.Date := Now;
  edDtPkrCheckIn.Text := DateToStr(Now);
  { Retrieve Contractor List in File #396.45 - Get All as some exams requests
    may have been previously opened with a contractor who is now inactive. }
  GetContractors;
  btnGetCntrctdExamFile.Enabled := False;  { Requires selection of contractor first }
  btnRfrshRqstsClick(self); { Populate Requests }
end;

procedure TExntdCntrctdBaseFormCheckIn.chkBxCntrctAllExamsClick(
  Sender: TObject);
begin
  inherited;
  lblCntrctrs.Enabled := chkBxCntrctAllExams.Checked;
  cmbBxContractors.Enabled := chkBxCntrctAllExams.Checked;
  { Request or Exam selection changed/refreshed have user select file again
    to ensure correct contracted exam file(s) chosen }
  _CntrctdExmFilePths.Clear;
  _CntrctdExmRslts.Clear;
  AllowAction;
end;

procedure TExntdCntrctdBaseFormCheckIn.chkdLstBxExamsClickCheck(
  Sender: TObject);
var
  curIndx: Integer;
begin
  inherited;
  curIndx := chkdLstBxExams.ItemIndex;
  if (GetCheckedCount(chkdLstBxExams) = 0) then
  begin
    PopExamList(_RqstIEN);  { Reset List to all applicable exams }
  end  { End If No Exams Selected }
  else if _UpdtExmLst then
  begin
    { Only enable exams for specific contractor once initial contractor selected }
    PopExamList(_RqstIEN, _fmTmpLstrExams.GetRecord(_fmTmpLstrExams.
         Results[curIndx]).GetField('100').FMDBExternal);
    { Reselect selection after populating and repainting list }
    chkdLstBxExams.Checked[curIndx] := True;
    _UpdtExmLst := False;
  end;  { End Else If Contractor Specific List }
  InitCntrctdFileRtrvl;  { Contractor Completed Exam selection required again }
end;

procedure TExntdCntrctdBaseFormCheckIn.cmbBxContractorsChange(Sender: TObject);
begin
  InitCntrctdFileRtrvl;  { Contractor Completed Exam selection required again }
  ResetWndwTmr;
end;

procedure TExntdCntrctdBaseFormCheckIn.cmbx2507RqstsChange(Sender: TObject);
begin
  inherited;
  InitCntrctdFileRtrvl;  { Contractor Completed Exam selection required again }
end;

//procedure TExntdCntrctdBaseFormCheckIn.dtPckrCheckInChange(Sender: TObject);
//begin
//  ResetWndwTmr;
//  edDtPkrCheckIn.Text := DatetoStr(dtPckrCheckIn.Date);
//end;

//procedure TExntdCntrctdBaseFormCheckIn.dtPckrCheckInExit(Sender: TObject);
//var
//  msg: String;
//begin
//  msg := '';
//  ResetWndwTmr;
//  { Check for Valid Date }
// // edDtPkrCheckIn.Text := dtPckrCheckIn.Text;
//  if (dtPckrCheckIn.IsDateValid) then
//  begin
//    if (dtPckrCheckIn.Date > Date) then
//      msg := 'Future dates cannot be entered.' + #13#10 +
//           'Please enter a date on or before ' + DateTimeToStr(Date) + '.';
//  end
//  else
//    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrCheckIn.SetFocus;
//    dtPckrCheckIn.SelectAll;
//  end;  { End Error Occured, display message and reset focus }
//end;

//procedure TExntdCntrctdBaseFormCheckIn.dtPckrCheckInLookupSelect(
//  Sender: TObject; var Value: string);
//begin
//  inherited;
//  edDtPkrCheckIn.Text := dtPckrCheckIn.Text;
//end;

procedure TExntdCntrctdBaseFormCheckIn.edDtPkrCheckInExit(Sender: TObject);
var
  msg: String;
  s : string;
  MinDate : TDate;
begin
  msg := '';
  // validate text input in date field
  s := edDtPkrCheckIn.Text;
  MinDate := StrToDate('01/01/2000'); 
  DateComplete(s, MinDate, FALSE);
  edDtPkrCheckIn.Text := s;
  if copy(edDtPkrCheckIn.Text,1,4) = 'Min ' then
  begin
    edDtPkrCheckIn.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edDtPkrCheckIn.SetFocus;
  end;               
end;

procedure TExntdCntrctdBaseFormCheckIn.tmepckrCheckInChange(Sender: TObject);
begin
  ResetWndwTmr;
end;

procedure TExntdCntrctdBaseFormCheckIn.btnDateReceivedFromContractorClick(
  Sender: TObject);
var
  ADate : TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    frmVRSelectDate.MinimumDate := StrToDate('01/01/2000');  // editing - allow reasonable dates
    if TryStrToDate(edDtPkrCheckIn.Text,ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Today;
    frmVRSelectDate.ShowModal;
    edDtPkrCheckIn.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edDtPkrCheckIn) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TExntdCntrctdBaseFormCheckIn.btnGetCntrctdExamFileClick(
  Sender: TObject);
var
  ProdAccnt: Boolean;
begin
  ResetWndwTmr;
  { Clear Previous Vendor Results (File Paths and ASCII Exam Info
    Assists in Ensuring that the user selects the appropriate exam(s) }
  _CntrctdExmFilePths.Clear;
  _CntrctdExmRslts.Clear;
  ProdAccnt := IsProductionAccount(IntCCOWBrkrRef);
  { Prompt user for completed contracted exam info file - Disable for Test
    Accounts, Unless Development Test Account and user holds the Test Key:
    ZJFW CONTRACTED EXM TEST }
  if (ProdAccnt or ((Not ProdAccnt) and
       TUserInfo.UserHasKey(IntCCOWBrkrRef, 'ZJFW CONTRACTED EXM TEST'))) then
    GetCntrctdExamFiles
  else
    MessageDlgCAPRI('This functionality has been disabled on TEST accounts,' + #13#10 +
         'since the Broker Security Enhancements (BSE) used to reverse' + #13#10 +
         'lookup the Vendors SFTP information on CLAIMS is not readily supported.', mtWarning, [mbOK], 0);
  AllowAction;  { Determine if Check-In Button can be enabled }
end;

procedure TExntdCntrctdBaseFormCheckIn.btnRfrshRqstsClick(Sender: TObject);
begin
  inherited;
  InitCntrctdFileRtrvl;  { Contractor Completed Exam selection required again }
end;

procedure TExntdCntrctdBaseFormCheckIn.ExecuteBtnAction;
var
  i, dlgRslt: Integer;
  allExmsCmpltdCncld, rsltsExst: Boolean;
  exmObjLst: TStringList;
begin
  ResetWndwTmr;
  exmObjLst := TStringList.Create;  { List of Exam Objects to Check-In for Request }
  { Ensure Date Received from Contractor is greater than or equal to any
    check-out dates (Date sent to contractor) for the selected exams }
  if IsCheckInDateValid then
  begin
    rsltsExst := False;
    dlgRslt := mrNO;
    Refresh;
    { At Least One Record had to be selected to get here and Required Completed
      Vendor Results have been selected and validated to belong to this Patient }
      allExmsCmpltdCncld := CreateExamObjRefList(exmObjLst, rsltsExst);  { Get Checked Exam Info }
      if (rsltsExst) then
        dlgRslt := MessageDlg('Exam results already exist for the exam(s) selected.' + #13#10#13#10 +
             'Do you wish to OVERWRITE the existing Exam Results?' + #13#10 +
             'Note: NO will append the new results to the existing results for the exam.',
             mtConfirmation, [mbYES, mbNO, mbCANCEL], 0);
      try
        if (dlgRslt <> mrCANCEL) then
        begin
          Forms.Screen.Cursor := crHourGlass;
          { Add Check-In Date/Time (Current Date/Time used) / Vendor Completed
            Exam Results to each 2507 Exam that was externally contracted out. }
          try
            if CheckInExams(exmObjLst, allExmsCmpltdCncld, (dlgRslt = mrYES),
                 _CntrctdExmRslts) then
            begin
              Forms.Screen.Cursor := crHourGlass;  { Reset Cursor to HourGlass }
              { Archive Completed Exams on Vendor System }
              _SFTPConn.ArchiveFiles(_CntrctdExmFilePths);
            end
            else { Display Err Message to User - Previous Changes Backed Out in VistA }
              MessageDlgCAPRI('An error occurred while updating Request/Exam entries with contract info.' +
                  #13#10 + 'All exam(s) information previously selected have been returned to their original state.'
                  + #13#10 + 'Please try again later, if the problem persists consult IRM.',
                  mtError, [mbOK], 0);
          except
            on E: EVndrExmLngthError do
            begin
              MessageDlgCAPRI(E.Message, mtError, [mbOK], 0);
            end;  { End EVndrExmLngthError Exception Handling }
            on E: Exception do
            begin
              MessageDlgCAPRI('Unexpected error occurred: ' + #13#10 + E.Message +
                   'All exam(s) information previously selected have been returned to their original state.',
                   mtError, [mbOK], 0);
            end;  { End Remaining Other Types of Exception Handling }
          end;  { End Try/Except Block }
        end;  { End If Prompt if displayed not equal to cancel }
      finally
        { Free Object Memory - Regardless if error occurred }
        for i := 0 to exmObjLst.Count - 1 do
          TExamInfo(exmObjLst.Objects[i]).Destroy;
        exmObjLst.Free;
        Forms.Screen.Cursor := crDefault;
      end;  { End Try/finally block }
  end  { End If Date Received from Contractor is Valid }
  else
    ModalResult := mrNone;  { Don't close window - User select another date }
end;

procedure TExntdCntrctdBaseFormCheckIn.PopExamList(rqstIEN: string);
begin
  _RqstIEN := rqstIEN;
  _UpdtExmLst := True;
  PopExamList(rqstIEN, '');  { Load Initial, all applicable exams enabled }
end;

{ PRIVATE }

procedure TExntdCntrctdBaseFormCheckIn.AddVendorRsltsToExmRslts(Rslts: TStrings);
begin
{ Remove single empty line from results if exists prior to adding new results,
    add line break if more than 1 line or if 1 line and text exists. }
  if (fmMemoExmRslts.Lines.Count = 1) then
  begin
    if (Not SameText(Trim(fmMemoExmRslts.Lines[0]), '')) then
      { Insert Blank Line between old/new comments }
      fmMemoExmRslts.Lines.Add(fmMemoExmRslts.Lines.LineBreak)
    else
      fmMemoExmRslts.Lines.Clear();
  end  { End If only 1 line in exam results }
  else
    if (fmMemoExmRslts.Lines.Count > 0) then
      { Insert Blank Line between old/new comments }
      fmMemoExmRslts.Lines.Add(fmMemoExmRslts.Lines.LineBreak);
  { Add Completed Vendor Exam results in TFMMemo component for saving. }
  fmMemoExmRslts.Lines.AddStrings(Rslts);
end;

procedure TExntdCntrctdBaseFormCheckIn.PopExamList(rqstIEN: string; cntrctrSrchIEN: string);
var
  i: Integer;
  IEN, exmSts, cntrctrNme, cntrctrIEN: String;
begin
  { Components cleared in Base Class, but updates to the list in this class
    also require resetting which does NOT invoke the base class method }
  chkdLstBxExams.Items.Clear;
  _RqstCntrctrs.Clear;
  chkdLstBxExams.Items.BeginUpdate;
  { Add Exams for Request to list, enable only those entries which
    have been Checked-Out, but NOT Checked-In from the Contractor }
  for i := 0 to _fmTmpLstrExams.Results.Count - 1 do
  begin
    IEN := _fmTmpLstrExams.Results[i];
    exmSts := _fmTmpLstrExams.GetRecord(IEN).GetField('.04').FMDBExternal;
    { Internal value requested in lister call, but value still returned in External }
    cntrctrIEN := _fmTmpLstrExams.GetRecord(IEN).GetField('100').FMDBExternal;
    { Create List of Contractors Exams for Check-In }
    cntrctrNme := '';
    if Not SameText(cntrctrIEN, '') then
      cntrctrNme := ' - ' + fmLstrCntrctrs.GetRecord(cntrctrIEN).GetField('.01').FMDBExternal;
    chkdLstBxExams.Items.AddObject(_fmTmpLstrExams.GetRecord(IEN).GetField
        ('.03').FMDBExternal + ' [' + exmSts + cntrctrNme + ']',
      TObject(StrToInt(IEN)));
    { Show all Exams for request, but Disable Exam entries in list if the exam
      has been canceled (By MAS or RO), transferred out, completed, NOT been
      checked out to the Contractor or has already been Checked In from
      Contractor or exam does not belong to specific contractor if defined }
    if ((Not SameText(UpperCase(exmSts), 'OPEN')) or
        (SameText(_fmTmpLstrExams.GetRecord(IEN).GetField('101')
            .FMDBExternal, '')) or (Not SameText(_fmTmpLstrExams.GetRecord(IEN)
            .GetField('102').FMDBExternal, '')) or ((Not SameText(cntrctrSrchIEN, ''))
        and (Not SameText(_fmTmpLstrExams.GetRecord(IEN).GetField('100').FMDBExternal, cntrctrSrchIEN)))) then
      chkdLstBxExams.ItemEnabled[(chkdLstBxExams.Items.Count - 1)] := False
    else
    begin
      { Add to list for enabled items only - use hash style to throw out duplicates }
      _RqstCntrctrs.Values[Piece(cntrctrNme, '- ', 2) + '^' + cntrctrIEN] := cntrctrIEN;
      { If at least one exam is available, user can select contractor from list }
      { Note: Cannot mix exams from different contractors }
      chkBxCntrctAllExams.Enabled := True;
    end;  { End Else Enable Exam Item for Selection }
  end; { End For Loop }
  chkdLstBxExams.Items.EndUpdate;
  chkdLstBxExams.Repaint;
  PopContractorList;  { Pop List with Contractors who have check-out exams }
end;

procedure TExntdCntrctdBaseFormCheckIn.PopContractorList;
var
  i: Integer;
begin
  _RqstCntrctrs.Sort;  { Sort List Alphabetically }
  { Pop list with only contractors that have been assigned an exam on the
    request, which has NOT already been checked out. }
  cmbBxContractors.Items.Clear;
  if (_RqstCntrctrs.Count > 0) then
  begin
    for i := 0 to _RqstCntrctrs.Count - 1 do
      cmbBxContractors.items.Add(Piece(_RqstCntrctrs[i], '^'));
    cmbBxContractors.ItemIndex := 0;
  end;  { End If Contractors Exist in List }
end;

procedure TExntdCntrctdBaseFormCheckIn.GetCntrctdExamFiles;
var
  i: Integer;
  tmpDir, cntrctrInfo: String;
  LstVndrCrtnDTM: TDateTime;
  curItm: TListItem;
  VndrFleDlg: TvndrExmsRtrvlDlg;
  VldtVndrExmRsltsDlg: TdlgVndrExamRslts;
begin
  cntrctrInfo := GetContractorInfo;  { Get Contractor Name ^ IEN ^ Remote IEN}
  if Not SameText(Piece(cntrctrInfo, '^', 3), '') then
  begin
    VndrFleDlg := nil;
    VldtVndrExmRsltsDlg := nil;
    try
      Forms.Screen.Cursor := crHourGlass;
      try
        tmrWndwClose.Enabled := False;
        if Assigned(_SFTPConn) then begin // DONE: LMS memory leak potential
          FreeAndNil(_SFTPConn);
        end;
        { Always reset connection in case Vendor selection changed }
        _SFTPConn := TSFTPConn.Create(Piece(cntrctrInfo, '^', 3), True, IntCCOWBrkrRef);
        VndrFleDlg := TvndrExmsRtrvlDlg.Create(self, Piece(cntrctrInfo, '^', 1), False,
             _SFTPConn, tmrWndwClose.Interval);

        if (VndrFleDlg.ShowModal = mrOk) then
        begin
          tmpDir := GetTempExmDir(IntCCOWBrkrRef.User.DUZ);  { Get temporary holding location for downloaded exams }
          curItm := VndrFleDlg.lstVwVndrFiles.Selected;
          LstVndrCrtnDTM := TElSftpFileInfo(curItm.Data).Attributes.CTime;
          for i := 0 to VndrFleDlg.lstVwVndrFiles.SelCount - 1 do
          begin
            { SFTP Vendor Location ^ Temporary Local Machine Location }
            _CntrctdExmFilePths.Add(_SFTPConn.AbsPath(TElSftpFileInfo(curItm.Data).Name) +
                 '^' + tmpDir + '\' + TElSftpFileInfo(curItm.Data).Name);
            { Use Creation Date of Selected Document(s) to default Check-In Date too
              Date will automatically be defaulted when user validates documents below }
            if LstVndrCrtnDTM < TElSftpFileInfo(curItm.Data).Attributes.CTime then
              LstVndrCrtnDTM := TElSftpFileInfo(curItm.Data).Attributes.CTime;
            curItm := VndrFleDlg.lstVwVndrFiles.GetNextItem(curItm, sdBelow, [isSelected]);
          end;  { End For Loop through Selected Items }
          Refresh;
          { User required to validate contractor results, to ensure correct patient
            exam results retrieved, prior to continuing with CheckIn process }
          Forms.Screen.Cursor := crHourGlass;
          VldtVndrExmRsltsDlg := TdlgVndrExamRslts.Create(self, _PtntInfo,
               _CntrctdExmFilePths, _SFTPConn, tmrWndwClose.Interval);
          if (VldtVndrExmRsltsDlg.ShowModal = mrYes) then
          begin
            _CntrctdExmRslts.AddStrings(VldtVndrExmRsltsDlg.fmMemoExmRslts.Lines);
//            dtPckrCheckIn.Date := LstVndrCrtnDTM;  { Set Default Check-In Date }
//            dtPckrCheckInExit(nil);  { Validate Creation Date - Should never error }
              edDtPkrCheckIn.Text := DateToStr(LstVndrCrtnDTM);  // Set Default Check-In Date
          end  { End If User Validated Document as correct }
          else  { User Closed form without explicitly clicking Ok }
            _CntrctdExmFilePths.Clear;
        end;  { End If User Clicked Ok - At least 1 file had to be selected }
      except
        on E: Exception do
        begin
          Application.MessageBox(PChar(E.Message), 'SFTP Error', MB_OK);
          if Assigned(_SFTPConn) then begin // DONE: LMS memory leak potential
            FreeAndNil(_SFTPConn);
          end;
        end;  { End Exception Handling }
      end;  { End Inner Try/Except Block for Initializing SFTP Connection }
    finally
      ResetWndwTmr;
      if Assigned(VndrFleDlg) then
        VndrFleDlg.Free;
      if Assigned(VldtVndrExmRsltsDlg) then
        VldtVndrExmRsltsDlg.Free;
      Forms.Screen.Cursor := crDefault;
    end;  { End Outer Try/Finally Block }
  end { End If Selected Contractor has assigned Remote IEN }
  else
    Application.MessageBox(PChar('The selected contractor (' + Piece(cntrctrInfo, '^', 1) +
         ') is NOT associated with a Remote SFTP entry for connection to the Vendors ' +
         'system.' + #13#10 + 'Edit the contractor information ' +
         '(AdminTools - Add/Edit Contractors) to include a Remote SFTP entry.'),
         'Missing Remote Connection', MB_OK);
end;

(* // DONE: LMS refactored out
function TExntdCntrctdBaseFormCheckIn.GetTempExmDir(): String;
begin
  Result := GetTempDir;  { Windows Temp Directory }
  Result := Result + 'demTranTemp\' + _CCOWBrkr.User.DUZ;
  if (Not DirectoryExists(Result)) then
  begin
    { Create SubDirectory for File Attachements }
    CreateDir(Result);
    if (Not DirectoryExists(Result)) then
      ForceDirectories(Result);
  end;  { End If Directory does not exists }
end;
*)

procedure TExntdCntrctdBaseFormCheckIn.InitCntrctdFileRtrvl;
begin
  chkBxCntrctAllExamsClick(self);  { Ensures Buttons are correctly set }
end;

procedure TExntdCntrctdBaseFormCheckIn.AllowAction;
begin
  inherited;
  btnGetCntrctdExamFile.Enabled := (chkBxCntrctAllExams.Checked or
       (GetCheckedCount(chkdLstBxExams) > 0));
  { Selection of vendor completed exam result(s) is required to check-in }
  btnAction.Enabled := (btnAction.Enabled and (_CntrctdExmFilePths.Count > 0));
end;

function TExntdCntrctdBaseFormCheckIn.CheckInExams(exmObjLst: TStringList;
     allExmsCmpltdCncld: Boolean; OverWriteRslts: Boolean; VRslts: TStrings): Boolean;
const
  ADDTNLEXMRSLTS  = 'Please refer to the exam report contained in: ';
var
  i: Integer;
  err: Boolean;
  aExmRslts: TStrings;
  exmIEN, exmNme, chkInDTM: String;
begin
  err := False;
  i := -1;
  chkInDtm := DelphiDateToFMInternal(StrToDate(edDtPkrCheckIn.Text));
  try
    repeat
      inc(i);
      exmIEN := exmObjLst[i];
      fmMemoExmRslts.Lines.Clear;
      { Set Memo to Exam's Current results (Could be empty) if NOT Overwriting }
      if Not(OverWriteRslts) then
        fmMemoExmRslts.Lines.Assign(TExamInfo(exmObjLst.Objects[i]).GetExamResults);
      { Save off Exam Name in case mulitple exams selected for check-in and
        Add Vendor Exam Results Info or pointer to exam results in to TFMMemo.
        More than 1 Exam selected will cause remaining exam results to point
        back to the initial exam that has the complete vendor exam results. }
      if (i = 0) then
      begin
        exmNme := _fmTmpLstrExams.GetRecord(exmIEN).GetField('.03').FMDBExternal;
        AddVendorRsltsToExmRslts(VRslts);  { Only add results to initial exam }
      end
      else
      begin
        aExmRslts := TStringList.Create;
        aExmRslts.Add(ADDTNLEXMRSLTS);
        aExmRslts.Add(exmNme);
        AddVendorRsltsToExmRslts(aExmRslts);
        aExmRslts.Clear;
        aExmRslts.Free;
      end;  { Add Pointer Exam Results to Memo for subsequent selected exams }
      try
        err := Not _2507Info.CheckInExam(exmIEN, chkInDTM, fmMemoExmRslts);
      except
        on E: Exception do
        begin
          err := True;  { So any previously modified exams are restored }
          { Handle Exception where the length of one or more lines in the Vendors
            completed exam text file to be uploaded exceeds 999 characters in length. }
          raise EVndrExmLngthError.Create('The length of one or more lines in the Vendors ASCII text file ' +
               'is greater than 999 characters.' + #13#10 + 'Contact the Vendor to ' +
               'have the file(s) corrected before trying to complete the check-in for this request again.');
        end;  { End Exception Handling }
      end;  { End Inner Try/Except Block }
    until ((i = (exmObjLst.Count - 1)) or err);
    { No Errors and All Exams Completed/Cancelled - Set Request Status to 'P' }
    if (Not err) and allExmsCmpltdCncld then
      _2507Info.UpdtRqstStatus(fmCmbBx2507Rqsts.GetSelectedRecord.IEN, 'P');
  finally
    if err then  { Error - restore modified exams to original state }
      for i := 0 to exmObjLst.Count - 1 do
      begin
        exmIEN := exmObjLst[i];
        { Retrieve ORIGINAL exam results to restore }
        fmMemoExmRslts.Lines.Assign(TExamInfo(exmObjLst.Objects[i]).GetExamResults);
        _2507Info.CheckInExam(exmIEN, '@', fmMemoExmRslts);
      end; { End Modified Exam List Loop }
  end;  { End Outer Try/Finally Block }
  Result := Not err;
end;

function TExntdCntrctdBaseFormCheckIn.IsCheckInDateValid(): Boolean;
var
  i: Integer;
  exmIEN, dteChkIn: String;
  dte, slctdDte, lstDte: TDateTime;
begin
  Result := True;
//  slctdDte := dtPckrCheckIn.Date;
  slctdDte := StrToDate(edDtPkrCheckIn.text);
  lstDte := 2.25;  { Initialize to 1/1/1900 - to remove warning from compiler }
  i := -1;
  repeat
    inc(i);
    if chkdLstBxExams.ItemEnabled[i] then
    begin
      exmIEN := IntToStr(Integer(chkdLstBxExams.Items.Objects[i]));
      if (chkdLstBxExams.Checked[i] or (chkBxCntrctAllExams.Checked and
           SameText(Piece(_RqstCntrctrs[cmbBxContractors.ItemIndex], '=', 2),
           _fmTmpLstrExams.GetRecord(exmIEN).GetField('100').FMDBExternal))) then
      begin
        dteChkIn := FMInternalToDelphiDate(Piece(_fmTmpLstrExams.
             GetRecord(exmIEN).GetField('101').FMDBExternal, '.'));
        if (Not SameText(dteChkIn, '')) then
          try
            dte := StrToDate(dteChkIn);
            if (dte > slctdDte) then
            begin
              Result := False;
              if (dte > lstDte) then
                lstDte := dte;  { Save Latest Date in Exam list for user }
            end;  { End If Check-Out Date is greater than Check-In Date Selected }
          except
            { Do Nothing on EConvertErrors }
          end;
      end  { End If Exam Item Checked or All Exams Checked for selected Contractor }
    end;  { End If Exam Item Enabled - Indicates can be checked out }
  until (i = (chkdLstBxExams.Items.Count - 1));
  if Not Result then
    MessageDlgCAPRI('The selected date received from the contractor precedes' + #13#10 +
         'the sent to contractor date for one or more exams.' + #13#10 +
         'The date received from the contractor must be equal to or' + #13#10 +
         'greater than, ' + FormatDateTime('mmm dd, yyyy', lstdte)  +
         ', to proceed with check-in processing.' + #13#10#13#10 +
         'Please correct the date and check-in the exam(s) again.', mtError, [mbOK], 0);
  { Prompt to ensure correct date selected if today }
  if Result and (CompareDate(slctdDte, Date) = 0) then
    if (MessageDlgCAPRI('The selected date received from the contractor is today.' +
         #13#10#13#10 + 'Is this the actual date the exam(s) was received back?',
         mtConfirmation, [mbYes, mbNo], 0) = mrNo) then
      Result := False;  { Allow user to fix date }
end;

// DONE: LMS move into untMiscMthds as likely the most appropriate unit
(*
function TExntdCntrctdBaseFormCheckIn.IsDateValid(aDateStr: string): Boolean;
var
  aDate : TDateTime;
begin
  Result := TryStrToDate(aDateStr, aDate);
  (* DONE: LMS more efficient implementation
  try
    aDate := StrToDate(aDateStr);
    Result := true;
  except on e:exception do
    Result := false;
  end;
  *)(*
end;*)

function TExntdCntrctdBaseFormCheckIn.CreateExamObjRefList(exmObjLst: TStringList;
     Var rsltsExst: Boolean): Boolean;
var
  i: Integer;
  exmSlctd: Boolean;
  exmIEN, exmSts: String;
begin
  i := -1;
  Result := True;  { All Exams are in a Completed / Cancelled State }
  rsltsExst := False; { No Exams have stored results 396.4.70 }
  repeat
    inc(i);
    exmIEN := IntToStr(Integer(chkdLstBxExams.Items.Objects[i]));
    exmSts := UpperCase(_fmTmpLstrExams.GetRecord(exmIEN).GetField('.04').FMDBExternal);
    exmSlctd := (chkdLstBxExams.ItemEnabled[i] and (chkdLstBxExams.Checked[i] or
         (chkBxCntrctAllExams.Checked and
         SameText(Piece(_RqstCntrctrs[cmbBxContractors.ItemIndex], '=', 2),
         _fmTmpLstrExams.GetRecord(exmIEN).GetField('100').FMDBExternal))));
    { Request will be set to "P" (Pending, Reported) if ALL exams for the
      request are in a completed or cancelled state. Selected exams will
      be moved to a completed state upon check-in. }
    if ((Not (SameText(exmSts, 'COMPLETED') or SameText(exmSts, 'CANCELED BY MAS') or
         SameText(exmSts, 'CANCELED BY RO'))) and (Not exmSlctd)) then
      Result := False;
    { Exam must be enabled and checked or Contractor Checked to be acted upon }
    if exmSlctd then
    begin
      fmMemoExmRslts.Lines.Clear();
      { Retrieve current exam results to restore if error occurs and to
        determine Overwrite/Append. }
      _2507Info.Get2507WPInfo('396.4', '70', exmIEN, fmMemoExmRslts);
      if Not(rsltsExst) then
        rsltsExst := ((fmMemoExmRslts.Lines.Count > 1) or ((fmMemoExmRslts.Lines.Count = 1)
             and (Not SameText(Trim(fmMemoExmRslts.Lines[0]), ''))));
      { Store Exam Object Info }
      exmObjLst.AddObject(exmIEN, TExamInfo.Create(exmIEN, 'COMPLETE',
           _fmTmpLstrExams.GetRecord(exmIEN).GetField('102').FMDBExternal,        // DONE: LMS CodeCR533 changed field back to 102. BEST had changed to use field 90 but 90's meaning is different and it was updated via AMIE only in the past and not in CAPRI. If it's filled then CAPRI in tuisign.pas screen thinks that the exam is "transcribed" and hence can't be auto-released. To this users object since they want to auto-release as many vendor sent exams as possible. Also see references to field 90 in demTranMain.pas
           fmMemoExmRslts.Lines));
    end;  { End If Exam Item Checked or All Exams Checked for selected Contractor }
  until (i = (chkdLstBxExams.Items.Count - 1));
end;

{ Retrieve the Current Selected Contractor Info
  Input: N/A
  Output: Contractor Name ^ Contractor IEN ^ Remote IEN for Contractor }
function TExntdCntrctdBaseFormCheckIn.GetContractorInfo(): String;
var
  i: Integer;
  IEN: String;
begin
  Result := '';
  { Determine Contractor Name }
  if chkBxCntrctAllExams.Checked then
  begin
    IEN := Piece(_RqstCntrctrs[cmbBxContractors.ItemIndex], '=', 2);  { Contractor IEN }
    Result := cmbBxContractors.Text;
    Result := Result + '^' + IEN + '^' + fmLstrCntrctrs.GetRecord(IEN).GetField('3').FMDBExternal;
  end  { End If Contractor Selected from ComboBox Selection }
  else
    for i := 0 to chkdLstBxExams.Items.Count - 1 do
    begin
      if (chkdLstBxExams.ItemEnabled[i] and chkdLstBxExams.Checked[i]) then
      begin
        IEN := _fmTmpLstrExams.Results[i];  { Exam IEN }
        IEN := _fmTmpLstrExams.GetRecord(IEN).GetField('100').FMDBExternal;  { Contractor IEN }
        Result := fmLstrCntrctrs.GetRecord(IEN).GetField('.01').FMDBExternal +
             '^' + IEN + '^' + fmLstrCntrctrs.GetRecord(IEN).GetField('3').FMDBExternal;
        break;  { Jump out of loop as only 1 contractor's exams allowed to be selected }
      end;  { End If Exam Item enabled and checked }
    end;  { End For Loop through Exams - Exam Selection (NOT Vendor Selection) }
end;

function TExntdCntrctdBaseFormCheckIn.GetDateOfText(aDateStr,
  defaultDate: string): TDateTime;
begin
  try
    Result := StrToDate(aDateStr)
  except on e:exception do
    try
      Result := StrToDate(defaultDate);
    except on e2:exception do
      Result := StrToDate('1/1/1800');
    end;
  end;
end;

procedure TExntdCntrctdBaseFormCheckIn.DateComplete(var StrLikeDate: string;
  MinDate: TDate; const NowIfError: Boolean);
var
   DateStr : string;
   Year, Month, Day : Word;
   cnt, SepCount : Integer;
begin
   DateStr := StrLikeDate;
   if DateStr = '' then
      Exit;
   SepCount := 0;
   for cnt := 1 to Length(DateStr) do
   begin
     if not (DateStr[cnt] in ['0'..'9']) then
     begin
       DateStr[cnt] := DateSeparator;
       inc(SepCount);
     end;
   end;
   while (DateStr <> '') and (DateStr[Length(DateStr)]=DateSeparator) do
   begin
     Delete(DateStr, Length(DateStr),1);
     Dec(SepCount);
   end;
   DecodeDate(Now,Year,Month,Day);
   if SepCount = 0 then
   begin
     case Length(DateStr) of
       0   : DateStr := DateToStr(Now);
       1, 2: DateStr := DateStr+DateSeparator+IntToStr(Day);
//     1, 2: DateStr := DateStr+DateSeparator+IntToStr(Month);  // use this if short date format is dd/mm/yyyy
       4   : Insert(DateSeparator, DateStr, 3);
       6, 8: begin
             Insert(DateSeparator, DateStr, 5);
             Insert(DateSeparator, DateStr, 3);
             end; 
     end; // case
   end; // if SepCount
   try
     StrLikeDate := FormatDateTime('mm/dd/yyyy',StrToDate(DateStr));
   Except
     if NowIfError = TRUE then
     begin
      StrLikeDate := DateToStr(Date)
     end
     else
        StrLikeDate := '';
   end;
   // Date is valid, check for greater than minimum date
   if StrToDate(DateStr) < MinDate then
      StrLikeDate := 'Min ' + StrLikeDate;
end;

end.
