unit frmContractorEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Fmcntrls, Fmcmpnts,
  CCOWRPCBrokerCAPRI,     // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
  ExtCtrls, Diaccess, StdCtrls,
  dialogsCAPRI, untBrkrMthds, untMiscMthds, clsUserInfo;

type
  TContractorEditorForm = class(TForm)
    fmLstrCntrctrs: TFMLister;
    tmrWndwClose: TTimer;
    tmrEnsrBrkrCnnctd: TTimer;
    fmGetsCntrctrInfo: TFMGets;
    fmVldtrCntrctrInfo: TFMValidator;
    fmFlrCntrctrInfo: TFMFiler;
    btnSave: TButton;
    btnCancel: TButton;
    btnClose: TButton;
    btnNew: TButton;
    grpBxCntrctrInfo: TGroupBox;
    fmTxtBxName: TFMEdit;
    cmbBxStatus: TComboBox;
    fmTxtBxEmlAddrss: TFMEdit;
    fmRdoGrpStatus: TFMRadioGroup;
    pnlCntrctrs: TPanel;
    fmCmbBxContractor: TFMComboBox;
    cmbBxContractor: TComboBox;
    Label1: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Panel3: TPanel;
    Label4: TLabel;
    pnlRmtSFTP: TPanel;
    Label6: TLabel;
    fmCmbBxSFTPInfo: TFMComboBox;
    cmbBxSFTPInfo: TComboBox;
    fmLstrSFTPInfo: TFMLister;
    fmTxtBxRmtCntrctrIEN: TFMEdit;
    procedure fmCmbBxContractorKeyPress(Sender: TObject; var Key: Char);
    procedure fmCmbBxContractorChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure fmTxtBxNameKeyPress(Sender: TObject; var Key: Char);
    procedure fmTxtBxEmlAddrssKeyPress(Sender: TObject; var Key: Char);
    procedure fmTxtBxEmlAddrssChange(Sender: TObject);
    procedure fmTxtBxNameChange(Sender: TObject);
    procedure cmbBxStatusChange(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure cmbBxContractorChange(Sender: TObject);
    procedure cmbBxSFTPInfoChange(Sender: TObject);
    procedure cmbBxSFTPInfoKeyPress(Sender: TObject; var Key: Char);
    procedure cmbBxSFTPInfoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    _CCOWBrkr: TCCOWRPCBrokerCAPRI;
    function IsOkToAdd(Cntrctr: String): Boolean;
    procedure ClearCntrctrInfo;
    procedure EnbleCntrctrSave;
    procedure GetClaimsSFTPContractors;
    procedure PopCntrctrLst;
    procedure ResetForm;
    procedure ResetTmrs;
    procedure SetFMNew;
    procedure SyncCmbBxFMSetOfCodes(FMRdoGp: TFMRadioGroup; CmbBx: TComboBox);
    procedure SyncCmbBxFMTEdit(FMCmbBx: TFMComboBox; TxtBx: TFMEdit);
    procedure ValKeyPress(var Key: Char);
    procedure ValTxtPaste(txtBx: TFMEdit);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; CCOWBrkr: TCCOWRPCBrokerCAPRI;
         TmrVal: Cardinal); reintroduce;
    destructor Destroy; override;
  end;

var
  ContractorEditorForm: TContractorEditorForm;

implementation

{$R *.dfm}

{ PUBLIC }

constructor TContractorEditorForm.Create(AOwner: TComponent; CCOWBrkr: TCCOWRPCBrokerCAPRI;
     TmrVal: Cardinal);
begin
  inherited Create(AOwner);
  _CCOWBrkr := CCOWBrkr;
  fmLstrCntrctrs.RPCBroker := _CCOWBrkr;
  fmGetsCntrctrInfo.RPCBroker := _CCOWBrkr;
  fmVldtrCntrctrInfo.RPCBroker := _CCOWBrkr;
  fmFlrCntrctrInfo.RPCBroker := _CCOWBrkr;
  tmrWndwClose.Interval := TmrVal;
end;

destructor TContractorEditorForm.Destroy;
begin
  inherited;
end;

{ EVENTS }

procedure TContractorEditorForm.fmCmbBxContractorChange(Sender: TObject);
begin
  ResetTmrs;
  { Get Selected Contractor IEN and populate information }
  fmGetsCntrctrInfo.IENS := fmCmbBxContractor.GetSelectedRecord.IEN;
  fmGetsCntrctrInfo.GetAndFill;
  { Update Contractor Status Manually to match FMSetofCodes }
  cmbBxStatus.ItemIndex := fmRdoGrpStatus.ItemIndex;
  { Update Remote SFTP Entry Manually to match TFMEdit (Free Text) Entry }
  if SameText(fmTxtBxRmtCntrctrIEN.Text, '') then
    fmCmbBxSFTPInfo.ItemIndex := -1
  else
    fmCmbBxSFTPInfo.ItemIndex := GetItemIndex(fmCmbBxSFTPInfo, fmTxtBxRmtCntrctrIEN.Text);
  cmbBxSFTPInfo.ItemIndex := fmCmbBxSFTPInfo.ItemIndex;  { Sync Displayed Combobox }
  fmFlrCntrctrInfo.Clear;  { Clear Cntrls after loading new record }
end;

procedure TContractorEditorForm.fmCmbBxContractorKeyPress(Sender: TObject;
  var Key: Char);
begin
  ResetTmrs;
  Key := #0; { Prevent Key Events, as style cannot be changed to dropdownlist }
end;

procedure TContractorEditorForm.fmTxtBxEmlAddrssChange(Sender: TObject);
begin
  ValTxtPaste(fmTxtBxEmlAddrss);
end;

procedure TContractorEditorForm.fmTxtBxEmlAddrssKeyPress(Sender: TObject;
  var Key: Char);
begin
  ValKeyPress(Key);
end;

procedure TContractorEditorForm.fmTxtBxNameChange(Sender: TObject);
begin
  ValTxtPaste(fmTxtBxName);
  EnbleCntrctrSave;  { Determine if user can save new/modified contractor }
end;

procedure TContractorEditorForm.fmTxtBxNameKeyPress(Sender: TObject;
  var Key: Char);
begin
  ValKeyPress(Key);
end;

procedure TContractorEditorForm.btnNewClick(Sender: TObject);
begin
  ResetTmrs;
  cmbBxContractor.Enabled := False;
  ClearCntrctrInfo;
  SetFMNew;  { Set Cntrls IENS to create New Record when saved }
  cmbBxStatus.ItemIndex := 0;  { Set initial value to Active }
  cmbBxSFTPInfo.ItemIndex := -1;  { Set initial value to blank }
  SyncCmbBxFMSetOfCodes(fmRdoGrpStatus, cmbBxStatus);
  EnbleCntrctrSave;
  fmTxtBxName.SetFocus;
end;

procedure TContractorEditorForm.cmbBxContractorChange(Sender: TObject);
begin
  { Keep fmCmbBx in Sync with displayed CmbBx for 508 }
  fmCmbBxContractor.ItemIndex := cmbBxContractor.ItemIndex;
  fmCmbBxContractorChange(Sender);
end;

procedure TContractorEditorForm.cmbBxSFTPInfoChange(Sender: TObject);
begin
  { Keep fmCmbBx/TFMEdit in Sync with displayed CmbBx for 508 }
  SyncCmbBxFMTEdit(fmCmbBxSFTPInfo, fmTxtBxRmtCntrctrIEN);
end;

procedure TContractorEditorForm.cmbBxSFTPInfoKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  { If user presses the Delete Key set index to -1 so NO value shows }
  if (Key = VK_Delete) then
  begin
    cmbBxSFTPInfo.ItemIndex := -1;
    cmbBxSFTPInfoChange(Sender);
  end;  { End If Delete Button Pressed }
end;

procedure TContractorEditorForm.cmbBxSFTPInfoKeyPress(Sender: TObject;
  var Key: Char);
begin
  { If user presses the Backspace Key set index to -1 so NO value shows }
  if (Key = #8) then
  begin
    cmbBxSFTPInfo.ItemIndex := -1;
    cmbBxSFTPInfoChange(Sender);
  end;  { End If Backspace Button Pressed }
end;

procedure TContractorEditorForm.cmbBxStatusChange(Sender: TObject);
begin
  SyncCmbBxFMSetOfCodes(fmRdoGrpStatus, cmbBxStatus);  { Sync controls }
end;

procedure TContractorEditorForm.btnSaveClick(Sender: TObject);
var
  indx: Integer;
  curSlctn: String;
begin
  ResetTmrs;
  { Remove any Leading and Trailing Spaces from text boxes before saving }
  fmTxtBxName.Text := Trim(fmTxtBxName.Text);
  fmTxtBxEmlAddrss.Text := Trim(fmTxtBxEmlAddrss.Text);
  curSlctn := fmTxtBxName.Text;  { Current Item being created/edited }
  if fmFlrCntrctrInfo.AnythingToFile then
    if IsOkToAdd(curSlctn) then  { Check for duplicates and prompt user to continue }
      if fmFlrCntrctrInfo.Update then
      begin
        ShowMessageCAPRI('Contractor changes saved to VistA successfully.');
        cmbBxContractor.Enabled := True; { Disabled if NEW }
        { Refresh Contractor List - User required to inactivate, no deletions }
        ResetForm;
        { Set contractor selection to last referenced }
        indx := fmCmbBxContractor.Items.IndexOf(curSlctn);
        if (indx < 0) then
          indx := 0;  { Set to top record if value not found in list (Shouldn't Occur) }
        fmCmbBxContractor.ItemIndex := indx;
        cmbBxContractor.ItemIndex := indx;
        fmCmbBxContractorChange(self);  { Refresh Data in Cntrls }
      end  { End If Changes Saved to VistA }
      else
        fmFlrCntrctrInfo.DisplayErrors
    else
    begin
      fmTxtBxName.SelectAll;
      fmTxtBxName.SetFocus;
    end  { End If Duplicate Contractor Found }
  else
  begin
    ShowMessageCAPRI('No contractor changes to file in VistA.');
    btnCancelClick(Self);
  end;  { End Else No Changes to Save }
end;

procedure TContractorEditorForm.btnCancelClick(Sender: TObject);
begin
  ResetTmrs;
  cmbBxContractor.Enabled := True;
  { Redisplay current selection else leave blank if no contractors exist }
  if (fmCmbBxContractor.ItemIndex <> -1) then
  begin
    fmCmbBxContractorChange(self);
    cmbBxContractor.ItemIndex := fmCmbBxContractor.ItemIndex;
    cmbBxContractor.SetFocus;
  end  { End If Contractors Exist in List }
  else
  begin
    ClearCntrctrInfo;  { Clear Contractor Info }
    btnNew.SetFocus;
  end;  { End If NO Contractors Exist in List }
end;

procedure TContractorEditorForm.FormShow(Sender: TObject);
begin
  GetClaimsSFTPContractors;  { Get SFTP Contractors from Central Remote System - CLAIMS }
  ResetForm;
end;

{ PRIVATE }

procedure TContractorEditorForm.ClearCntrctrInfo;
begin
  fmTxtBxName.Text := '';
  cmbBxStatus.ItemIndex := -1;
  fmTxtBxEmlAddrss.Text := '';
  cmbBxSFTPInfo.ItemIndex := -1;
end;

procedure TContractorEditorForm.SetFMNew;
begin
  fmTxtBxName.IENS := '+1,';  { Creates New Record when filed }
  fmRdoGrpStatus.IENS := '+1';
  fmTxtBxEmlAddrss.IENS := '+1';
  fmTxtBxRmtCntrctrIEN.IENS := '+1';
end;

procedure TContractorEditorForm.ResetForm;
begin
  PopCntrctrLst;  { Retrieve all contractors (Active/Inactive) }
  if (fmCmbBxContractor.Items.Count > 0) then
  begin
    cmbBxContractor.ItemIndex := 0;
    fmCmbBxContractor.ItemIndex := 0;
    fmCmbBxContractorChange(self);
    cmbBxContractor.SetFocus;
  end  { End If Contractors Exist }
  else
    btnNewClick(self);
  { Disable Save button if NO contractors exist }
  btnSave.Enabled := (fmCmbBxContractor.Items.Count > 0);
end;

procedure TContractorEditorForm.ResetTmrs;
begin
  tmrWndwClose.Enabled := False;
  tmrEnsrBrkrCnnctd.Enabled := False;
  tmrWndwClose.Enabled := True;
  tmrEnsrBrkrCnnctd.Enabled := True;
end;

procedure TContractorEditorForm.PopCntrctrLst;
begin
  fmCmbBxContractor.Text := '';
  fmCmbBxContractor.Items.Clear;
  fmCmbBxContractor.GetList;
  cmbBxContractor.Items.Clear;
  cmbBxContractor.Items.AddStrings(fmCmbBxContractor.Items);
end;

procedure TContractorEditorForm.ValKeyPress(var Key: Char);
begin
  ResetTmrs;
  if (((Length(fmTxtBxName.Text) = 0) or (fmTxtBxName.SelStart = 0)) and (Key = #32)) then
    Key := #0;  { Prevent space in first position of text }
  if (Key = #94) then
    Key := #0;  { Prevent '^' from being used, as it is a FM Delimiter }
end;

procedure TContractorEditorForm.ValTxtPaste(txtBx: TFMEdit);
var
  crtPos: Integer;
  modTxtVal: String;
begin
  ResetTmrs;
  crtPos := txtBx.SelStart;
  { Ensure's valid pasted text content }
  modTxtVal := TrimLeft(txtBx.Text);  { Remove Leading spaces }
  { Remove '^' from string as they interfere with FM Delimiter }
  modTxtVal := StringReplace(modTxtVal, '^', '', [rfReplaceAll, rfIgnoreCase]);
  if (Not SameText(txtBx.Text, modTxtVal)) then
    txtBx.Text := modTxtVal;  { Update only if value changed }
  txtBx.SelStart := crtPos;  { Reset Caret Position in case value changed }
end;

procedure TContractorEditorForm.EnbleCntrctrSave;
begin
  { Ensure Name is greater than or equal to 3 chars before enabling Save Button.
    Note: Status should always reflect a value, so don't check.
          Email Address can be null, but will require user to manually enter
          when message is generated to send. }
  btnSave.Enabled := (Length(fmTxtBxName.Text) > 2)
end;

procedure TContractorEditorForm.SyncCmbBxFMSetOfCodes(FMRdoGp: TFMRadioGroup;
     CmbBx: TComboBox);
{ Fileman components don't support combobox for set of codes. Combobox will
  be used as it conforms nicer to layout. Radio Button Panel is hidden and
  needs to be kept in sync with the combobox to allow ease of filing using
  the FMFiler component. }
begin
  ResetTmrs;
  FMRdoGp.ItemIndex := CmbBx.ItemIndex;
  FMRdoGp.Validate;
  fmFlrCntrctrInfo.AddChgdControl(FMRdoGp);
end;

procedure TContractorEditorForm.SyncCmbBxFMTEdit(FMCmbBx: TFMComboBox; TxtBx: TFMEdit);
{ Text Box is hidden and needs to be kept in sync with the FM and Delphi
  ComboBoxes to allow for eas of filing using the FMFiler component. }
begin
  ResetTmrs;
  FMCmbBx.ItemIndex := cmbBxSFTPInfo.ItemIndex;
  { Update Text to ensure correct value get's filed with Record on save }
  if (FMCmbBx.ItemIndex >= 0) then
    TxtBx.Text := FMCmbBx.GetSelectedRecord.IEN
  else
    TxtBx.Text := '';
  TxtBx.Validate;
  fmFlrCntrctrInfo.AddChgdControl(TxtBx);
end;

function TContractorEditorForm.IsOkToAdd(Cntrctr: string): Boolean;
begin
  Result := True;
  { Only execute if new record being added or existing Contractor name was edited }
  if (SameText(fmTxtBxName.IENS, '+1,')) or Not SameText(fmTxtBxName.FMDBExternal, Cntrctr) then
  begin
    { Check for existing record }
    if (fmCmbBxContractor.Items.IndexOf(Cntrctr) >= 0) then
    begin
      if MessageDlgCAPRI('A contractor with the name, ' + Cntrctr + ', already exists.' +
           #13#10 + 'Creation of duplicate contractors is not recommended.' +
           #13#10#13#10 + 'Do you still want to save this duplicate contractor?',
           mtConfirmation, [mbYes, mbNo], 0) = mrNo then
        Result := False;
    end;  { End If Duplicate Contractor Record Found }
  end;  { End If New Contractor Record being added }
end;

procedure TContractorEditorForm.GetClaimsSFTPContractors;
var
  err, ProdAccnt: Boolean;
  ClmsSysCCOWBrkr: TCCOWRPCBrokerCAPRI;
  msg: String;
begin
  err := False;
  msg := 'Unable to connect to CLAIMS system to retrieve SFTP Contractor entries.' +
         #13#10 + 'Linking to remote SFTP connections will be disabled.' + #13#10 +
         'Try accessing the Contractor Editor again later. If the problem persists contact IRM.';
  ClmsSysCCOWBrkr := TCCOWRPCBrokerCAPRI.Create(nil);  { Remote Broker Object }
  ProdAccnt := IsProductionAccount(_CCOWBrkr);  { Determine Account }
  try
    { Disable retrieval for Test Accounts, Unless Development Test Account
      and user holds the Test Key: ZJFW CONTRACTED EXM TEST }
    if (ProdAccnt or ((Not ProdAccnt) and
       TUserInfo.UserHasKey(_CCOWBrkr, 'ZJFW CONTRACTED EXM TEST'))) then
    begin
      { Use BSE to Connect to CLAIMS to retrieve Vendor Info }
      if RemoteClaimsLogin(_CCOWBrkr, ClmsSysCCOWBrkr) then
      begin
        try
          fmLstrSFTPInfo.RPCBroker := ClmsSysCCOWBrkr;
          { Get/Populate SFTP Contractor Entries for selection }
          fmCmbBxSFTPInfo.Text := '';
          fmCmbBxSFTPInfo.Items.Clear;
          fmCmbBxSFTPInfo.GetList;
          cmbBxSFTPInfo.Items.Clear;
          cmbBxSFTPInfo.Items.AddStrings(fmCmbBxSFTPInfo.Items);
        except
          err := True;
        end;  { End Inner Try/Except Block }
      end  { End If Successfully connected to Remote CLAIMS system }
      else
        err := True;
    end   { End Production Account or Dev Test Account & User has Key }
    else
    begin
      err := True;
      msg := 'The ability to link contractors to a remote SFTP entry has been disabled' + #13#10 +
             'on TEST accounts, since the Broker Security Enhancements (BSE) used to' + #13#10 +
             'reverse lookup the Vendors SFTP information on CLAIMS is not readily supported.';
    end;  { End NOT Production Account or Dev Account & User does Not have Key }
  finally
    if err then
    begin
      MessageDlgCAPRI(msg, mtWarning, [mbOK], 0);
      cmbBxSFTPInfo.Enabled := False;
    end;  { End If Error Occurred Retrieving Remote Contractor Entries }
    ClmsSysCCOWBrkr.Connected := False;
    ClmsSysCCOWBrkr.Free;
  end;  { End Outer Try/Finally Block }
end;

end.
