unit labgraph;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  ExtCtrls,
  TeeProcs,
  TeEngine,
  Chart,
  Diaccess,
  Fmcmpnts,
  StdCtrls,
  Fmcntrls,
  Main,
  ComCtrls,
  Series,
  RpcConf1,
  Trpcb,
  ORFn;

type
  TfrmLabGraph = class(TForm)
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel3: TPanel;
    FMListerLabs: TFMLister;
    DateTimePicker1: TDateTimePicker;
    Label2: TLabel;
    Label3: TLabel;
    DateTimePicker2: TDateTimePicker;
    ButtonGraph: TButton;
    chartLab: TChart;
    Splitter3: TSplitter;
    memoLabComments: TMemo;
    Series1: TLineSeries;
    checkboxValues: TCheckBox;
    memoLab1: TMemo;
    checkboxZoom: TCheckBox;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Button1: TButton;
    ListBoxLabs: TListBox;
    CCOWTimer: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonGraphClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure checkboxValuesClick(Sender: TObject);
    procedure Series1GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
    procedure checkboxZoomClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLabGraph: TfrmLabGraph;
  Lab1: tStrings;

implementation
Uses
  caprisupport;
{$R *.DFM}

procedure TfrmLabGraph.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  modalresult := mrOK;
end;

procedure TfrmLabGraph.Series1GetMarkText(Sender: TChartSeries; ValueIndex: Longint; var MarkText: string);
begin
  // Do it in reverse order to tag the points properly
  MarkText := Piece(MemoLab1.Lines[MemoLab1.Lines.Count - 1 - ValueIndex], '^', 2);
  //MarkText:=MemoLab1.Lines[MemoLab1.Lines.Count-2-ValueIndex];
end;

procedure TfrmLabGraph.ButtonGraphClick(Sender: TObject);
var
  xx, yy: integer;
begin
  if ListBoxLabs.ItemIndex = -1 then begin
    ShowMessageCAPRI('Please select a lab to graph.');
    exit;
  end;
  (*
    If DateTimePicker2.Date>Now then begin;
      ShowMessageCAPRI('Stop date cannot be in the future.');
      exit;
    end;
    *)
  if DateTimePicker1.Date > DateTimePicker2.Date then begin
    ShowMessageCAPRI('Start date cannot be greater than stop date.');
    exit;
  end;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWLRR CHART';
  frmMain.RPCBroker1.Param[1].Value := PatientIEN; // Patient IEN
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker2.Date)) + '.2359'; //Stop Date
  frmMain.RPCBroker1.Param[2].PType := literal;
  frmMain.RPCBroker1.Param[3].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePicker1.Date)); //Start Date
  frmMain.RPCBroker1.Param[3].PType := literal;
  frmMain.RPCBroker1.Param[4].Value := '0'; // 0 for "All Specimens"
  frmMain.RPCBroker1.Param[4].PType := literal;
  frmMain.RPCBroker1.Param[5].Value := '';
  for yy := 0 to listLabTestNames.Count - 1 do
    if ListBoxLabs.Items[ListBoxLabs.ItemIndex] = Piece(listLabTestNames[yy], '^', 1) then
      frmMain.RPCBroker1.Param[5].Value := Piece(listLabTestNames[yy], '^', 2);
  frmMain.RPCBroker1.Param[5].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('RPC ORWLRR CHART could not be accessed!');
  end;
  QuickCopy(frmMain.RPCBroker1.Results, memoLabComments);
  memoLabcomments.Visible := False;

  CheckBoxValues.Checked := false;
  CheckBoxZoom.Checked := false;
  CheckBoxValuesClick(Application);
  CheckBoxZoomClick(Application);

  ChartLab.Series[0].Clear;
  ChartLab.Series[1].Clear;
  ChartLab.Series[2].Clear;
  ChartLab.Title.Text.Clear;
  ChartLab.SeriesList[0].Title := ' ';
  if memoLabComments.Lines.Count = 0 then begin
    ChartLab.Title.Text.Add(ListBoxLabs.Items[ListBoxLabs.ItemIndex]);
    ChartLab.Title.Text.Add(DateToStr(DateTimePicker1.Date) + ' to ' + DateToStr(DateTimePicker2.Date));
    ChartLab.SeriesList[0].Title := 'Ref Low:    Ref High:';
    exit; // No data returned;
  end;
  if Piece(frmMain.RPCBroker1.Results[0], '^', 2) <> '' then
    ChartLab.Title.Text.Add(ListBoxLabs.Items[ListBoxLabs.ItemIndex] + ' (' + Piece(frmMain.RPCBroker1.Results[0], '^', 2) + ')')
  else
    ChartLab.Title.Text.Add(ListBoxLabs.Items[ListBoxLabs.ItemIndex]);
  ChartLab.Title.Text.Add(DateToStr(DateTimePicker1.Date) + ' to ' + DateToStr(DateTimePicker2.Date));
  ChartLab.SeriesList[0].Title := 'Ref Low: ' + Piece(frmMain.RPCBroker1.Results[0], '^', 4) + Piece(frmMain.RPCBroker1.Results[0], '^', 5) + '    ' + 'Ref High: ' + Piece(frmMain.RPCBroker1.Results[0], '^', 3) + Piece(frmMain.RPCBroker1.Results[0], '^', 5);
  for xx := 1 to StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) do begin
    // Graph
    ChartLab.Series[0].AddXY(StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) + 1 - xx, Int(StrToFloat(Piece(frmMain.RPCBroker1.Results[xx], '^', 2))),
      FMDateTimeConvert3(Piece(frmMain.RPCBroker1.Results[xx], '^', 1)),
      clTeeColor);
    // Low range
    ChartLab.Series[1].AddXY(StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) + 1 - xx, Int(StrToFloat(Piece(frmMain.RPCBroker1.Results[0], '^', 3))),
      FMDateTimeConvert3(Piece(frmMain.RPCBroker1.Results[xx], '^', 1)),
      clTeeColor);
    // Upper Range
    ChartLab.Series[2].AddXY(StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) + 1 - xx, Int(StrToFloat(Piece(frmMain.RPCBroker1.Results[0], '^', 4))),
      FMDateTimeConvert3(Piece(frmMain.RPCBroker1.Results[xx], '^', 1)),
      clTeeColor);
  end;
  (*
    for xx:=1 to StrToInt(Piece(frmMain.RPCBroker1.Results[0],'^',1)) do begin;
      ChartLab.Series[0].AddXY( xx-1,StrToInt(Piece(frmMain.RPCBroker1.Results[xx],'^',2)),
             FMDateTimeConvert3(Piece(frmMain.RPCBroker1.Results[xx],'^',1)),
             clTeeColor);
    end;
  *)
    //Copy to memoLab1
  QuickCopy(frmMain.RPCBroker1.Results, memoLab1);
  memoLab1.Lines.Delete(0);
  //Clear out comments but leave graph data
  if memolab1.lines.count > StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) then
    for xx := memolab1.lines.count - 1 downto StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) do
      memoLab1.Lines.Delete(xx);
  //Clear out graph data but leave comments
  for xx := 0 to StrToInt(Piece(frmMain.RPCBroker1.Results[0], '^', 1)) do
    memoLabcomments.Lines.Delete(0);
  memoLabcomments.BringToFront;
  memoLabcomments.Visible := True;
  memolab1.visible := False;
end;

procedure TfrmLabGraph.FormCreate(Sender: TObject);
begin
  memoLabComments.ReadOnly := True;
  chartLab.Title.Text.Clear;
end;

procedure TfrmLabGraph.checkboxValuesClick(Sender: TObject);
begin
  if CheckBoxValues.Checked = True then
    ChartLab.SeriesList[0].Marks.Visible := True
  else
    ChartLab.SeriesList[0].Marks.Visible := False;
  //ChartLab.Series[0].Title:=' ';
  Series1.OnGetMarkText := Series1GetMarkText;
end;

procedure TfrmLabGraph.checkboxZoomClick(Sender: TObject);
begin
  if checkboxZoom.Checked = True then begin
    chartLab.AllowZoom := True;
  end
  else begin
    chartLab.BottomAxis.Automatic := True;
    chartLab.LeftAxis.Automatic := True;
    chartLab.AllowZoom := False;
  end;
end;

procedure TfrmLabGraph.Button1Click(Sender: TObject);
begin
  ChartLab.CopyToClipBoardBitmap;
end;

procedure TfrmLabGraph.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    modalresult := mrCancel;
    frmLabGraph.visible := false;
  end;
end;

end.
