unit patientlistrestricted;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  DialogsCAPRI,
  StdCtrls,
  Fmcntrls,
  ExtCtrls,
  Fmcmpnts,
  Diaccess,
  ORCtrls,
  TRPCB,
  CCOWRPCBrokerCAPRI;

type
  TfrmPatientListRestricted = class(TForm)
    GroupBoxCvr1Pt: TGroupBox;
    ScrollBox1: TScrollBox;
    FMCvrNamePt: TFMLabel;
    LabelCvrSSN: TLabel;
    FMCvrSexPt: TFMLabel;
    FMCvrAgePt: TFMLabel;
    FMCvrBirthdatePt: TFMLabel;
    FMCvrWardPt: TFMLabel;
    FMCvrRoomBedPt: TFMLabel;
    LabelCvrCNumberPt: TLabel;
    LabelCvrICNPt: TLabel;
    FMCvrICNPt: TFMLabel;
    FMCvrSSNPt: TFMLabel;
    FMCvrCNumberPt: TFMLabel;
    LabelCvrWard: TLabel;
    LabelStatus: TLabel;
    btnCvrCancelPt: TButton;
    btnCvrSelectPt: TButton;
    Label1: TLabel;
    ComboBoxListNames: TComboBox;
    ORListBox1: TORListBox;
    PanelCvr1PtNotFound: TPanel;
    PanelCvr1Pt: TPanel;
    ButtonOtherSites: TButton;
    FMFinder1: TFMFinder;
    FMListBox1: TFMListBox;
    FMCvrGets1Pt: TFMGets;
    Label2: TLabel;
    btnSearch: TButton;
    procedure ComboBoxListNamesChange(Sender: TObject);
    procedure ORListBox1Change(Sender: TObject);
    procedure ButtonOtherSitesClick(Sender: TObject);
    procedure btnCvrCancelPtClick(Sender: TObject);
    procedure btnCvrSelectPtClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPatientListRestricted: TfrmPatientListRestricted;

implementation

uses
  caprisupport,
  essoselect,
  main,
  patientlist,
  remotesitepick;

{$R *.DFM}

procedure TfrmPatientListRestricted.ComboBoxListNamesChange(
  Sender: TObject);
var
  x: integer;
begin
  btnSearch.enabled := false;
  LabelStatus.Caption := '';
  Scrollbox1.Visible := False;
  FMCvrGets1Pt.ClearCtrlData;
  ButtonOtherSites.Enabled := False;
  ORListBox1.Items.Clear;
  if frmMain.ListBoxRestrictedPatients.Items.Count > 0 then
    for x := 0 to frmMain.ListBoxRestrictedPatients.Items.Count - 1 do
      if (frmMain.piece(frmMain.ListBoxRestrictedPatients.Items[x], '^', 1) = ComboBoxListNames.Items[ComboBoxListNames.ItemIndex]) or
        (((frmMain.piece(frmMain.ListBoxRestrictedPatients.Items[x], '^', 1) = '') and (ComboBoxListNames.ItemIndex = 0))) then
        ORListBox1.Items.Add(frmMain.ListBoxRestrictedPatients.Items[x]);
end;

procedure TfrmPatientListRestricted.ORListBox1Change(Sender: TObject);
var
  x: integer;
  foundflag: integer;

  procedure RemoveHDRFromList;
  var
    x: integer;
  begin
    // Remove HDR entry, if found
    if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '-1' then
      for x := frmMain.RPCBroker1.Results.Count - 1 downto 0 do
        if frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) = '200HD' then
          frmMain.RPCBroker1.Results.Delete(x);
    // If the list is empty, make sure this is reflected.
    if frmMain.RPCBroker1.Results.Count = 0 then
      frmMain.RPCBroker1.Results.Add('-1^No Sites Found');
  end;

  procedure checkfordoddata;
  var
    x: integer;
  begin
    frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
    frmMain.RPCBroker1.Param[0].Value := FMListBox1.GetSelectedRecord.IEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        exit;
      end
    end;
    if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' then begin
      // Only local data or other problem
      // Do nothing
    end
    else begin
      for x := 0 to frmMain.RPCBroker1.Results.Count - 1 do begin
        Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
        Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
        sitenum := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1);
        if sitenum = '200' then begin
          // DOD data is available so do something here....
          LabelStatus.Caption := LabelStatus.Caption + 'DoD data is available.  ';
        end;
      end;
    end;
  end;

  procedure checkkeyfields;
  begin
    CheckForDODData;
    if FMCvrGets1Pt.GetField('.351').FMDBExternal <> '' then begin
      LabelStatus.Caption := LabelStatus.Caption + 'Patient is deceased.  ';
      LabelStatus.Visible := True;
    end;
  end;

begin
  btnSearch.enabled := true;
  GroupBoxCvr1Pt.Visible := True;
  ScrollBox1.Visible := False;
  LabelStatus.Caption := '';
  FMCvrGets1Pt.ClearCtrlData;
  ButtonOtherSites.Enabled := False;
  LabelStatus.Caption := '';
  FMFinder1.Value := frmMain.Piece(ORListBox1.Items[ORListBox1.ItemIndex], '^', 6);
  FMFinder1.GetFinderList(FMListBox1.Items);
  if FMListBox1.Items.Count = 0 then begin
    PanelCvr1PtNotFound.Visible := True;
    PanelCvr1PtNotFound.BringToFront;
    GroupBoxCvr1Pt.Visible := False;
    PanelCvr1Pt.Visible := False;
    btnCvrSelectPt.Enabled := False;
  end
  else begin
    btnCvrSelectPt.Enabled := True;
    PanelCvr1PtNotFound.Visible := False;
    GroupBoxCvr1Pt.Visible := True;
    GroupBoxCvr1Pt.BringToFront;
    PanelCvr1Pt.Visible := False;
    foundflag := -1;
    // Look for right patient
    for x := 0 to FMListBox1.Items.Count - 1 do
      if
        Pos('  ' + frmMain.Piece(ORListBox1.Items[ORListBox1.ItemIndex], '^', 6), FMListBox1.Items[x]) > 0 then
        foundflag := x;
    if foundflag > -1 then begin
      FMListBox1.ItemIndex := foundflag;
      FMCvrGets1Pt.IENS := FMListBox1.GetSelectedRecord.IEN;
      // Check for sensitive record
      frmMain.RPCBroker1.RemoteProcedure := 'DG SENSITIVE RECORD ACCESS';
      frmMain.RPCBroker1.Param[0].Value := FMListBox1.GetSelectedRecord.IEN;
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do begin
          frmPatientList.enabled := True;
          ShowMessageCAPRI('DG SENSITIVE RECORD ACCESS could not be accessed!');
        end;
      end;
      if frmMain.RPCBroker1.Results[0] = '0' then begin
        FMCvrGets1Pt.GetAndFill;
        Scrollbox1.Visible := True;
        checkkeyfields;
      end
      else begin
        PanelCvr1Pt.Visible := True;
        PanelCvr1Pt.BringToFront;
        GroupBoxCvr1Pt.Visible := False;
        FMCvrGets1Pt.GetAndFill;
        checkkeyfields;
      end;
    end;

    // Check for other sites
    frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
    frmMain.RPCBroker1.Param[0].Value := FMListBox1.GetSelectedRecord.IEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
      end
    end;
    RemoveHDRFromList;
    if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' then begin
      // Only local data or other problem
      ButtonOtherSites.Enabled := False;
    end
    else begin
      ButtonOtherSites.Enabled := True;
    end;

  end;
end;

procedure TfrmPatientListRestricted.ButtonOtherSitesClick(Sender: TObject);
var
  a, b: string;
  x: integer;
  procedure RemoveHDRFromList;
  var
    x: integer;
  begin
    // Remove HDR entry, if found
    if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) <> '-1' then
      for x := frmMain.RPCBroker1.Results.Count - 1 downto 0 do
        if frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) = '200HD' then
          frmMain.RPCBroker1.Results.Delete(x);
    // If the list is empty, make sure this is reflected.
    if frmMain.RPCBroker1.Results.Count = 0 then
      frmMain.RPCBroker1.Results.Add('-1^No Sites Found');
  end;
begin
  frmRemoteSitePick := TfrmRemoteSitePick.Create(frmPatientList);
  frmMain.AnimateLogo(True);
  frmMain.StatusBarLoadPt.Caption := 'Generating report.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  frmMain.RPCBroker1.RemoteProcedure := 'ORWCIRN FACLIST';
  frmMain.RPCBroker1.Param[0].Value := frmMain.Piece(FMCvrGets1Pt.IENS, ',', 1);
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC ORWCIRN FACLIST could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('ORWCIRN FACLIST could not be accessed!');
    end
  end;
  RemoveHDRFromList;
  if frmMain.Piece(frmMain.RPCBroker1.Results[0], '^', 1) = '-1' then begin
    // Only local data or other problem
    frmRemoteSitePick.ORListBoxSites.Items.Add('Sites could not be loaded.');
  end
  else begin
    for x := 0 to frmMain.RPCBroker1.Results.Count - 1 do begin
      a := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1) + '        ', 1, 8);
      b := Copy(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 2) + '                         ', 1, 25);
      sitenum := frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 1);
      if a <> '200HD' then
        frmRemoteSitePick.ORListBoxSites.Items.Add(a + b + '  ' + FMDateTimeConvert(frmMain.Piece(frmMain.RPCBroker1.Results[x], '^', 3)) + '^' + sitenum)
      else
        showmessage('Found HDR');
    end;
  end;
  frmMain.AnimateLogo(False);
  frmMain.StatusBarLoadPt.Caption := 'Ready.';
  frmMain.StatusBarLoadPt.Repaint;
  Application.Processmessages;
  if frmRemoteSitePick.ShowModal = mrok then begin
    if SiteNum = '200' then begin
      frmRemoteSitePick.Release;
      switchtosite := '';
      ShowMessageCAPRI('Switching to DoD is not allowed.  Instead, select the patient and use the DOD RECORDS tab to view DOD data.');
      exit;
    end;

    if switchtosite <> '' then begin
      for x := 0 to formEssoSelect.slUserSites.Count - 1 do   //CodeCR77
        if (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.slUserSites[x], '^', 8)) > 0) or // CodeCR191 -MER 05/2011
          (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.slUserSites[x], '^', 4)) > 0)
          then begin
          switchtosite := inttostr(x);
          SwitchToPatientSSN := FMCvrSSNPt.Caption;
          frmRemoteSitePick.Release;
          frmPatientList.Visible := False;
          btnCvrCancelPtClick(application);
          frmRemoteSitePick.Release;
          exit;
        end;
      // User doesn't have authorized access, so look for site an alternate way
      for x := 0 to formEssoSelect.ORListBox2.Items.Count - 1 do
        if (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.ORListBox2.Items[x], '^', 1)) > 0) or
          (Pos(SwitchToSite, frmMain.Piece(formESSOSelect.ORListBox2.Items[x], '^', 4)) > 0)
          then begin
          switchtosite := '*' + inttostr(x);
          SwitchToPatientSSN := FMCvrSSNPt.Caption;
          frmRemoteSitePick.Release;
          frmPatientList.Visible := False;
          btnCvrCancelPtClick(application);
          frmRemoteSitePick.Release;
          exit;
        end;
      switchtosite := '';
      ShowMessageCAPRI('+You either do not have access to the remote site or some other problem prevented connection.  Try connecting manually instead using FILE | SWITCH SITES.');
    end
    else begin
      SwitchToSite := '';
      ShowMessageCAPRI('*You either do not have access to the remote site or some other problem prevented connection.  Try connecting manually instead using FILE | SWITCH SITES.');
    end;
  end;
  frmRemoteSitePick.Release;
end;

procedure TfrmPatientListRestricted.btnCvrCancelPtClick(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmPatientListRestricted.btnCvrSelectPtClick(Sender: TObject);
var
  buf: array[0..PORT] of char;
  msg: string;
  xx: integer;
  foundflag: boolean;
  x: integer;

  function ptdeceasedcheck: boolean;
  var
    diedtext: string;
  begin
    diedtext := FMCvrGets1Pt.GetField('.351').FMDBExternal;
    if diedtext <> '' then begin
      msg := 'This patient died ' + diedtext + char(13) + 'Do you wish to continue?';
      StrPCopy(buf, msg);
      if Application.MessageBox(buf, 'Deceased Patient', 4) = IDNo then begin
        patientien := '-1';
        result := false;
        exit;
      end;
    end;
    result := true;
  end;

begin
  if FMListBox1.ItemIndex > -1 then begin
    PatientIEN := FMListBox1.GetSelectedRecord.IEN;

    // Check for sensitive record
    frmMain.RPCBroker1.RemoteProcedure := 'DG SENSITIVE RECORD ACCESS';
    frmMain.RPCBroker1.Param[0].Value := FMListBox1.GetSelectedRecord.IEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do begin
        frmPatientList.enabled := True;
        ShowMessageCAPRI('DG SENSITIVE RECORD ACCESS could not be accessed!');
      end;
    end;
    if frmMain.RPCBroker1.Results[0] <> '0' then begin
      if frmMain.RPCBroker1.Results[0] <> '3' then begin //2=regular patient
        msg := '';
        if frmMain.RPCBroker1.Results.Count > 0 then
          for xx := 1 to frmMain.RPCBroker1.Results.Count - 1 do
            msg := msg + frmMain.RPCBroker1.Results[xx] + char(13);
        //xx:=0;
        StrPCopy(buf, msg);
        if ANURemoteProcedureCallInProgress = True then
          repeat application.processmessages until ANURemoteProcedureCallInProgress = False;
        if Application.MessageBox(buf, 'Sensitive Record', 4) = IDNo then begin
          ProcessingTimer := False;
          // Check that user should have access to this site in case they switched
          // sites, don't normally have access and then cancelled a sensitive patient switch
          if essoversion = true then begin
            foundflag := false;
            if formESSOSelect.slUserSites.Count > 0 then   //CodeCR77
              for x := 0 to formESSOSelect.slUserSites.Count - 1 do
                if uppercase(frmMain.piece(formESSOSelect.slUserSites[x], '^', 2)) = uppercase(frmMain.RPCBroker1.Server) then
                  foundflag := true;
            if foundflag <> true then begin
              ShowmessageCAPRI('You do not have direct access to this site.  Please use FILE | SWITCH SITES and pick a different site prior to selecting a patient.');
              btnCvrCancelPtClick(Application);
              exit;
            end;
          end;
          exit;
        end;
        // Send warning message to ISO
        PatientSensitive := 'Y';
        frmMain.RPCBroker1.RemoteProcedure := 'DG SENSITIVE RECORD BULLETIN';
        frmMain.RPCBroker1.Param[1].Value := PatientIEN;
        frmMain.RPCBroker1.Param[1].PType := literal;
        frmMain.RPCBroker1.Param[2].Value := 'DVBA CAPRI GUI^Capri GUI (Broker)';
        frmMain.RPCBroker1.Param[2].PType := literal;
        frmMain.RPCBroker1.Param[3].Value := ''; // Use the default for this parameter by leaving it blank
        frmMain.RPCBroker1.Param[3].PType := literal;
        frmMain.RPCBrokerCall;
        frmMain.RPCBroker1.Call;
        (*
        try frmMain.RPCBroker1.Call;
          except
        On EBrokerError do
          ShowMessageCAPRI('DG SENSITIVE RECORD BULLETIN could not be accessed for this patient!  You may continue using CAPRI.');
        end;
        *)
        if frmMain.RPCBroker1.Results.Count > 0 then
          if frmMain.RPCBroker1.Results[0] <> '1' then begin
            ShowMessageCAPRI('There was a problem generating the DG SENSITIVE RECORD e-mail.  Please notify IRM.');
          end;

        (*
        if ptDeceasedCheck=false then begin
          processingtimer:=False;
          exit;
        end;

        PatientIEN:=PatientDFN;
        frmPatientList.Close;
        processingtimer:=false;
        exit;
        *)
      end;
      (*

      if ptDeceasedCheck=false then begin
        processingtimer:=false;
        exit;
      end;
      *)

      if frmMain.RPCBroker1.Results[0] = '3' then begin
        msg := '';
        if frmMain.RPCBroker1.Results.Count > 0 then
          for xx := 1 to frmMain.RPCBroker1.Results.Count - 1 do
            msg := msg + frmMain.RPCBroker1.Results[xx] + char(13);
        ShowMessageCAPRI(msg);
        processingtimer := false;
        exit;
        // Don't send warning message to ISO
      end;
    end;
    if ptDeceasedCheck = false then begin
      processingtimer := false;
      exit;
    end;
    modalresult := mrok;
  end
  else
    modalresult := mrcancel;
end;

procedure TfrmPatientListRestricted.btnSearchClick(Sender: TObject);
begin
  frmMain.actToolsSearchExecute(btnSearch);
end;

end.
