unit pncsSave;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TformPncsSave = class(TForm)
    btnSaveIt: TButton;
    edtSaveName: TEdit;
    xLabelClose1     : TLabel;
    xPanelDescription: TPanel;
    xPanelSaveInfo   : TPanel;
    xPanelSaveInfo2  : TPanel;
    xPanelSaveInfo3  : TPanel;
    xPanelSaveInfo4  : TPanel;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnSaveItClick(Sender: TObject);
    procedure xLabelClose1Click(Sender: TObject);
  private
    function GetBottomLeft: TPoint;
    procedure SetBottomLeft(const Value: TPoint);
  protected
    { Protected declarations }
    FSaveLabel: String;
    FSuccess  : Boolean;
    function GetSaveLabel: String;
    function GetSuccess: Boolean;
    procedure SetSaveLabel(const Value: String);
    procedure SetSuccess(const Value: Boolean);
  published
    { Published declarations }
    property BottomLeft: TPoint  read GetBottomLeft write SetBottomLeft;
    property SaveLabel : String  read GetSaveLabel  write SetSaveLabel;
    property Success   : Boolean read GetSuccess    write SetSuccess;
  end;

var
  formPncsSave: TformPncsSave;

implementation
Uses
  PNCSMain;

{$R *.DFM}

procedure TformPncsSave.FormCreate(Sender: TObject);
begin
  FSuccess  := False;
  FSaveLabel:= 'Manual save';
end;

procedure TformPncsSave.FormActivate(Sender: TObject);
begin
  Success:=False;
  edtSaveName.SetFocus;
end;

procedure TformPncsSave.btnSaveItClick(Sender: TObject);
begin
  PNCSForm.SaveName:=edtSaveName.Text;
  Success:=True;
  Close;
end;

procedure TformPncsSave.xLabelClose1Click(Sender: TObject);
begin
  PNCSForm.SaveName:=edtSaveName.Text;
  Close;
end;

function TformPncsSave.GetSaveLabel: String;
begin
  Result:=FSaveLabel;
end;

function TformPncsSave.GetSuccess: Boolean;
begin
  Result:=FSuccess;
end;

procedure TformPncsSave.SetSaveLabel(const Value: String);
begin
  FSaveLabel:=Value;
  edtSaveName.Text:=Value;
end;

procedure TformPncsSave.SetSuccess(const Value: Boolean);
begin
  FSuccess:=Value;
end;

function TformPncsSave.GetBottomLeft: TPoint;
begin
  Result.x:=Left;
  Result.y:=Top+Height;
end;

procedure TformPncsSave.SetBottomLeft(const Value: TPoint);
begin
  Left:=Value.x;
  Top :=Value.y-Height;
end;

end.
