unit printsupport;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Printers,
  Qrctrls,
  QuickRpt,
  ExtCtrls,
  Main,
  QrPrntr,
  Winspool;

type
  TformPrint = class(TForm)
    QuickRep1: TQuickRep;
    DetailBand1: TQRBand;
    QRMemoReport: TQRRichText;
    PageFooterBand1: TQRBand;
    QRLabel1: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel5: TQRLabel;
    buttonPreview: TButton;
    buttonPrinterSetup: TButton;
    buttonPrint: TButton;
    QRShape1: TQRShape;
    QRSysData1: TQRSysData;
    QRLabel6: TQRLabel;
    PrintDialog1: TPrintDialog;
    PageHeaderBand: TQRBand;  //CodeCR127 - rpm 8/10/2010
    qrlblDateRange: TQRLabel;  //CodeCR127 - rpm 8/10/2010
    procedure buttonPreviewClick(Sender: TObject);
    procedure buttonPrinterSetupClick(Sender: TObject);
    procedure buttonPrintClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure QuickRep1ApplyPrinterSettings(Sender: TObject;
      var Cancel: Boolean; DevMode: Pointer);
  private
    { Private declarations }
    procedure OpenPrinterDevice;
  public
    { Public declarations }
    procedure SetPrinterSettings(aQRep: TQuickRep); overload;
    procedure SetPrinterSettings(aQRep: TQRCompositeReport); overload;
    function PrinterSetup(): Boolean; overload;
    function PrinterSetup(aQuickReport: TQuickRep): Boolean; overload;
    function PrinterSetup(aQRCompositeReport: TQRCompositeReport): Boolean; overload;
  end;

var
  formPrint: TformPrint;
  tempQRPrinter: TQRPrinter;
  DeviceMode: THandle;
  aDevMode: PDeviceMode;

implementation

uses printconfirm;

{$R *.DFM}

procedure TformPrint.buttonPreviewClick(Sender: TObject);
begin
  try
  QuickRep1.PreviewModal except
  end;
end;

procedure TformPrint.buttonPrinterSetupClick(Sender: TObject);
begin
  //QuickRep1.PrinterSetup;
  // tempQRPrinter:=QuickRep1.QRPrinter;
  PrinterSetup;  //CodeCR84 - rpm 2/25/10
end;

procedure TformPrint.buttonPrintClick(Sender: TObject);
begin
  if PrinterSetup then  //CodeCR84 - rpm 4/21/10
  begin
    if FormPrintConfirm.ComboBoxPaperSize.ItemIndex = -1 then
      FormPrintConfirm.ComboBoxPaperSize.ItemIndex := 0;
    FormPrintConfirm.EditTitle.Text := Authorname + ': ' + formPrint.QRLabel1.Caption;
    FormPrintConfirm.UpDown1.Position := QuickRep1.PrinterSettings.Copies;
    if FormPrintConfirm.ShowModal <> mrCancel then
    begin
      QuickRep1.PrinterSettings.Title := FormPrintConfirm.EditTitle.Text;
      case FormPrintConfirm.ComboBoxPaperSize.ItemIndex of
        1: QuickRep1.PrinterSettings.PaperSize := Default;
        2: QuickRep1.PrinterSettings.PaperSize := Letter;
        3: QuickRep1.PrinterSettings.PaperSize := LetterSmall;
        4: QuickRep1.PrinterSettings.PaperSize := Tabloid;
        5: QuickRep1.PrinterSettings.PaperSize := Ledger;
        6: QuickRep1.PrinterSettings.PaperSize := Legal;
        7: QuickRep1.PrinterSettings.PaperSize := Statement;
        8: QuickRep1.PrinterSettings.PaperSize := Executive;
        9: QuickRep1.PrinterSettings.PaperSize := A3;
        10: QuickRep1.PrinterSettings.PaperSize := A4;
        11: QuickRep1.PrinterSettings.PaperSize := A4Small;
        12: QuickRep1.PrinterSettings.PaperSize := A5;
        13: QuickRep1.PrinterSettings.PaperSize := B4;
        14: QuickRep1.PrinterSettings.PaperSize := B5;
        15: QuickRep1.PrinterSettings.PaperSize := Quarto;
        16: QuickRep1.PrinterSettings.PaperSize := qr10X14;
        17: QuickRep1.PrinterSettings.PaperSize := qr11X17;
        18: QuickRep1.PrinterSettings.PaperSize := Note;
        19: QuickRep1.PrinterSettings.PaperSize := Env9;
        20: QuickRep1.PrinterSettings.PaperSize := Env10;
        21: QuickRep1.PrinterSettings.PaperSize := Env11;
        22: QuickRep1.PrinterSettings.PaperSize := Env14;
        23: QuickRep1.PrinterSettings.PaperSize := CSheet;
        24: QuickRep1.PrinterSettings.PaperSize := DSheet;
        25: QuickRep1.PrinterSettings.PaperSize := ESheet;

      end;
      QuickRep1.PrinterSettings.Copies := strtoint(FormPrintConfirm.EditCopies.Text);

      QuickRep1.Print;
      ShowMessageCAPRI('This report has been sent to the printer.');
    end;
  end;
end;

procedure TformPrint.FormCreate(Sender: TObject);
begin
  //jcs - d2006
  //tempQRPrinter := TQRPrinter.Create;
  tempQRPrinter := TQRPrinter.Create(self);
  QuickRep1.QRPrinter := tempQRPrinter;
  qrlblDateRange.Caption := ''; // CodeCR127 -MER 12/10
  PageHeaderBand.Enabled := FALSE; // CodeCR127 -MER 12/10
end;

{===========================================================================
 PrinterSetup() -
 This overloaded function provides printer selection and populates
 QuickReport printersettings.

 Input: none
 Output: returns True on accepting printer selection; otherwise returns False

 CodeCR84 - rpm 4/21/10
 ============================================================================}
function TformPrint.PrinterSetup(): Boolean;
begin
  if PrintDialog1.Execute then
  begin
    SetPrinterSettings(QuickRep1);
    Result := True;
  end
  else
    Result := False;
end;

{============================================================================
 PrinterSetup(TQuickRep)
 This overloaded function provides printer selection and populates
 QuickReport printersettings.

 Input: aQuickReport
 Output: returns True on accepting printer selection; otherwise returns False

 CodeCR84 - rpm 4/21/10
 ============================================================================}
function TformPrint.PrinterSetup(aQuickReport: TQuickRep): Boolean;
begin
  if PrintDialog1.Execute then
  begin
    SetPrinterSettings(aQuickReport);
    Result := True;
  end
  else
    Result := False;
end;

{============================================================================
 PrinterSetup(TQRCompositeReport)
 This overloaded function provides printer selection and populates
 Composite report printersettings.

 Input: aQRCompositeReport
 Output: returns True on accepting printer selection; otherwise returns False
 CodeCR84 - rpm 4/21/10
 =============================================================================}
function TformPrint.PrinterSetup(aQRCompositeReport: TQRCompositeReport): Boolean;
begin
  if PrintDialog1.Execute then
  begin
    SetPrinterSettings(aQRCompositeReport);
    Result := True;
  end
  else
    Result := False;
end;

{========================================================================
 OpenPrinterDevice
 This utility procedure opens the printer device driver to enable
 retrieval of printer properties.

 CodeCR84 - rpm 2/25/10
 ========================================================================}
procedure TformPrint.OpenPrinterDevice;
var
  Driver_Info2: PDriverInfo2;
  Retrieved: dword;
  hPrinter: THandle;
  FDevice, FDriver, FPort: array[0..255] of Char;
begin
  Printer().GetPrinter(FDevice, FDriver, FPort, DeviceMode);
  if DeviceMode = 0 then
    Printer().GetPrinter(FDevice, FDriver, FPort, DeviceMode);
  OpenPrinter(FDevice, hPrinter, nil);
  GetMem(Driver_Info2, 255);
  GetPrinterDriver(hPrinter, nil, 2, Driver_info2, 255, Retrieved);
  StrLCopy(FDriver, PChar(ExtractFileName(StrPas(Driver_Info2^.PDriverPath)) + #0), 63);
  FreeMem(Driver_info2, 255);
  aDevMode := GlobalLock(DeviceMode);
end;

procedure TformPrint.QuickRep1ApplyPrinterSettings(Sender: TObject;
  var Cancel: Boolean; DevMode: Pointer);
var
 cDevMode: PDeviceMode;
begin
   cDevMode := PDeviceMode(DevMode);
   if QuickRep1.PrinterSettings.Orientation = poPortrait then
      cDevMode.dmOrientation := DMORIENT_PORTRAIT;
   if QuickRep1.PrinterSettings.Orientation = poLandscape then
      cDevMode.dmOrientation := DMORIENT_LANDSCAPE;
end;

{===========================================================================
 SetPrinterSettings
 This overloaded procedure retrieves the DevMode settings from the selected
 printer and populates the PrinterSettings property of a TQRCompositeReport.

 CodeCR84: rpm 2/25/10
 ===========================================================================}
procedure TformPrint.SetPrinterSettings(aQRep: TQRCompositeReport);
var
  DefaultSource: Short;
begin
  aQRep.PrinterSettings.PrinterIndex := Printer.PrinterIndex;
  //View const descriptions in Windows.pas.
  OpenPrinterDevice;
  try
    {Copies}
    if ((aDevMode^.dmFields and DM_COPIES) = DM_COPIES) then
      aQRep.PrinterSettings.Copies := aDevMode^.dmCopies;

    {Orientation}
    if ((aDevMode^.dmFields and DM_ORIENTATION) = DM_ORIENTATION) and
       (aDevMode^.dmOrientation = DMORIENT_PORTRAIT) then
      //Portrait
      aQRep.PrinterSettings.Orientation := poPortrait
    else
      //Landscape
      aQRep.PrinterSettings.Orientation := poLandscape;

    {Duplex}
    if ((aDevMode^.dmFields and DM_DUPLEX) = DM_DUPLEX) then
    begin
      if ((aDevMode^.dmDuplex) <> DMDUP_SIMPLEX) then
        aQRep.PrinterSettings.Duplex := True
      else
        aQRep.PrinterSettings.Duplex := False;
      aQRep.PrinterSettings.ExtendedDuplex := (aDevMode^.dmDuplex)
    end;

    {Collate}
    if ((aDevMode^.dmFields and DM_COLLATE) = DM_COLLATE) then
      aQRep.PrinterSettings.Collate := (aDevMode^.dmCollate);

    {Print Quality}
    if ((aDevMode^.dmFields and DM_PRINTQUALITY) = DM_PRINTQUALITY) then
      aQRep.PrinterSettings.PrintQuality := (aDevMode^.dmPrintQuality);

    {Bin}
    if ((aDevMode^.dmFields and DM_DEFAULTSOURCE) = DM_DEFAULTSOURCE) then
    begin
      DefaultSource := aDevMode^.dmDefaultSource;
      if (DefaultSource > 14) then  //highest TQRBin supported value
      begin
        aQRep.PrinterSettings.UseCustomBinCode := True;
        aQRep.PrinterSettings.CustomBinCode := DefaultSource;
      end
      else
      begin
        aQRep.PrinterSettings.UseCustomBinCode := False;
        case DefaultSource of
          DMBIN_UPPER:         aQRep.PrinterSettings.OutputBin := Upper; {1}
          DMBIN_LOWER:         aQRep.PrinterSettings.OutputBin := Lower; {2}
          DMBIN_MIDDLE:        aQRep.PrinterSettings.OutputBin := Middle; {3}
          DMBIN_MANUAL:        aQRep.PrinterSettings.OutputBin := Manual; {4}
          DMBIN_ENVELOPE:      aQRep.PrinterSettings.OutputBin := Envelope; {5}
          DMBIN_ENVMANUAL:     aQRep.PrinterSettings.OutputBin := EnvManual; {6}
          DMBIN_AUTO:          aQRep.PrinterSettings.OutputBin := Auto;  {7}
          DMBIN_TRACTOR:       aQRep.PrinterSettings.OutputBin := Tractor; {8}
          DMBIN_SMALLFMT:      aQRep.PrinterSettings.OutputBin := SmallFormat; {9}
          DMBIN_LARGEFMT:      aQRep.PrinterSettings.OutputBin := LargeFormat; {10}
          DMBIN_LARGECAPACITY: aQRep.PrinterSettings.OutputBin := LargeCapacity; {11}
          DMBIN_CASSETTE:      aQRep.PrinterSettings.OutputBin := Cassette; {14}
        else
          aQRep.PrinterSettings.OutputBin := Auto;
        end;
      end;
    end;
  finally
    //At last, don't forget to unlock a device:
    GlobalUnlock(DeviceMode);
  end;
end;

{===========================================================================
 SetPrinterSettings
 This overloaded procedure retrieves the DevMode settings from the selected
 printer and populates the PrinterSettings property of TQuickRep.

 CodeCR84: rpm 2/25/10
 ===========================================================================}
procedure TformPrint.SetPrinterSettings(aQRep: TQuickRep);
var
  DefaultSource: Short;
begin
  aQRep.PrinterSettings.PrinterIndex := Printer.PrinterIndex;
  //View const descriptions in Windows.pas.
  OpenPrinterDevice;
  try
    {Copies}
    if ((aDevMode^.dmFields and DM_COPIES) = DM_COPIES) then
      aQRep.PrinterSettings.Copies := aDevMode^.dmCopies;

    {Orientation}
    if ((aDevMode^.dmFields and DM_ORIENTATION) = DM_ORIENTATION) and
       (aDevMode^.dmOrientation = DMORIENT_PORTRAIT) then
      //Portrait
      aQRep.PrinterSettings.Orientation := poPortrait
    else
      //Landscape
      aQRep.PrinterSettings.Orientation := poLandscape;

    {Duplex}
    if ((aDevMode^.dmFields and DM_DUPLEX) = DM_DUPLEX) then
    begin
      if ((aDevMode^.dmDuplex) <> DMDUP_SIMPLEX) then
        aQRep.PrinterSettings.Duplex := True
      else
        aQRep.PrinterSettings.Duplex := False;
      aQRep.PrinterSettings.ExtendedDuplex := (aDevMode^.dmDuplex)
    end;

    {Collate}
    if ((aDevMode^.dmFields and DM_COLLATE) = DM_COLLATE) then
      aQRep.PrinterSettings.Collate := (aDevMode^.dmCollate);

    {Print Quality}
    if ((aDevMode^.dmFields and DM_PRINTQUALITY) = DM_PRINTQUALITY) then
      aQRep.PrinterSettings.PrintQuality := (aDevMode^.dmPrintQuality);

    {Bin}
    if ((aDevMode^.dmFields and DM_DEFAULTSOURCE) = DM_DEFAULTSOURCE) then
    begin
      DefaultSource := aDevMode^.dmDefaultSource;
      if (DefaultSource > 14) then  //highest TQRBin supported value
      begin
        aQRep.PrinterSettings.UseCustomBinCode := True;
        aQRep.PrinterSettings.CustomBinCode := DefaultSource;
      end
      else
      begin
        aQRep.PrinterSettings.UseCustomBinCode := False;
        case DefaultSource of
          DMBIN_UPPER:         aQRep.PrinterSettings.OutputBin := Upper; {1}
          DMBIN_LOWER:         aQRep.PrinterSettings.OutputBin := Lower; {2}
          DMBIN_MIDDLE:        aQRep.PrinterSettings.OutputBin := Middle; {3}
          DMBIN_MANUAL:        aQRep.PrinterSettings.OutputBin := Manual; {4}
          DMBIN_ENVELOPE:      aQRep.PrinterSettings.OutputBin := Envelope; {5}
          DMBIN_ENVMANUAL:     aQRep.PrinterSettings.OutputBin := EnvManual; {6}
          DMBIN_AUTO:          aQRep.PrinterSettings.OutputBin := Auto;  {7}
          DMBIN_TRACTOR:       aQRep.PrinterSettings.OutputBin := Tractor; {8}
          DMBIN_SMALLFMT:      aQRep.PrinterSettings.OutputBin := SmallFormat; {9}
          DMBIN_LARGEFMT:      aQRep.PrinterSettings.OutputBin := LargeFormat; {10}
          DMBIN_LARGECAPACITY: aQRep.PrinterSettings.OutputBin := LargeCapacity; {11}
          DMBIN_CASSETTE:      aQRep.PrinterSettings.OutputBin := Cassette; {14}
        else
          aQRep.PrinterSettings.OutputBin := Auto;
        end;
      end;
    end;
  finally
    //At last, don't forget to unlock a device:
    GlobalUnlock(DeviceMode);
  end;
end;

procedure TformPrint.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
  tempQRPrinter.free except
  end;
  action := caFree;
end;


end.
