Unit specialreport;

Interface

Uses
  Windows,
  Messages,
  CAPRISupport,
  CheckLst,
  Classes,
  ComCtrls,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Graphics,
  RpcConf1,
  StdCtrls,
  StrUtils,
  SysUtils,
  Trpcb,
  CCOWRPCBrokerCAPRI;

Type
  TfrmSpecialReport = Class(TForm)
    ButtonResetList           : TButton;
    ButtonRunReport           : TButton;
    CheckListBoxTypes         : TCheckListBox;
    DateTimePickerBDate       : TDateTimePicker;
    DateTimePickerEDate       : TDateTimePicker;
    EditInstructions          : TEdit;
    FMGetsMASMovementType     : TFMGets;
    FMListBoxMASMovementType  : TFMListBox;
    FMListerMASMovementType   : TFMLister;
    FMRegionalOfficeNumber    : TFMComboBox;
    FMRegionalOfficeNumberFake: TFMEdit;
    GroupBox1                 : TGroupBox;
    GroupBox2                 : TGroupBox;
    Label16                   : TLabel;
    Panel1                    : TPanel;
    Panel2                    : TPanel;
    RadioGroupReportType      : TRadioGroup;
    rgReportFormat            : TRadioGroup;  //CodeCR129 - rpm 10/14/10
    Procedure ButtonResetListClick(Sender: TObject);
    Procedure ButtonRunReportClick(Sender: TObject);
    Procedure CheckListBoxTypesDrawItem(Control: TWinControl;Index: Integer; Rect: TRect; State: TOwnerDrawState);
    Procedure CheckListBoxTypesKeyUp(Sender: TObject; Var Key: Word;Shift: TShiftState);
    Procedure FMRegionalOfficeNumberEnter(Sender: TObject);
    Procedure FormShow(Sender: TObject);
  Private
    { Private declarations }
    FROStationNumber: String;  //CodeCR171 - rpm 4/28/11
    function GetDelimitedParam(IsDelimited: Boolean): String;  //CodeCR129 - rpm 10/14/10
  Public
    { Public declarations }
  End;

Var
  frmSpecialReport: TfrmSpecialReport;

Implementation

Uses
  main,
  ORFn,
  REPORTS,
  rofinder,
  wait;


{$R *.DFM}

Procedure TfrmSpecialReport.FMRegionalOfficeNumberEnter(Sender: TObject);
Var
  tempstring: String;
Begin
  If frmROFinder.ShowModal = mrOK Then
  Begin
    FMRegionalOfficeNumberFake.Text := frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 2);
    //CodeCR171 - rpm 4/28/11 - populate station number value to pass to RPC
    FROStationNumber := frmMain.Piece(frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 1), ' ',1);
    tempString := frmROFinder.GetCurrentROName;  //CodeCR170 - rpm 3/10/11
    FMRegionalOfficeNumber.Text := tempstring;
    FMRegionalOfficeNumberFake.Text := frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 2);
  End;
  Try
  RadioGroupReportType.SetFocus Except
  End;
  exit;
End;

Procedure TfrmSpecialReport.ButtonResetListClick(Sender: TObject);
Var
  x, y: integer;
  lWaitForm: TWaitForm; // CodeCR154 -MER 04/2011 The wait form was not showing
                        // progress and was not going away properly.
                        // To fix the problem we create a local wait form and
                        // manage it within this method
Begin
  // CodeCR154 -MER 04/2011
  lWaitForm := TWaitForm.Create(Self);
  try
    Screen.Cursor := crHourglass;
    lWaitForm.Label1.Caption := 'Loading VISTA data...';
    lWaitForm.StaticText1.Caption := 'Loading VISTA data...';
    lWaitForm.ImageNetwork.Visible := TRUE;
    lWaitForm.Show;
    Application.ProcessMessages;
    CheckListBoxTypes.Items.Clear;
    FMListBoxMASMovementType.Items.Clear;
    // Some items in the list get cut off, so look up the names
    // using FMGets
    FMListerMASMovementType.GetList(FMListBoxMASMovementType.Items);

    If FMListBoxMASMovementType.Items.Count > 0 Then
      For x := 0 To FMListBoxMASMovementType.Items.Count - 1 Do
      Begin
        // CodeCR154 -MER 04/2011
        lWaitForm.StaticText1.Caption := 'Updating discharge type list, item ' + IntToStr(x + 1)
          + ' of ' + IntToStr(FMListBoxMASMovementType.Items.Count);
        Application.ProcessMessages;
        FMListBoxMASMovementType.ItemIndex := x;
        FMGetsMASMovementType.IENS := FMListBoxMASMovementType.GetSelectedRecord.IEN;
        FMGetsMASMovementType.GetData;
        CheckListBoxTypes.items.Add(Copy(FMGetsMASMovementType.GetField('.01').FMDBExternal + '                                           ', 1, 43) + FMListBoxMASMovementType.GetSelectedRecord.IEN);
        y := StrToInt(FMListBoxMASMovementType.GetSelectedRecord.IEN);
        If (y = 10) Or
          (y = 18) Or
          (y = 31) Or
          (y = 32) Or
          (y = 33) Or
          (y = 34) Or
          (y = 35) Or
          (y = 40) Or
          (y = 41) Or
          (y = 43) Then
          CheckListBoxTypes.checked[x] := True;
      End;
  finally
    // CodeCR154 -MER 04/2011
    lWaitForm.Visible := False;
    FreeAndNil(lWaitForm);
    Screen.Cursor := crDefault;
  end;
End;

Procedure TfrmSpecialReport.FormShow(Sender: TObject);
Begin
  frmSpecialReport.buttonResetListClick(Application);
  DateTimePickerBdate.Date := Now;
  DateTimePickerEdate.Date := Now;
  rgReportFormat.Visible := True;  //CodeCR296 - rpm 2/2/12 - removed IsPatch149Installed check
End;

Procedure TfrmSpecialReport.ButtonRunReportClick(Sender: TObject);
Var
  i, x: integer;
  DateRangeHdr: String;
  IsDelimited: Boolean;  //CodeCR129 - rpm 10/14/10
  DelimitedLines: TStringList;  //CodeCR129 - rpm 10/14/10
  FileName: String;  //CodeCR129 - rpm 10/14/10
Begin
  FileName := '';  //CodeCR129 - rpm 10/14/10

  If DateTimePickerBdate.Date > DateTimePickerEDate.Date Then
  Begin
    ShowMessageCAPRI('Start date cannot be greater than stop date.');
    exit;
  End;
  i := 0;
  For x := 0 To CheckListBoxTypes.Items.Count - 1 Do // DC Movement Types
    If CheckListBoxTypes.Checked[x] = True Then
    Begin
      inc(i);
    End;
  If i = 0 Then
  Begin
    ShowMessageCAPRI('Please select at least one discharge type first.');
    exit;
  End;

  if (rgReportFormat.ItemIndex = 1) then    //CodeCR129 - rpm 10/13/10
    IsDelimited := True
  else
    IsDelimited := False;

  DelimitedLines := TStringList.Create;  //CodeCR129 - rpm 10/14/10

  try
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB REPORT SPECIAL'; // RE-PRINT C&P FINAL';
    i := 0;
    For x := 0 To CheckListBoxTypes.Items.Count - 1 Do // DC Movement Types
      If CheckListBoxTypes.Checked[x] = True Then
      Begin
        FMListBoxMASMovementType.ItemIndex := x; // Get from the FMListBox because it has IEN easily available
        frmMain.RPCBroker1.Param[1].Mult[IntToStr(i + 1)] := FMListBoxMASMovementType.GetSelectedRecord.IEN;
        inc(i);
      End;
    // The VistA function adds ".5" to these next two dates, so we'll do that too
    frmMain.RPCBroker1.Param[1].PType := list;
    frmMain.RPCBroker1.Param[2].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', StrToInt(Copy(FloatToStr(DateTimePickerBdate.Date), 1, Pos('.', FloatToStr(DateTimePickerBdate.Date)) - 1)) - 1)) +
      '.5'; // BDate
    frmMain.RPCBroker1.Param[2].PType := literal;
    frmMain.RPCBroker1.Param[3].Value := FMToDateConvert(FormatDateTime('mm/dd/yyyy', StrToInt(Copy(FloatToStr(DateTimePickerEdate.Date), 1, Pos('.', FloatToStr(DateTimePickerEdate.Date)) - 1)))) +
      '.5'; // EDate
    frmMain.RPCBroker1.Param[3].PType := literal;
    frmMain.RPCBroker1.Param[4].Value := FROStationNumber;  //CodeCR171 - rpm 4/28/11
    frmMain.RPCBroker1.Param[4].PType := literal;
    frmMain.RPCBroker1.Param[5].Value := Copy(RadioGroupReportType.Items[RadioGroupReportType.ItemIndex], 1, 1); // Type of Report
    frmMain.RPCBroker1.Param[5].PType := literal;
    //CodeCR129 - rpm 10/12/10 - add additional paramter for FINAL END DATE
    //                           to indicate delimited to RPC
    //CodeCR296 - rpm 2/2/12 - removed IsPatch149Installed check
    frmMain.RPCBroker1.Param[6].PType := literal;
    frmMain.RPCBroker1.Param[6].Value := GetDelimitedParam(IsDelimited);

    frmMain.AnimateLogo(True);
    frmMain.StatusBarLoadPt.Caption := 'Running report...';
    frmMain.StatusBarLoadPt.Repaint;
    Application.Processmessages;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'DVBAB REPORT SPECIAL could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.Processmessages;
        ShowMessageCAPRI('DVBAB REPORT SPECIAL could not be accessed!');
      End;
    End;

    if (frmMain.RPCBroker1.Results.Count > 0) then  //CodeCR129 - rpm 10/14/10
    begin
      if NOT AnsiStartsText('NO DATA FOUND', frmMain.RPCBroker1.Results[0]) then
        if IsDelimited then
          CAPRIQuickCopy(frmMain.RPCBroker1.Results, DelimitedLines)
        else
          CAPRIQuickCopy(frmMain.RPCBroker1.Results, frmReports.Reportmemo);
    end;

    if not IsDelimited then                                                     //CodeCR470 JRL 7/18/13
    begin
       DateRangeHdr := 'Date Range: '
                   + DateToStr(DateTimePickerBdate.Date)
                   + '-'
                   + DateToStr(DateTimePickerEdate.Date);  //CodeCR127 - rpm 8/10/2010
       frmReports.SpecialReportDtRangeHdr := DateRangeHdr;  //CodeCR127 - rpm 8/10/2010
    end;
    frmMain.AnimateLogo(False);

    if IsDelimited and (DelimitedLines.Count > 0) then  //CodeCR129 - rpm 10/14/10
    begin
//      FileName := frmReports.SaveDelimitedReport(DelimitedLines, 'SpecialReportAAPension'
//                                                  + '_'
//                                                  + FormatDateTime('YYYYMMDD', DateTimePickerBDate.Date)
//                                                  + '_'
//                                                  + FormatDateTime('YYYYMMDD', DateTimePickerEDate.Date));
      FileName := frmReports.SaveDelimitedReportCSV(DelimitedLines, 'SpecialReportAAPension'   // CodeCR470 JRL 4/15/13
                                                    + '_'
                                                    + FormatDateTime('YYYYMMDD', DateTimePickerBDate.Date)
                                                    + '_'
                                                    + FormatDateTime('YYYYMMDD', DateTimePickerEDate.Date));
      if (FileName <> '') then
      begin
        frmReports.ReportMemo.Lines.Insert(0, IntToStr(DelimitedLines.Count)
                                   + ' Extract lines saved to: ' + #13#10
                                   + FileName);
      end
      else
        frmReports.ReportMemo.Lines.Insert(0, 'No delimited text lines were saved!');
    end;

    if (frmReports.ReportMemo.Lines.Count = 0) and (DelimitedLines.Count = 0) then  //CodeCR129 - rpm 10/14/10
      frmReports.ReportMemo.Lines.Add('No data found for parameters entered.');

    if IsDelimited or (frmReports.ReportMemo.Lines.Count < 2) then   //CodeCR129 - rpm 10/27/10 add DateRangeHdr for delimited results
    begin
      frmReports.ReportMemo.Lines.Insert(0, '');
      frmReports.ReportMemo.Lines.Insert(0, DateRangeHdr);
    end;

    frmMain.StatusBarLoadPt.Caption := 'Ready.';
    frmMain.StatusBarLoadPt.Repaint;
    Application.Processmessages;
    modalresult := mrOK;
  finally
    FreeAndNil(DelimitedLines);
  end;
End;

Procedure TfrmSpecialReport.CheckListBoxTypesDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var
  temptext: String;
Begin
  With (Control As TCheckListBox).Canvas Do { draw on control canvas, not on the form }
  Begin
    Font.Color := clWindowText; {Set to default color}
    TempText := (Control As TCheckListBox).Items[Index];
    If ScreenReaderActive Then
    Begin
      If (Control As TCheckListBox).Checked[Index] = True Then
      Begin
        Temptext := 'Checked - ' + Temptext;
      End;
      If (Control As TCheckListBox).Checked[Index] = False Then
      Begin
        Temptext := 'Not Checked - ' + Temptext;
      End;
    End;
    Brush.Color := clWindow;
    FillRect(Rect); { clear the rectangle }
    TextOut(Rect.Left, Rect.Top, TempText); { display the text }
  End;
End;

Procedure TfrmSpecialReport.CheckListBoxTypesKeyUp(Sender: TObject;
  Var Key: Word; Shift: TShiftState);
Begin
  checkListBoxTypes.Repaint;
End;

{===========================================================================
 GetDelimitedParam
 Input: IsDelimited

 This function retrieves the delimited report parameter.
 //CodeCR129 - rpm 10/12/10
 ===========================================================================}
function TfrmSpecialReport.GetDelimitedParam(IsDelimited: Boolean): String;
begin
  if IsDelimited then  //delimited
    Result := FMToDateConvert(FormatDateTime('mm/dd/yyyy', DateTimePickerEDate.Date))
  else
    Result := '';   //plain text
end;

End.
