unit untBrkrMthds;

// DONE: LMS will we need this unit within CAPRI? Yes, at minimum RemoteClaimsLogin is being used.

interface

uses Windows, Forms, Controls, SysUtils, StrUtils, IniFiles, RpcConf1,
     { VistA Components }
     MFunStr
     , CCOWRPCBrokerCAPRI    // DONE: CodeCR457 - LMS Changed from CCOWRPCBroker
     , Trpcb, dialogsCAPRI, Fmcmpnts;

// DONE: LMS Later: All these methods are candidates for replacement
function EnsureBrokerConnected(Brkr: TCCOWRPCBrokerCAPRI): Boolean;
function IsProductionAccount(Brkr: TCCOWRPCBrokerCAPRI): Boolean;
function ReconnectBrokerIfDisconnected(Brkr: TCCOWRPCBrokerCAPRI): Boolean;

function GetRemoteAuthenticationToken(HmeBrkr: TCCOWRPCBrokerCAPRI): String;   // DONE: LMS CodeCR540 Expose security token for "get" for VLER / DAS authenticator
function RemoteClaimsLogin(HmeBrkr: TCCOWRPCBrokerCAPRI; RmtBrkr: TCCOWRPCBrokerCAPRI): Boolean;

procedure SetupRemoteBrkr(HmeBrkr: TCCOWRPCBrokerCAPRI; RmtBrkr: TCCOWRPCBrokerCAPRI);

// DONE: CodeCR457 - LMS - removed from interface. Used locally
//  SetupRemoteBrkr(HmeBrkr: TCCOWRPCBroker; RmtBrkr: TCCOWRPCBroker);

// DONE: CodeCR457 - LMS Not used - removed
//  function AuthenticateConn(Brkr: TCCOWRPCBroker): Boolean;

Const
  XWB_BADSIGNON = 20000 + 4;  //  TODO: LMS  this is a duplicate of same const in main.pas. Consolidate.
  CLMNSKEY: String = 'Action is the real measure of intelligence. -- Napolean Hill';
  // Note: VLERAUTHKEY is not compiled in CAPRI, so can't be reverse engineered out of this EXE. VLERAUTHKEY: String = 'The universe is equally as expansive within as without';

implementation

uses RpcSLogin
   , untConstVals
//   , untMiscMthds
   , CAPRISupport
   ;

function AuthenticateConn(Brkr: TCCOWRPCBrokerCAPRI): Boolean;
(*var
  i: Integer;
  Server, Port, x: String;*)
begin
  Result := true;
  (* DONE: CodeCR457 - lms not needed, wrapped into CAPRI
  Result := False;
  Server := '';
  Port := '';
  for i := 0 to ParamCount do
  begin
    x := UpperCase(Piece(ParamStr(i), '='));
    if (x = 'S') or (x = 'SERVER') then
      Server := Piece(ParamStr(i), '=', 2);
    if (x = 'P') or (x = 'PORT') then
      Port := Piece(ParamStr(i), '=', 2);
    if ((x = 'CCOW') and SameText(UpperCase(Piece(ParamStr(i), '=', 2)), 'OFF')) then
      Brkr.Contextor := nil;  { User Force Disable Context Management }
  end;  { End For Loop }
  if ((SameText(Server, '')) or (SameText(Port, ''))) then
  begin
    { Quit and terminate app if Server and/or Port are NOT Defined }
    if (GetServerInfo(Server, Port) = mrCancel) then
      Exit;
  end;  { End If Server or Port are nil }
  { Setup CCOWBroker with configuration info }
  Brkr.Server := ShortString(Copy(Server,1,Length(Server)));
  Brkr.ListenerPort := StrToInt(Port);
  try
    Brkr.Connected := True;  { Try and Connect to System }
    Brkr.ShowErrorMsgs := TRPCB.semQuiet;
    { Ensure User is authorized to access application context }
    if Brkr.CreateContext('DVBA CONTRACTED 2507 EXAM GUI') then
    begin
      Brkr.RPCTimeLimit := 28800;
      Result := True;
      Brkr.ShowErrorMsgs := TRPCB.semRaise;
    end  { End If Context was succesfully created }
    else
      Application.MessageBox(PChar(Brkr.User.StandardName +
           ' is not authorized to access this application.' + #13#10 +
           'User must be assigned secondary option: DVBA CONTRACTED 2507 EXAM GUI.'),
           'Authorization Error', MB_OK);
  except
    on E : EBrokerError do
    begin
      if (E.Code <> XWB_BADSIGNON) then
        Application.MessageBox(PChar(E.Message), 'Broker Error', MB_OK);
      Brkr.Connected := False;
    end;  { End EBrokerError }
  end;  { End Try/Except }
  *)
end;

function EnsureBrokerConnected(Brkr: TCCOWRPCBrokerCAPRI): Boolean;
begin
  Result := false;
  try
    if not CallRPC(Brkr, 'XWB GET VARIABLE VALUE', ['DUZ'], nil, True) then
      exit;
    //tempDUZ := Brkr.Results[0];
  except on e: exception do
    Brkr.Connected := true;          // if it fails, then error will be raised to let user know.
  end;
  Result := Brkr.Connected;
  if result then
    application.ProcessMessages;  // allow timers to do their thing
end;

function ReconnectBrokerIfDisconnected(Brkr: TCCOWRPCBrokerCAPRI): Boolean;
var
  SavBrkrShowErrorMsgs : TShowErrorMsgs; //  DONE: LMS Values not being saved and set back to original properly.
  SavBrkrKL, SavBrkrPD : Boolean;
  SavBrkrLM : TLoginMode;
begin
  //Result := true;
  // TODO: LMS if it doesn't work, I may not do it. Result := SilentLogin(Brkr);
  (* DONE: lms rewritten , wrapped into CAPRI *)

  Result := Brkr.Connected;
  { Reconnect Silently if Broker Connection is lost.
    Access/Verify codes should still be assigned to Broker object }
  if Not Result then
  begin
    try
      SavBrkrKL := Brkr.KernelLogIn;
      SavBrkrLM := Brkr.LogIn.Mode;
      SavBrkrPD := Brkr.LogIn.PromptDivision;
      SavBrkrShowErrorMsgs := Brkr.ShowErrorMsgs;
      try
        Brkr.KernelLogIn := False;
        Brkr.LogIn.Mode := lmAVCodes;
        Brkr.LogIn.PromptDivision := False;
        Brkr.ShowErrorMsgs := semQuiet;

        Brkr.Connected := True;
        Result := SilentLogin(Brkr); // TODO: LMS Brkr.Connected;  Not sure if this is totally silent. Also need to add error handling.
      finally
        Brkr.KernelLogIn := SavBrkrKL;
        Brkr.LogIn.Mode := SavBrkrLM;
        Brkr.LogIn.PromptDivision := SavBrkrPD;
        Brkr.ShowErrorMsgs := SavBrkrShowErrorMsgs;
      end;
    except
      Result := false;
    end;
  end;  { End If Not Currently Connected }
end;

function IsProductionAccount(Brkr: TCCOWRPCBrokerCAPRI): Boolean;
begin
  //Result := true;
  (* DONE: lms NOT removing *)
  // Result := Brkr.Login.IsProductionAccount;  // TODO: LMS later, this may be sufficient and a server call may not be necessary.
  Result := False;
  Brkr.RemoteProcedure := 'DVBAB CCOW';
  Brkr.Param[0].Value := '2';
  Brkr.Param[0].PType := literal;
  try
    Brkr.Call;
    Result := (StrToIntDef(Brkr.Results[0], 0) > 0);
  except
    on E: Exception do
    begin
      Application.MessageBox(PChar('Unable to determine if Production Account.' +
           #13#10#13#10 + E.Message), 'Broker Error', MB_OK);
    end;  { End Exception Handling - Identify account type as Test }
  end;  { End Try/Except Block }
  (**)
end;

  // DONE: lms removed from interface section.
procedure SetupRemoteBrkr(HmeBrkr: TCCOWRPCBrokerCAPRI; RmtBrkr: TCCOWRPCBrokerCAPRI);
var
  ini: TIniFile;
  ClaimsServer, TestClaimsServer, X: String;
  ClaimsPort, TestClaimsPort: Integer;
begin

  // ClaimsServer info stored in .ini file  -jltp 07-Mar-2013   // LMS: Could use INI file to override the hard coded default values.
  ini := TIniFile.Create(Piece(Application.ExeName, '.') + '.ini');
  ClaimsServer := ini.ReadString('Servers', 'ClaimsServer', 'claims.forum.domain');
  TestClaimsServer := ini.ReadString('Servers', 'TestClaimsServer', 'vista.tbaisc.domain.ext');
  X := ini.ReadString('Servers', 'ClaimsPort', '9400');
  ClaimsPort := StrToInt(X);
  X := ini.ReadString('Servers', 'TestClaimsPort', '9401');
  TestClaimsPort := StrToInt(X);

  if IsProductionAccount(HmeBrkr) then
    with  RmtBrkr do
    begin
      Server := ClaimsServer;
      ListenerPort := ClaimsPort;
    end  { End With for Broker - Production Account (CLAIMS) }
  else  { Test Account Connection to TESTCLAIMS System }
    with  RmtBrkr do
    begin
      Server := TestClaimsServer;
      ListenerPort := TestClaimsPort;
    end;  { End With for Broker - Test Account (TESTCLAIMS) }
  ini.Free;
end;
(**)

/// Returns authentication token from home broker that can be combined with Application Key to create a security phrase for RPC Broker BSE login to remote broker.
/// e.g. RmtBrkr.SecurityPhrase := CLMNSKEY + '^' + GetRemoteAuthenticationToken(HmeBrkr);
function GetRemoteAuthenticationToken(HmeBrkr: TCCOWRPCBrokerCAPRI): String;    // LMS: 2013-12-10 Refactored to use with CCR as well as VLER Authentication
var
  HmeBSEToken, HmeListenerPort : string;
begin
  Result := '';
  { BSE Doc on VDL indicates Public RPC, but FORUM shows as Private #5501
    CAPRI does NOT have an IA. }
  HmeBrkr.RemoteProcedure := 'XUS SET VISITOR';    // DONE: LMS check into need for set context to DVBA CAPRI GUI as per Joel.. may be outdated or not relevant? Yes, Context is needed to double ensure only CAPRI authenticated users connect.
  HmeBrkr.Call;
  if (HmeBrkr.Connected and (HmeBrkr.Results.Count > 0)) then
  begin
    { Setup automatic remote guest login to appropriate CLAIMS system.
      Security = KEY in REMOTE APPLICATION File (8994.5) Connected to B-Type
                 Context Option ^ BSE Token created from XUS SET VISTOR
                 RPC Call ^ VistA Instance Number (Station Number) ^
                 Broker Home Port # for Remote Server to call back on }
    HmeBSEToken := HmeBrkr.Results[0];
    HmeListenerPort := IntToStr(HmeBrkr.ListenerPort);
    Result := HmeBSEToken + '^' + TCCOWRPCBrokerCAPRI(HmeBrkr).Station + '^' + HmeListenerPort;  // DONE: LMS This is the only place we use station instead of division.   $$SITE^VASITE always returns that same Station# (and it is associated with the VistA instance that user has first authenticated to)
  end;
end;

function RemoteClaimsLogin(HmeBrkr: TCCOWRPCBrokerCAPRI; RmtBrkr: TCCOWRPCBrokerCAPRI): Boolean;
begin
  Result := False;
  { Determine Server Location/Connection Info - TESTCLAIMS or CLAIMS (Production)
    Note: For Use in TEST ACCOUNTS the user must be assigned the Security Key
          ZJFW CONTRACTED EXM TEST. Also DEVFEX is configured in TESTCLAIMS
          HL LOGICAL Link File to callback. Any additional Test Accounts will
          need to be configured if connection is required. }
  SetupRemoteBrkr(HmeBrkr, RmtBrkr);
  { Create BSE Token }
  try
    RmtBrkr.SecurityPhrase := GetRemoteAuthenticationToken(HmeBrkr);
    if RmtBrkr.SecurityPhrase <> '' then
    begin
      RmtBrkr.SecurityPhrase := CLMNSKEY + '^' + RmtBrkr.SecurityPhrase;
      RmtBrkr.Connected := True;  { Try and Connect to Remote System }
      if RmtBrkr.Connected then
      begin
        RmtBrkr.CreateContext(CAPRICCRREMOTEACCESSOPTION); // 'DVBA CONTRACTED 2507 EXAM GUI');
        RmtBrkr.RPCTimeLimit := 28800;
        {$IFDEF CAPRIDEVELOPER}
        RmtBrkr.RPCTimeLimit := 2880000;  //  LMS - for debugging
        {$ENDIF}
        Result := True;
      end;  { End If Connection to remote system successful }
    end;  { Host/Home Broker is connected and RPC returned results }
  except
    on E: EBrokerError do
    begin
      ShowMessageCAPRI('Remote broker error: ' + #13#10 + PChar((E.Message)));
      {TODO: CKU -> bug E.Message is viewed as unicode chars on Win 7. }
    end;  { End Exception Handling Block }
  end;  { End Try/Except Block }
  (**)
end;

end.
