unit viewaddress;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  Diaccess,
  DiTypLib,
  Fmcmpnts,
  Fmcntrls,
  Main,
  TRPCB,
  ExtCtrls,
  CCOWRPCBrokerCAPRI,
  GifImage, AccessibilityUtils, VA508AccessibilityManager,
  CAPRISupport;  // CodeCR694 JRL 3/27/15

type
  TfrmAddress = class(TForm)
    FMEditStreet1: TFMEdit;
    lblAddress1: TLabel;
    FMEditStreet2: TFMEdit;
    FMEditStreet3: TFMEdit;
    lblCity: TLabel;
    FMEditCity: TFMEdit;
    lblState: TLabel;
    lblZip: TLabel;
    FMEditZip: TFMEdit;
    lblCounty: TLabel;
    lblPhone: TLabel;
    FMEditPhone: TFMEdit;
    lblOffice: TLabel;
    FMEditOffice: TFMEdit;
    FMGetsPtAddress: TFMGets;
    FMEditCounty: TFMEdit;
    FMEditState: TFMEdit;
    lblTempAddr: TLabel;
    lblTempActive: TLabel;
    FMEditTempActive: TFMEdit;
    FMEditTempStartDate: TFMEdit;
    lblTempStartDate: TLabel;
    lblTempStreet1: TLabel;
    FMEditTempStreet1: TFMEdit;
    FMEditTempStreet2: TFMEdit;
    FMEditTempStreet3: TFMEdit;
    lblTempEndDate: TLabel;
    FMEditTempEndDate: TFMEdit;
    FMEditTempCity: TFMEdit;
    lblTempCity: TLabel;
    lblTempState: TLabel;
    FMEditTempState: TFMEdit;
    FMEditTempZip: TFMEdit;
    lblTempZip: TLabel;
    lblTempCounty: TLabel;
    lblTempPhone: TLabel;
    FMEditTempPhone: TFMEdit;
    FMEditTempCounty: TFMEdit;
    lblPermAddr: TLabel;
    ButtonOK: TButton;
    ButtonEditAddress: TButton;
    CountyFake: TEdit;
    btnSaveAddress: TButton;
    StateFake: TEdit;
    lblAddress2: TLabel;
    lblAddress3: TLabel;
    Panel1: TPanel;
    AddressDate: TFMEdit;
    lblAddressDate: TLabel;
    Panel2: TPanel;
    FMStatesList: TFMListBox;
    ButtonStateAccept: TButton;
    Panel3: TPanel;
    FMCountiesList: TFMListBox;
    ButtonCountyAccept: TButton;
    Label15: TLabel;
    Label16: TLabel;
    lblCountry: TLabel;
    lblTempCountry: TLabel;
    lblProvince: TLabel;
    lblPostalCode: TLabel;
    lblTempProvince: TLabel;
    lblTempPostalCode: TLabel;
    FMEditTempProvince: TFMEdit;
    FMEditTempPostalCode: TFMEdit;
    FMListerCountry: TFMLister;
    cboCountry: TComboBox;
    cboTempCountry: TComboBox;
    FMEditProvince: TFMEdit;
    FMEditPostalCode: TFMEdit;
    FMGetsCountry: TFMGets;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    st508TempCountry: TVA508StaticText;
    lblCellPhone: TLabel;
    FMEditCell: TFMEdit;
    lblEmail: TLabel;
    FMEditEmail: TFMEdit;
    lblTempStreet2: TLabel;
    lblTempStreet3: TLabel;
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonEditAddressClick(Sender: TObject);
    procedure FMEditStreet1Exit(Sender: TObject);
    procedure StateFakeEnter(Sender: TObject);
    procedure ButtonStateAcceptClick(Sender: TObject);
    procedure FMStatesListDblClick(Sender: TObject);
    procedure FMCountiesListDblClick(Sender: TObject);
    procedure ButtonCountyAcceptClick(Sender: TObject);
    procedure CountyFakeEnter(Sender: TObject);
    procedure btnSaveAddressClick(Sender: TObject);
    procedure StateFakeChange(Sender: TObject);
    procedure CountyFakeChange(Sender: TObject);
    procedure FMEditStateEnter(Sender: TObject);
    procedure Panel3Exit(Sender: TObject);
    procedure Panel2Exit(Sender: TObject);
    procedure FMStatesListKeyPress(Sender: TObject; var Key: Char);
    procedure FMCountiesListKeyPress(Sender: TObject; var Key: Char);
    procedure FMStatesListExit(Sender: TObject);
    procedure FMCountiesListExit(Sender: TObject);
    procedure FMEditCountyEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cboCountryChange(Sender: TObject);
    procedure cboTempCountryChange(Sender: TObject);
  private
    { Private declarations }
    procedure CMDialogKey(var Msg: TWMKey); message CM_DIALOGKEY;
    function GetCountryList(aComboBox: TComboBox): Boolean;
    function IsForeignCountry(aCountry: String): Boolean;
    procedure EnableForeign(isForeign: Boolean; isTempAddr: Boolean; isEdit: Boolean);
    function GetCountryName(aCountryIEN: String): String;
    procedure UpdateTempEditsFor508;
  public
    { Public declarations }
    procedure PopulateCountry;
  end;

var
  frmAddress: TfrmAddress;
  NextControl: string;

implementation

{$R *.DFM}

procedure TfrmAddress.CMDialogKey(var Msg: TWMKEY);
begin
  if (ActiveControl = FMEditCity) then begin
    if Msg.Charcode = VK_TAB then
      NextControl := '';
  end;

  if (ActiveControl = FMEditZip) then begin
    if Msg.Charcode = VK_TAB then
      NextControl := '';
  end;

  if (ActiveControl = FMStatesList) then begin
    if Msg.Charcode = VK_TAB then
      if GetasyncKeyState(VK_SHIFT) <> 0 then begin
        NextControl := 'CITY';
        Msg.Charcode := 0; // to eat the tab key!
        FMStatesListExit(Application);
      end;
  end;

  if (ActiveControl = FMCountiesList) then begin
    if Msg.Charcode = VK_TAB then
      if GetasyncKeyState(VK_SHIFT) <> 0 then begin
        NextControl := 'ZIP';
        Msg.Charcode := 0; // to eat the tab key!
        FMCountiesListExit(Application);
      end;
  end;

  inherited;
end;

procedure TfrmAddress.ButtonOKClick(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmAddress.ButtonEditAddressClick(Sender: TObject);
var
  buttonloc: integer;
begin
  ButtonEditAddress.Enabled := False;
  ButtonEditAddress.sendtoback;
  ButtonOK.Caption := '&Don''t Save';
  ButtonOK.BringToFront;

  buttonloc := ButtonOK.left;
  ButtonOK.left := btnSaveAddress.Left;
  btnSaveAddress.Left := buttonloc;

  // modalresult:=mrcancel;
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      //jcs - d2006
      //frmMain.GIFImageVistaYellow.Animate := False;
      TGifImage(frmMain.GIFImageVistaYellow).Animate := False;
      frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB CHECK CREDENTIALS could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
    end;
  end;
  if frmMain.RPCBroker1.Results[0] <> '[OK]' then begin
    ShowMessageCAPRI(frmMain.RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  end;
  // If credentials are ok, then continue
  btnSaveAddress.Enabled := True;

  StateFake.Text := FMEditState.Text;

  btnSaveAddress.Enabled := True;
  cboCountry.Color := clYellow;
  FMEditStreet1.Color := clYellow;
  FMEditStreet2.Color := clYellow;
  FMEditStreet3.Color := clYellow;
  FMEditCity.Color := clYellow;
  FMEditState.Color := clYellow;
  FMEditZip.Color := clYellow;
  FMEditProvince.Color := clYellow;
  FMEditPostalCode.Color := clYellow;
  CountyFake.Color := clYellow;
  FMEditPhone.Color := clYellow;
  FMEditOffice.Color := clYellow;
  If IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR694 JRL 3/27/15
  begin                                                                         // CodeCR694 JRL 3/27/15
    FMEditCell.Color := clYellow;                                               // CodeCR694 JRL 3/12/15
    FMEditEmail.Color := clYellow;                                              // CodeCR694 JRL 3/12/15
  end;                                                                          // CodeCR694 JRL 3/27/15
  AddressDate.Color := clYellow;
  cboCountry.Enabled := True;
  FMEditStreet1.enabled := True;
  FMEditStreet2.enabled := True;
  FMEditStreet3.enabled := True;
  FMEditCity.enabled := True;
  if IsForeignCountry(cboCountry.Text) then
  begin
    FMEditProvince.Enabled := True;
    FMEditPostalCode.Enabled := True;
  end
  else
  begin
    FMEditState.enabled := True;
    FMEditZip.enabled := True;
    CountyFake.enabled := True;
    CountyFake.BringToFront;

    StateFake.Enabled := True;
    StateFake.BringToFront;
  end;

  FMEditPhone.enabled := True;
  FMEditOffice.enabled := True;

  If IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR694 JRL 3/27/15
  begin                                                                         // CodeCR694 JRL 3/27/15
    FMEditCell.Enabled := TRUE;                                                 // CodeCR694 JRL 3/12/15
    FMEditEmail.Enabled := TRUE;                                                // CodeCR694 JRL 3/12/15
  end;                                                                          // CodeCR694 JRL 3/27/15
  AddressDate.enabled := true;

  StateFake.BringToFront;

  FMEditState.Enabled := False;
  FMEditCounty.Enabled := False;
  UpdateTempEditsFor508; // -MER CodeCR115 10/2010
  FMEditStreet1.Setfocus;
end;

// -MER CodeCR115 10/2010
procedure TfrmAddress.UpdateTempEditsFor508;
begin
  if ScreenReaderActive then begin
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempActive));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempStartDate));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempEndDate));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempStreet1));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempStreet2));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempStreet3));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempCity));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempState));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempZip));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempProvince));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempPostalCode));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempCounty));
    ConfigDisabledEditBoxForScreenReader(TEdit(FMEditTempPhone));
    st508TempCountry.Caption := 'Country: Read Only.  Value is ' + cboTempCountry.Text;
    st508TempCountry.Visible := TRUE;
  end;
end;

procedure TfrmAddress.FMEditStreet1Exit(Sender: TObject);
var
  x: integer;
  tempEdit: TEdit;
begin
  tempEdit := Sender as TEdit;
  // Remove trailing spaces
  if Length(TempEdit.Text) > 0 then begin
    x := length(TempEdit.text);
    repeat begin
        if Copy(TempEdit.Text, x, 1) = ' ' then
          TempEdit.Text := copy(TempEdit.text, 1, x - 1)
        else
          x := 1;
        dec(x);
    end until x = 0;
  end;
  // Remove leading spaces
  if Length(TempEdit.Text) > 0 then begin
    x := 0;
    repeat begin
        if Copy(TempEdit.Text, 1, 1) = ' ' then begin
          TempEdit.Text := copy(TempEdit.text, 2, length(TempEdit.text) - 1);
          dec(x);
        end
        else
          x := length(TempEdit.text);
        inc(x);
    end until x > length(TempEdit.text);
  end;
  TempEdit.Text := Uppercase(TempEdit.Text);
end;

procedure TfrmAddress.StateFakeEnter(Sender: TObject);
begin
  Panel2.BringToFront;
  Panel2.visible := True;
  FMStatesList.BringToFront;
  ButtonStateAccept.BringToFront;
  FMStatesList.Visible := True;
  ButtonStateAccept.Visible := True;
  try
  FMStatesList.SetFocus except
  end;
  if FMStatesList.ItemIndex > -1 then begin
    TempIEN := FMStatesList.GetSelectedRecord.IEN;
  end
  else
    TempIEN := '';
end;

procedure TfrmAddress.ButtonStateAcceptClick(Sender: TObject);
begin
  // Reload Counties
  if FMStatesList.ItemIndex > -1 then begin

    frmMain.FMListerCounties.IENS := ',' + FMStatesList.GetSelectedRecord.IEN;
    frmMain.fmListerCounties.GetList(FMCountiesList.Items);
    if TempIEN <> FMStatesList.GetSelectedRecord.IEN then begin
      // State has changed, so clear county
      FMEditCounty.Text := '';
      CountyFake.Text := '';
      FMCountiesList.ItemIndex := -1;
    end;

    FMEditState.Text := '`' + FMStatesList.GetSelectedRecord.IEN;
    StateFake.Text := FMStatesList.Items[FMStatesList.ItemIndex];
    Panel2.Visible := False;
    FMStatesList.Visible := False;
    ButtonStateAccept.Visible := False;
    if StateFake.Text = 'CANADA' then begin
      FMEditZip.Text := '@';
      FMEditZip.Visible := False;
    end
    else begin
      FMEditZip.Visible := True;
      if FMEditZip.Text = '@' then
        FMEditZip.Text := '';
    end;
  end;

  if NextControl = 'CITY' then begin
    FMEditCity.SetFocus;
  end
  else
    if nextcontrol = '' then try
        FMEditZip.SetFocus;
      except
      end
    else
      nextcontrol := '';

end;

procedure TfrmAddress.FMStatesListDblClick(Sender: TObject);
begin
  // Reload Counties
  frmMain.FMListerCounties.IENS := ',' + FMStatesList.GetSelectedRecord.IEN;
  frmMain.fmListerCounties.GetList(FMCountiesList.Items);
  if TempIEN <> FMStatesList.GetSelectedRecord.IEN then begin
    // State has changed, so clear county
    FMEditCounty.Text := '';
    CountyFake.Text := '';
    FMCountiesList.ItemIndex := -1;
  end;

  FMEditState.Text := '`' + FMStatesList.GetSelectedRecord.IEN;
  StateFake.Text := FMStatesList.Items[FMStatesList.ItemIndex];
  Panel2.Visible := False;
  FMStatesList.Visible := False;
  ButtonStateAccept.Visible := False;
end;

procedure TfrmAddress.cboCountryChange(Sender: TObject);
begin
  if IsForeignCountry(cboCountry.Text) then
    EnableForeign(True, False, True)
  else
    EnableForeign(False, False, True);
end;

procedure TfrmAddress.cboTempCountryChange(Sender: TObject);
begin
  if IsForeignCountry(cboTempCountry.Text) then
    EnableForeign(True, True, True)
  else
    EnableForeign(False, True, True);
end;

procedure TfrmAddress.FMCountiesListDblClick(Sender: TObject);
begin
  FMEditCounty.Text := '`' + FMCountiesList.GetSelectedRecord.IEN;
  CountyFake.Text := FMCountiesList.Items[FMCountiesList.ItemIndex];
  Panel3.Visible := False;
  FMCountiesList.Visible := False;
  ButtonCountyAccept.Visible := False;
end;

procedure TfrmAddress.ButtonCountyAcceptClick(Sender: TObject);
begin
  if FMCountiesList.ItemIndex > -1 then begin
    FMEditCounty.Text := '`' + FMCountiesList.GetSelectedRecord.IEN;
    CountyFake.Text := FMCountiesList.Items[FMCountiesList.ItemIndex];
  end;
  Panel3.Visible := False;
  FMCountiesList.Visible := False;
  ButtonCountyAccept.Visible := False;

  if NextControl = 'ZIP' then begin
    FMEditZIP.SetFocus;
  end
  else
    if nextcontrol = '' then try
        FMEditPhone.SetFocus;
      except
      end
    else
      nextcontrol := '';
end;

procedure TfrmAddress.CountyFakeEnter(Sender: TObject);
begin
  FMCountiesList.BringToFront;
  ButtonCountyAccept.BringToFront;
  Panel3.Visible := True;
  Panel3.BringToFront;
  FMCountiesList.Visible := True;
  ButtonCountyAccept.Visible := True;
  try
  FMCountiesList.SetFocus except
  end;
end;

procedure TfrmAddress.EnableForeign(isForeign: Boolean; isTempAddr: Boolean; isEdit: Boolean);
begin
  if isTempAddr then
  begin
    lblTempProvince.Visible := isForeign;
    FMEditTempProvince.Visible := isForeign;

    lblTempPostalCode.Visible := isForeign;
    FMEditTempPostalCode.Visible := isForeign;

    lblTempZip.Visible := not isForeign;
    FMEditTempZip.Visible := not isForeign;

    lblTempState.Visible := not isForeign;
    FMEditTempState.Visible := not isForeign;

    lblTempCounty.Visible := not isForeign;
    FMEditTempCounty.Visible := not isForeign;
  end
  else
  begin
    lblProvince.Visible := isForeign;
    FMEditProvince.Visible := isForeign;

    lblPostalCode.Visible := isForeign;
    FMEditPostalCode.Visible := isForeign;

    lblZip.Visible := not isForeign;
    FMEditZip.Visible := not isForeign;

    lblState.Visible := not isForeign;
    FMEditState.Visible := not isForeign;
    StateFake.Visible := not isForeign;

    lblCounty.Visible := not isForeign;
    FMEditCounty.Visible := not isForeign;
    CountyFake.Visible := not isForeign;
    if isEdit then
    begin
      FMEditProvince.Enabled := isForeign;
      FMEditPostalCode.Enabled := isForeign;
      FMEditZip.Enabled := not isForeign;
      FMEditState.Enabled := not isForeign;
      StateFake.Enabled := not isForeign;
      FMEditCounty.Enabled := not isForeign;
      CountyFake.Enabled := not isForeign;
    end;
  end;
end;

procedure TfrmAddress.btnSaveAddressClick(Sender: TObject);
var
  Save_Cursor: TCursor;
  x: integer;
begin
  if isForeignCountry(cboCountry.Text) then
  begin
    if StateFake.Text <> '' then
      StateFake.Text := '@';
    if CountyFake.Text <> '' then
      CountyFake.Text := '@';
    if FMEditZip.Text <> '' then
      FMEditZip.Text := '@';
  end
  else
  begin
    if FMEditProvince.Text <> '' then
      FMEditProvince.Text := '@';
    if FMEditPostalCode.Text <> '' then
      FMEditPostalCode.Text := '@';
  end;

  modalresult := mrOK;
  exit;

  // The following code saves address.
  // It's been disabled, per VBA's request

  //
  if (FMEditStreet1.Text <> '') and (Length(FMEditStreet1.Text) < 3) then begin
    ShowMessageCAPRI('Street Address Line 1 is too short.');
    exit;
  end;
  if (FMEditStreet2.Text <> '') and (Length(FMEditStreet2.Text) < 3) then begin
    ShowMessageCAPRI('Street Address Line 2 is too short.');
    exit;
  end;
  if (FMEditStreet3.Text <> '') and (Length(FMEditStreet3.Text) < 3) then begin
    ShowMessageCAPRI('Street Address Line 2 is too short.');
    exit;
  end;
  if (FMEditCity.Text <> '') and (Length(FMEditCity.Text) < 2) then begin
    ShowMessageCAPRI('City is too short.');
    exit;
  end;
  if Application.MessageBox('Are you sure you want to update the address in VistA?', 'Update Address', 4) = 6 then begin
    TimeSinceLastBrokerCall := 0; // Prevent event
    if ANURemoteProcedureCallInProgress = True then
      repeat application.processmessages until ANURemoteProcedureCallInProgress = False;
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass; { Show hourglass cursor }
    if FMEditStreet1.FMModified then
      if FMEditStreet1.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditStreet1);
        FMEditStreet1.Text := FMEditStreet1.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditStreet1.Text := FMEditStreet1.FMTag;
      end;
    if FMEditStreet2.FMModified then
      if FMEditStreet2.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditStreet2);
        FMEditStreet2.Text := FMEditStreet2.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditStreet2.Text := FMEditStreet2.FMTag;
      end;
    if FMEditStreet3.FMModified then
      if FMEditStreet3.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditStreet3);
        FMEditStreet3.Text := FMEditStreet3.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditStreet3.Text := FMEditStreet3.FMTag;
      end;
    if FMEditCity.FMModified then
      if FMEditCity.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditCity);
        FMEditCity.Text := FMEditCity.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditCity.Text := FMEditCity.FMTag;
      end;
    if FMEditState.FMModified then
      if FMEditState.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditState);
        FMEditState.Text := FMEditState.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditState.Text := FMEditState.FMTag;
      end;
    if FMEditZip.FMModified then
      if FMEditZip.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditZip);
        FMEditZip.Text := FMEditZip.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditZip.Text := FMEditZip.FMTag;
      end;
    if FMEditPhone.FMModified then
      if FMEditPhone.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditPhone);
        FMEditPhone.Text := FMEditPhone.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditPhone.Text := FMEditPhone.FMTag;
      end;
    if FMEditOffice.FMModified then
      if FMEditOffice.Validate then begin
        frmMain.fmFiler2.AddChgdControl(FMEditOffice);
        FMEditOffice.Text := FMEditOffice.FMCtrlExternal;
      end
      else begin
        frmMain.FMValidator1.DisplayErrors;
        FMEditOffice.Text := FMEditOffice.FMTag;
      end;
    // the following code isn't currently executed, but was updated in case the 
    // functionality was added back in the future.  This code has not been
    // tested.  CodeCR694 JRL 3/12/15  
    
//    if FMEditCell.FMModified then                                               
//      if FMEditCell.Validate then begin                                         
//        frmMain.fmFiler2.AddChgdControl(FMEditCell);                            
//        FMEditCell.Text := FMEditCell.FMCtrlExternal;                           
//      end                                                                       
//      else begin                                                                
//        frmMain.FMValidator1.DisplayErrors;                                     
//        FMEditCell.Text := FMEditCell.FMTag;                                    
//      end;                                                                      
//    if FMEditEmail.FMModified then                                              
//      if FMEditEmail.Validate then begin                                        
//        frmMain.fmFiler2.AddChgdControl(FMEditEmail);                           
//        FMEditEmail.Text := FMEditCell.FMCtrlExternal;                          
//      end                                                                       
//      else begin                                                                
//        frmMain.FMValidator1.DisplayErrors;                                     
//        FMEditEmail.Text := FMEditEmail.FMTag;                                  
//      end;

    // End code addition.  CodeCR694 JRL 3/12/15
                
    for x := 0 to 10 do begin
    end; // Not sure why, but it bombs if I don't have a line of code here.
    //ShowMessageCAPRI('ok');
    if frmMain.fmFiler2.AnythingToFile then
      if frmMain.fmFiler2.DataProblemCheck then
        frmMain.fmFiler2.ProcessDataProblemList
      else begin
        if frmMain.fmFiler2.Update then begin
          // Only update county if there is a change and the IEN
          // is in the box.
          if FMEditCounty.Text <> '' then
            if Copy(FMEditCounty.Text, 1, 1) = '`' then begin
              if FMEditCounty.FMModified then
                if FMEditCounty.Validate then begin
                  frmMain.fmFiler2.AddChgdControl(FMEditCounty);
                  FMEditCounty.Text := FMEditCounty.FMCtrlExternal;
                end
                else begin
                  frmMain.FMValidator1.DisplayErrors;
                  FMEditCounty.Text := FMEditCounty.FMTag;
                end;
              if frmMain.fmFiler2.AnythingToFile then
                if frmMain.fmFiler2.DataProblemCheck then
                  frmMain.fmFiler2.ProcessDataProblemList
                else frmMain.fmFiler2.Update;
            end;
          frmMain.btnRefreshPtDemographicsClick(Application);
          frmMain.btnRefreshAddressClick(Application);
          //FMGetsPtAddress.GetAndFill;
        end;
      end
    else
      ShowMessageCAPRI('No changes to file!');
    Screen.Cursor := Save_Cursor; { Always restore to normal }
  end;
  ModalResult := mrOK;
end;

procedure TfrmAddress.StateFakeChange(Sender: TObject);
begin
  if StateFake.Text = 'CANADA' then begin
    FMEditZip.Text := '@';
    FMEditZip.Visible := False;
  end
  else begin
    FMEditZip.Visible := True;
    if FMEditZip.Text = '@' then
      FMEditZip.Text := '';
  end;
end;

procedure TfrmAddress.CountyFakeChange(Sender: TObject);
begin
  if StateFake.Text = 'CANADA' then begin
    FMEditZip.Text := '@';
    FMEditZip.Visible := False;
  end
  else begin
    FMEditZip.Visible := True;
    if FMEditZip.Text = '@' then
      FMEditZip.Text := '';
  end;
end;

procedure TfrmAddress.FMEditStateEnter(Sender: TObject);
begin
  FMEditCity.Setfocus;
end;

procedure TfrmAddress.Panel3Exit(Sender: TObject);
begin
  Panel3.Visible := False;
end;

procedure TfrmAddress.PopulateCountry;
var
  aCountryIEN: String;
  aCountryName: String;
begin
  try
    //Country (#.1773) field
    aCountryIEN := FMGetsPtAddress.GetField('.1173').FMDBInternal;
    aCountryName := GetCountryName(aCountryIEN);
    if aCountryName <> '' then
      cboCountry.ItemIndex := cboCountry.Items.IndexOf(aCountryName)
    else
      cboCountry.ItemIndex := -1;
    if cboCountry.Text <> '' then
    begin
      if IsForeignCountry(cboCountry.Text) then
        EnableForeign(True, False, False)
      else
        EnableForeign(False, False, False);
    end;

    //Temporary Address Country (#.1223) field
    aCountryIEN := FMGetsPtAddress.GetField('.1223').FMDBInternal;
    aCountryName := GetCountryName(aCountryIEN);
    if aCountryName <> '' then
      cboTempCountry.ItemIndex := cboTempCountry.Items.IndexOf(aCountryName)
    else
      cboTempCountry.ItemIndex := -1;
    if cboTempCountry.Text <> '' then
    begin
      if IsForeignCountry(cboTempCountry.Text) then
        EnableForeign(True, True, False)
      else
        EnableForeign(False, True, False);
    end;
  except
    //do nothing
  end;
end;

procedure TfrmAddress.Panel2Exit(Sender: TObject);
begin
  Panel2.Visible := False;
end;

procedure TfrmAddress.FMStatesListKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = char(13) then
    ButtonStateAcceptClick(Application);
end;

procedure TfrmAddress.FormCreate(Sender: TObject);
begin
  GetCountryList(cboCountry);
  GetCountryList(cboTempCountry);
  If IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR694 JRL 3/27/15
  begin                                                                         // CodeCR694 JRL 3/27/15
    lblCellPhone.Visible := TRUE;                                               // CodeCR694 JRL 3/27/15
    lblEmail.Visible := TRUE;                                                   // CodeCR694 JRL 3/27/15
    FMEditCell.Visible := TRUE;                                                 // CodeCR694 JRL 3/27/15
    FMEditEmail.Visible := TRUE;                                                // CodeCR694 JRL 3/27/15
  end                                                                           // CodeCR694 JRL 3/27/15
  else                                                                          // CodeCR694 JRL 3/27/15
  begin                                                                         // CodeCR694 JRL 3/27/15
    lblCellPhone.Visible := FALSE;                                              // CodeCR694 JRL 3/27/15
    lblEmail.Visible := FALSE;                                                  // CodeCR694 JRL 3/27/15
    FMEditCell.Visible := FALSE;                                                // CodeCR694 JRL 3/27/15
    FMEditEmail.Visible := FALSE;                                               // CodeCR694 JRL 3/27/15
  end;                                                                          // CodeCR694 JRL 3/27/15
end;

function TfrmAddress.GetCountryList(aComboBox: TComboBox): Boolean;
var
  I: Integer;
  aRecord: TFMRecordObj;
  aField: TFMFieldObj;
  aFieldVal: String;
begin
  Result := False;
  try
    FMListerCountry.GetList(nil);
    if FMListerCountry.Results.Count > 0 then
    begin
      for I := 0 to FMListerCountry.Results.Count - 1 do
      begin
        aRecord := FMListerCountry.GetRecord(FMListerCountry.Results[I]);
        //return Postal Name when not <NULL>; otherwise return uppercase description
        aField := aRecord.GetField('1.3');
        aFieldVal := aField.FMDBExternal;
        if aFieldVal = '<NULL>' then
        begin
          aField := aRecord.GetField('2');
          aFieldVal := aField.FMDBExternal;
        end;
        aComboBox.Items.AddObject(UpperCase(aFieldVal), TObject(StrToInt(FMListerCountry.Results[I])));
      end;
    end;
    Result := True;
  except on E: Exception do
    ShowMessageCapri('CAPRI failed to get Country list: ' + E.Message);
  end;
end;

{==============================================================================
 GetCountryName
 Input: aCountryIEN: String - Required pointer to COUNTRY CODE (#779.004) file.
 Output: Returns POSTAL NAME (#1.3) field or DESCRIPTION (#2) field
         if Postal Name is '<NULL>' on success; otherwise returns
         empty string ('').
 ==============================================================================}
function TfrmAddress.GetCountryName(aCountryIEN: String): String;
var
  aFieldVal: String;
begin
  Result := '';
  if aCountryIEN <> '' then
  begin
    FMGetsCountry.IENS := aCountryIEN;
    try
      FMGetsCountry.GetData;
      if FMGetsCountry.Results.Count > 0 then
      begin
        aFieldVal := FMGetsCountry.GetField('1.3').FMDBExternal;
        if aFieldVal = '<NULL>' then
          aFieldVal := FMGetsCountry.GetField('2').FMDBExternal;
        Result := aFieldVal;
      end;
    except on E: Exception do
      ShowMessageCapri('CAPRI failed to get Country name: ' + E.Message);
    end;
  end;
end;

function TfrmAddress.IsForeignCountry(aCountry: String): Boolean;
begin
  if (UpperCase(aCountry) = 'UNITED STATES') then
    Result := False
  else
    Result := True;
end;

procedure TfrmAddress.FMCountiesListKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = char(13) then
    ButtonCountyAcceptClick(Application);
end;

procedure TfrmAddress.FMStatesListExit(Sender: TObject);
begin
  ButtonStateAcceptClick(Application);
end;

procedure TfrmAddress.FMCountiesListExit(Sender: TObject);
begin
  ButtonCountyAcceptClick(Application);
end;

procedure TfrmAddress.FMEditCountyEnter(Sender: TObject);
begin
  FMEditZip.Setfocus;
end;

end.
